/*! For license information please see popup.js.LICENSE.txt */
!function(){var e={3174:function(e,n,t){"use strict";t.d(n,{$:function(){return r}});const r={}},2541:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,'\n\n:root {\n  --bg-color: lightgray;\n  --mg-color: #eee;\n  --fg-color: #fafafa; \n\n  --error-color: #fdd;\n  --error-text-color: #b70f0f;\n  --error-border-color: #ff6c71;\n\n  --blue-color: #dde8ff;\n  --blue-text-color: #0f1ab7;\n  --blue-border-color: #6f6cff;\n\n  --focus-color: blue; \n  --text-color: black; \n  --border-color: #aaa;\n\n  --link-color: #02a;\n\n  --code-bg-color: #eee;\n  --code-color: black; \n\n  --card-shadow: -1px 1px 3px 0px #aaa;\n  --card-border: none;\n\n  --icon-color: #777;\n  --icon-vibrant-color: #ee5454;\n\n  /* popup */\n  --control-hover-bg-color: #00000020;\n\n  --header-icon-color: #555;\n  --header-icon-muted-color: #888;\n  --header-icon-active-color: #24c;\n\n  --speed-focus-bg-color: #24a;\n  --speed-focus-text-color: white;\n\n\n  --track-color: #bbb;\n\n  --thumb-color: #888;\n  --thumb-border-color: #666;\n\n  \n  --select-red: red;\n  --select-green: green;\n}\n\n:root.darkTheme {\n  --bg-color: #111;\n  --mg-color: #181818;\n  --fg-color: #222; \n  \n  --error-color: #683131;\n  --error-text-color: #ffe0e0;\n  --error-border-color: #4d0d10;\n\n  --blue-color: #37395d;\n  --blue-text-color: #edeeff;\n  --blue-border-color: #060726;\n\n  --focus-color: yellow; \n  --text-color: white; \n  --border-color: #555;\n\n  --link-color: #fff816;\n\n  --code-bg-color: #777;\n  --code-color: white; \n\n  --card-bg-color: var(--bg-color);\n  --card-shadow: -1px 1px 3px 0px black;\n  --card-border: 1px solid #555;\n  \n  --icon-color: #888;\n  --icon-vibrant-color: #80beff;\n\n  /* popup */\n  --control-hover-bg-color: #ffffff10;\n\n  --header-icon-color: #eee;\n  --header-icon-muted-color: #eaeaea;\n  --header-icon-active-color: #8fc;\n\n  --speed-focus-bg-color: #8fc;\n  --speed-focus-text-color: black;\n\n  --thumb-color: #ddd;\n  --thumb-border-color: #eee;\n\n  --select-red: #f66;\n  --select-green: #35df35;\n}\n\nbody {\n  font-family: "IBM Plex Mono", Courier, monospace;\n  font-size: 14px; \n\n  margin: 0;\n  padding: 0;\n  background-color: var(--bg-color);\n  color: var(--text-color);\n}\n\n\n* {\n  box-sizing: border-box;\n}\n\nbutton, input, select, textarea {\n  font-size: inherit;\n  font-family: inherit;\n}\n\nbutton:focus, input:focus, select:focus, textarea:focus {\n    outline: 1px solid var(--focus-color);\n  }\n\nselect {\n  background-color: var(--fg-color); \n  color: var(--text-color); \n  border: 1px solid var(--border-color); \n}\n\nbutton, input[type="text"], textarea {\n  background-color: var(--fg-color);\n  color: var(--text-color);\n  border: 1px solid var(--border-color); \n  padding: 5px;\n}\n\nbutton:focus, input[type="text"]:focus, textarea:focus {\n    border: 1px solid var(--focus-color);\n    outline: none;\n  }\n\nbutton.error, input[type="text"].error, textarea.error {\n    background-color: var(--error-color);\n    color: var(--error-text-color);\n    border-color: var(--error-border-color);\n  }\n\nbutton.blue, input[type="text"].blue, textarea.blue {\n    background-color: var(--blue-color);\n    color: var(--blue-text-color);\n    border-color: var(--blue-border-color);\n  }\n\ninput[type="text"] {\n  min-width: 0;\n  width: 100%;\n}\n\ninput[type="text"].error {\n    background-color: var(--error-color);\n  }\n\ninput[type="text"]:disabled {\n    opacity: 0.7;\n  }\n\nbutton {\n  cursor: pointer;\n}\n\nbutton.large {\n    font-size: 1.2em;\n    padding: 7px;\n  }\n\nbutton:disabled {\n    opacity: 0.5;\n  }\n\nbutton.toggle {\n    border-style: dashed;\n    color: var(--text-color);\n  }\n\nbutton.toggle:enabled.active {\n      border-style: solid;\n      border-color: var(--text-color);\n      font-weight: bold;\n    }\n\n\na, a:visited {\n  color: var(--link-color); \n  text-decoration: none;\n}\n\n\na:hover, a:visited:hover {\n    text-decoration: underline;\n  }\n\nsvg {\n  vertical-align: middle;\n}\n\ncode {\n  padding: 2px 5px;\n  border: 1px solid currentColor;\n}\n\n.card {\n  padding: 10px;\n  background-color: var(--fg-color);\n  border: 1px solid var(--border-color);\n  color: var(--text-color);\n  display: inline-block;\n  font-size: 1.1em;\n  line-height: 2;\n}\n\n\ninput[type="checkbox"] {\n  width: 15px;\n  height: 15px;\n}\n\n.icon {\n  color: var(--icon-color);\n  padding: 0;\n  background-color: inherit;\n  border: none;\n}\n\n.icon:focus {\n    outline: 1px solid var(--focus-color);\n    border: none;\n  }\n\n.icon.muted {\n    color: var(--icon-color);\n  }\n\n.icon.active {\n    color: var(--icon-vibrant-color);\n  }\n\n.tabs {\n  display: grid;\n  grid-template-columns: 1fr 1fr;\n}\n\n.tabs > button {\n    border-radius: 5px 5px 0px 0px;\n    border: 1px solid var(--border-color);\n    border-top-width: 2px;\n    background-color: var(--mg-color);\n    opacity: 0.8;\n  }\n\n.tabs > button.open {\n      background-color: var(--fg-color);\n      border-bottom: 1px solid transparent;\n      opacity: 1;\n    }\n\n.tabs > button.active {\n      border-top: 2px solid var(--header-icon-active-color);\n    }\n\n.tabs > button:focus {\n      outline: 1px solid var(--focus-color);\n    }\n\ninput[type=range] {\n  width: 100%;\n  background-color: transparent;\n}\n\ninput[type=range]::-moz-range-track {\n  background: var(--track-color);\n  /* border: 0.2px solid var(--track-border-color); */\n  border: none;\n  /* border-radius: 5px; */\n  width: 100%;\n  height: 6px;\n  cursor: pointer;\n}\ninput[type=range]::-moz-range-thumb {\n  width: 10px;\n  height: 20px;\n  background: var(--thumb-color);\n  border: 1px solid var(--thumb-border-color-color);\n  border-radius: 0px;\n  /* border-radius: 8px; */\n  cursor: pointer;\n}\n\n\ninput[type="color"] {\n  background-color: var(--fg-color);\n  border: none;\n  width: 50px;\n  height: 30px;\n}\n\nselect.green {\n    border: 1px solid var(--select-green);\n    color: var(--select-green);\n  }\n\nselect.red {\n    border: 1px solid var(--select-red);\n    color: var(--select-red);\n  }\n\n.reset {\n  color: var(--icon-color);\n  border: 1px solid var(--icon-color);\n  padding: 2px;\n  box-sizing: content-box;\n  opacity: 0.5;\n  border-radius: 5px;\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n}\n\n.reset.active {\n    color: var(--header-icon-active-color);\n    border: 1px solid var(--header-icon-active-color);\n    opacity: 1;\n  }',""]),n.Z=o},2224:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,"/* URL paths are relative to html file. */\n\n/* ibm-plex-mono-regular - latin */\n@font-face {\n  font-family: 'IBM Plex Mono';\n  font-style: normal;\n  font-weight: 400;\n  src: local('IBM Plex Mono'), local('IBMPlexMono'),\n       url('./fonts/ibm-plex-mono-v6-latin-regular.woff2') format('woff2'), /* Chrome 26+, Opera 23+, Firefox 39+ */\n       url('./fonts/ibm-plex-mono-v6-latin-regular.woff') format('woff'); /* Chrome 6+, Firefox 3.6+, IE 9+, Safari 5.1+ */\n}\n/* ibm-plex-mono-700 - latin */\n@font-face {\n  font-family: 'IBM Plex Mono';\n  font-style: normal;\n  font-weight: 700;\n  src: local('IBM Plex Mono Bold'), local('IBMPlexMono-Bold'),\n       url('./fonts/ibm-plex-mono-v6-latin-700.woff2') format('woff2'), /* Chrome 26+, Opera 23+, Firefox 39+ */\n       url('./fonts/ibm-plex-mono-v6-latin-700.woff') format('woff'); /* Chrome 6+, Firefox 3.6+, IE 9+, Safari 5.1+ */\n}",""]),n.Z=o},1087:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,"\n.DropdownWarning {\n  background-color: var(--error-color);\n  color: var(--error-text-color);\n  border: 1px solid var(--error-border-color);\n  font-family: Arial, Helvetica, sans-serif;\n  padding: 10px;\n}\n\n  .DropdownWarning > .header {\n    display: grid;\n    grid-template-columns: max-content 1fr max-content;\n    grid-column-gap: 10px;\n    font-size: 1.1em;\n    align-items: center;\n  }\n\n  .DropdownWarning > .header > svg {\n      color: var(--error-text-color);\n    }\n\n  .DropdownWarning > .body {\n    margin-top: 10px;\n  }",""]),n.Z=o},3683:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,"\n.ErrorFallback {\n  padding: 10px;\n  background-color: var(--fg-color);\n  font-size: 1.1em;\n  border: 3px solid red;\n  margin-top: 20px;\n  min-width: 600px;\n  max-width: 800px;\n}\n\n  .ErrorFallback button {\n    display: block;\n    margin-top: 5px;\n  }\n\n  .ErrorFallback li {\n    margin-bottom: 15px;\n  }\n\n  .ErrorFallback li:last-child {\n      margin-bottom: 0;\n    }",""]),n.Z=o},3416:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,"\n.FloatTooltip {\n  position: absolute;\n  left: -80px; \n  right: -80px; \n  bottom: 40px;\n  font-size: 0.9em;\n  display: grid;\n  justify-content: center;\n}\n  \n  .FloatTooltip > div {\n    display: inline-block; \n    padding: 5px;\n    background-color: red;\n    color: white;\n  }",""]),n.Z=o},697:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,"\n\n.ModalBase {\n  position: fixed;\n  left: 0px; \n  top: 0px; \n  width: 100vw;\n  height: 100vh;\n  background-color: #00000088; \n  z-index: 9999999999;\n\n  display: grid;\n  justify-content: center;\n  align-items: center;\n}",""]),n.Z=o},5338:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,"\n.Move {\n  display: grid;\n  grid-auto-flow: row;\n}",""]),n.Z=o},8024:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,'\n.NumericControl {\n  display: grid;\n  grid-template-columns: repeat(2, 50px) 1fr repeat(2, 50px);\n  grid-column-gap: 5px;\n  align-items: stretch;\n}\n\n  .NumericControl > button {\n    font-size: 0.75em;\n  }\n\n  .NumericControl > button, .NumericControl input[type="text"] {\n    padding: none;\n    text-align: center;\n  }\n\n  .NumericControl > .NumericInput > input[type="text"] {\n    padding: 2px 0;\n  }\n\n  .NumericControl > .NumericInput {\n    font-size: 0.9em;\n  }\n\n  .NumericControl > .NumericInput > input {\n      text-align: center;\n    }',""]),n.Z=o},9695:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,'\n\n.SliderMicro {\n  background-color: var(--fg-color);\n  --label-color: var(--text-color);\n  --reset-color: var(--icon-color);\n  --font-weight: 400;\n  --opacity: 0.5;\n}\n\n  .SliderMicro.highlight {\n    --label-color: var(--header-icon-active-color);\n    --reset-color: var(--header-icon-active-color);\n    --font-weight: 600;\n    --opacity: 1;\n  }\n\n  .SliderMicro {\n\n\n  \n  display: grid;\n  grid-template-columns: 1fr max-content;\n  grid-column-gap: 5px;\n  margin-bottom: 2px;\n  align-items: center;\n}\n\n  .SliderMicro.withInput {\n    grid-template-columns: 1fr 60px max-content;\n  }\n\n  .SliderMicro.withLabel {\n    grid-template-columns: 80px 1fr max-content;\n  }\n\n  .SliderMicro.withLabel.withInput {\n    grid-template-columns: 80px 1fr 60px max-content;\n  }\n\n  .SliderMicro > input[type="range"] {\n    width: 100%;\n  }',""]),n.Z=o},7733:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,'.SliderPlus {\n  background-color: var(--fg-color);\n  --label-color: var(--text-color);\n  --reset-color: var(--icon-color);\n  --font-weight: 400;\n  --opacity: 0.5;\n}\n\n\n  .SliderPlus.highlight {\n    --label-color: var(--header-icon-active-color);\n    --reset-color: var(--header-icon-active-color);\n    --font-weight: 600;\n    --opacity: 1;\n  }\n\n\n  .SliderPlus > .header {\n    display: grid;\n    grid-template-columns: 1fr 60px max-content;\n    grid-column-gap: 5px;\n    margin-bottom: 2px;\n    align-items: center;\n  }\n\n\n  .SliderPlus > .header > span {\n      align-self: center;\n      font-weight: var(--font-weight);\n      color: var(--label-color);\n    }\n\n\n  .SliderPlus > .header > .NumericInput > input {\n      text-align: center;\n    }\n\n\n  .SliderPlus > input[type="range"] {\n    width: 100%;\n  }',""]),n.Z=o},1485:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,"\n.Tooltip {\n  display: inline-block;\n}\n  \n  .Tooltip > span {\n    -webkit-user-select: none;\n       -moz-user-select: none;\n            user-select: none;\n    padding: 0px 2px;\n    background-color: var(--fg-color);\n    color: var(--text-color);\n    border: 1px solid var(--border-color);\n  }\n  \n  .Tooltip > span:focus {\n      border-color: var(--focus-color);\n      outline: none;\n    }\n  \n  .Tooltip > .ModalBase > .fg {\n    position: fixed;\n    display: inline-block;\n    background-color: var(--fg-color);\n    color: var(--text-color);\n    padding: 10px;\n    filter: invert(1);\n  }",""]),n.Z=o},5394:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,"\n.AudioPanel {\n  font-size: 13px;\n  background-color: var(--fg-color);\n  padding-right: 20px;\n}\n\n  .AudioPanel > * {\n    margin-bottom: 10px;\n  }\n\n  .AudioPanel > .capture {\n    margin-bottom: 15px;\n    width: 100%;\n    font-size: 1.3em;\n    padding: 5px; \n    margin-top: 10px;\n    border-width: 3px;\n    background-color: var(--mg-color);\n    border-style: dashed;\n    border-radius: 5px;\n  }\n\n  .AudioPanel > .capture.active {\n      border-color: var(--focus-color);\n      border-style: solid;\n      color: var(--focus-color);\n    }\n\n  .AudioPanel > .SliderPlus {\n    margin-bottom: 20px;\n  }\n\n  /* for pitch HD button. */\n\n  .AudioPanel > .SliderPlus button.toggle {\n      padding: 0 5px;\n      font-size: 0.9em;\n    }\n\n  .AudioPanel > .SliderPlus button.toggle.active {\n        color: inherit;\n        border-color: inherit; \n      }\n\n  .AudioPanel > .mainControls {\n    margin-bottom: 30px;\n    display: grid;\n    grid-template-columns: 1fr 1fr;\n    grid-column-gap: 10px;\n  }\n\n  .AudioPanel > .mainControls button {\n      border-width: 2px;\n      border-radius: 3px;\n    }\n\n  .AudioPanel > .control {\n    display: grid;\n    grid-template-columns: 1fr max-content;\n    grid-column-gap: 10px;\n  }\n\n  .AudioPanel > .control.split {\n      margin-bottom: 30px;\n    }\n\n  .AudioPanel > .audioTab > .controls {\n      display: grid;\n      grid-template-columns: 1fr 1fr;\n      grid-column-gap: 10px;\n    }\n\n  .AudioPanel > .audioTab > .controls > button {\n        color: var(--header-icon-color); \n      }\n\n  .AudioPanel > .audioTab > .controls > button.active {\n          color: var(--header-icon-active-color);\n        }\n\n  .AudioPanel > .audioTab > .controls > button.muted {\n          color: var(--header-icon-muted-color);\n        }\n\n  .AudioPanel > .audioTab .SliderPlus {\n      margin-top: 10px;\n    }",""]),n.Z=o},3053:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,"\n.EqualizerControl {\n  margin-top: 20px;\n  padding-top: 15px;\n  border-top: 1px solid var(--text-color);\n}\n  \n  .EqualizerControl > .preset {\n    display: grid;\n    grid-template-columns: max-content 1fr;\n    grid-column-gap: 5px;\n    margin-top: 15px;\n    margin-bottom: 20px;\n    width: 100%;\n  }\n  \n  .EqualizerControl > .preset select {\n      width: inherit;\n    }",""]),n.Z=o},9317:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,"\n.Filters > .Filter {\n  display: grid;\n  grid-template-columns: max-content 1fr;\n  -moz-column-gap: 5px;\n       column-gap: 5px;\n  align-items: start;\n}\n\n  .Filters > .Filter > .Move {\n    row-gap: 5px;\n  }\n\n  .Filters > .Filter {\n\n  margin-bottom: 15px;\n}\n\n  .Filters > .Filter:last-child {\n    margin-bottom: 0;\n  }",""]),n.Z=o},1510:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,"\n.FxControl {\n  font-size: 14px;\n  background-color: var(--fg-color);\n  padding-right: 20px;\n}\n\n  .FxControl > * {\n    margin-bottom: 10px;\n  }\n\n  .FxControl > .controls {\n    display: grid;\n    grid-template-columns: 1fr 1fr 1fr;\n    grid-column-gap: 10px;\n  }\n\n  .FxControl > .controls > button {\n      color: var(--header-icon-color); \n    }\n\n  .FxControl > .controls > button.active {\n        color: var(--header-icon-active-color);\n      }\n\n  .FxControl > .controls > button.muted {\n        color: var(--header-icon-muted-color);\n      }\n\n  .FxControl > .intoPane {\n    display: block;\n    width: 100%;\n  }\n\n  .FxControl > .query {\n    margin-top: 10px;\n    display: grid;\n    grid-row-gap: 5px;\n  }\n\n  .FxControl > .origin {\n    display: grid;\n    grid-template-columns: 1fr max-content max-content;\n    grid-column-gap: 10px;\n  }",""]),n.Z=o},1617:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,"\n.Header {\n  display: grid;\n  grid-template-columns: repeat(2, max-content) 1fr repeat(4, max-content);\n  justify-items: right;\n  align-items: center;\n  padding: 3px 5px 0px 5px;\n  border-bottom: 1px solid var(--border-color);\n  background-color: var(--fg-color);\n}\n\n\n  .Header > div {\n    padding: 0 5px;\n    color: var(--header-icon-color);\n    border: none;\n    cursor: pointer;\n  }\n\n\n  .Header > div.noPadding {\n      padding: 0;\n    }\n\n\n  .Header > div:focus {\n      outline: none;\n    }\n\n\n  .Header > div:hover {\n      opacity: 0.9;\n    }\n\n\n  @keyframes beat {\n      0% {transform: scale(1)}\n      90% {transform: scale(0.8)}\n      95% {transform: scale(1.1)}\n    }\n\n\n  .Header > div.active {\n      color: var(--header-icon-active-color);\n    }\n\n\n  .Header > div.active.red {\n        color: red; \n      }\n\n\n  .Header > div.active.beat {\n        animation: 1s ease-in beat infinite;\n      }\n\n\n  .Header > div.active:hover {\n        opacity: 0.9;\n      }\n\n\n  .Header > div.muted {\n      color: var(--header-icon-muted-color);\n    }\n\n\n  .Header > div.muted:hover {\n        opacity: 0.9;\n      }\n\n\n  .Header > div > svg {\n      vertical-align: baseline;\n    }\n",""]),n.Z=o},6127:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,'.MainPanel > .volume {\n    display: grid;\n    grid-template-columns: 50px 1fr;\n    grid-column-gap: 10px;\n  }\n\n    .MainPanel > .volume input[type="text"] {\n      text-align: center;\n    }\n\n    .MainPanel > .volume > input[type="range"]:focus {\n        outline: none;\n      }',""]),n.Z=o},558:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,'\n.MediaView {\n  padding: 10px 0;\n  border-top: 1px solid var(--border-color);\n\n}\n  \n  .MediaView:nth-child(2) {\n    margin-top: 16px;\n  }\n  \n  .MediaView > .header {\n    font-size: 0.85em;\n    margin-left: 5px;\n    margin-bottom: 1px;\n  }\n  \n  .MediaView > .controls {\n    display: grid;\n    grid-template-columns: repeat(4, max-content) 1fr repeat(3, max-content);\n    align-items: center;\n    grid-column-gap: 5px;\n  }\n  \n  .MediaView > .controls > input[type="range"] {\n      min-width: 0;\n    }\n  \n  .MediaView > .controls > button {\n      background-color: transparent;\n      color: var(--header-icon-color);\n      border-color: transparent;\n    }\n  \n  .MediaView > .controls > button.active {\n        color: var(--header-icon-active-color);\n      }\n  \n  .MediaView > .controls > button.muted {\n        color: var(--header-icon-muted-color);\n      }\n  \n  .MediaView > .controls > button:hover  {\n        background-color: var(--control-hover-bg-color);\n      }\n  \n  .MediaView > .controls > button:focus {\n        border-color: 1px solid var(--focus-color);\n      }\n  \n  .MediaView > .controls > .duration {\n      font-size: 0.9em;\n      margin-right: 8px;\n      justify-self: end;\n    }',""]),n.Z=o},9017:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,"\n.Origin {\n  display: grid;\n  grid-template-columns: repeat(3, max-content);\n  grid-row-gap: 15px;\n  justify-content: space-around;\n}\n\n  .Origin > div {\n    border: 1px solid var(--border-color);\n    background-color: var(--fg-color);\n    width: 30px;\n    height: 15px;\n  }\n\n  .Origin > div.active {\n      background-color: var(--border-color);\n    }\n\n  .Origin > div:focus {\n      outline: 1px solid var(--focus-color);\n    }",""]),n.Z=o},9363:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,".ReverseButton {\n  width: 100%;\n  padding: 5px;\n  font-size: 1.3em;\n  border-width: 2px;\n  border-style: dashed;\n  border-radius: 5px;\n}\n\n  .ReverseButton:focus {\n    border-width: 2px;\n  }\n\n  .ReverseButton.recording {\n    border-color: #500;\n    border-style: solid;\n    background-color: lightcoral; \n    color: #500;\n  }\n\n  .ReverseButton.playing {\n    border-color: #172717;\n    border-style: solid;\n    background-color: lightgreen; \n    color: #172717;\n  }",""]),n.Z=o},3552:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l)()(a());o.push([e.id,'\n.SpeedControl {\n  -webkit-user-select: none;\n     -moz-user-select: none;\n          user-select: none;\n  font-family: Courier, "IBM Plex Mono", monospace;\n  font-size: 1.1em;\n  background-color: var(--fg-color);\n}  \n\n  .SpeedControl > .options {\n    display: grid; \n    grid-template-columns: repeat(3, 1fr);\n    justify-items: center;\n    grid-gap: 3px;\n  \n  }  \n\n  .SpeedControl > .options > button {\n      width: 100%;\n      text-align: center;\n      border: none;\n      padding: var(--padding) 0px;\n    }  \n\n  .SpeedControl > .options > button:focus {\n        outline: 1px solid var(--focus-color);\n      }  \n\n  .SpeedControl > .options > button.selected {\n        background-color: var(--speed-focus-bg-color);\n        color: var(--speed-focus-text-color);\n      }  \n\n  .SpeedControl > .NumericControl {\n    margin-top: 15px;\n  }  \n\n  .SpeedControl > .NumericControl button, .SpeedControl > .NumericControl input[type="text"] {\n      padding: 0;\n    }  \n\n  .SpeedControl > .slider {\n    display: grid;\n    grid-template-columns: max-content 1fr;\n    align-items: center; \n    margin-top: 15px;\n    -moz-column-gap: 5px;\n         column-gap: 5px;\n  }  \n\n  .SpeedControl > .slider > svg {\n      color: var(--header-icon-color);\n      opacity: 0.5;\n    }  \n\n  .SpeedControl > .slider > svg.active {\n        opacity: 1;\n        color: var(--header-icon-active-color);\n      }',""]),n.Z=o},4345:function(e,n,t){"use strict";var r=t(8081),a=t.n(r),l=t(3645),o=t.n(l),i=t(2224),u=t(2541),s=o()(a());s.i(i.Z),s.i(u.Z),s.push([e.id,"\nbody {\n  margin: 0;\n  padding: 0;\n  background-color: var(--fg-color);\n}\n\n#SuperDisable {\n  padding: 10px;\n  background-color: #fafafa; \n  color: #666; \n  cursor: pointer;\n}\n\n#App > .panel {\n    width: 300px;\n    padding: 8px;\n    min-height: 40px;\n  }\n\n#App > .panel > .unloaded {\n      min-height: 130px;\n    }\n",""]),n.Z=s},3645:function(e){"use strict";e.exports=function(e){var n=[];return n.toString=function(){return this.map((function(n){var t="",r=void 0!==n[5];return n[4]&&(t+="@supports (".concat(n[4],") {")),n[2]&&(t+="@media ".concat(n[2]," {")),r&&(t+="@layer".concat(n[5].length>0?" ".concat(n[5]):""," {")),t+=e(n),r&&(t+="}"),n[2]&&(t+="}"),n[4]&&(t+="}"),t})).join("")},n.i=function(e,t,r,a,l){"string"==typeof e&&(e=[[null,e,void 0]]);var o={};if(r)for(var i=0;i<this.length;i++){var u=this[i][0];null!=u&&(o[u]=!0)}for(var s=0;s<e.length;s++){var c=[].concat(e[s]);r&&o[c[0]]||(void 0!==l&&(void 0===c[5]||(c[1]="@layer".concat(c[5].length>0?" ".concat(c[5]):""," {").concat(c[1],"}")),c[5]=l),t&&(c[2]?(c[1]="@media ".concat(c[2]," {").concat(c[1],"}"),c[2]=t):c[2]=t),a&&(c[4]?(c[1]="@supports (".concat(c[4],") {").concat(c[1],"}"),c[4]=a):c[4]="".concat(a)),n.push(c))}},n}},8081:function(e){"use strict";e.exports=function(e){return e[1]}},3465:function(e,n,t){e=t.nmd(e);var r="__lodash_hash_undefined__",a=9007199254740991,l="[object Arguments]",o="[object Boolean]",i="[object Date]",u="[object Function]",s="[object GeneratorFunction]",c="[object Map]",d="[object Number]",f="[object Object]",p="[object Promise]",m="[object RegExp]",h="[object Set]",v="[object String]",g="[object Symbol]",b="[object WeakMap]",y="[object ArrayBuffer]",x="[object DataView]",w="[object Float32Array]",k="[object Float64Array]",S="[object Int8Array]",C="[object Int16Array]",E="[object Int32Array]",P="[object Uint8Array]",_="[object Uint8ClampedArray]",M="[object Uint16Array]",j="[object Uint32Array]",z=/\w*$/,N=/^\[object .+?Constructor\]$/,T=/^(?:0|[1-9]\d*)$/,F={};F[l]=F["[object Array]"]=F[y]=F[x]=F[o]=F[i]=F[w]=F[k]=F[S]=F[C]=F[E]=F[c]=F[d]=F[f]=F[m]=F[h]=F[v]=F[g]=F[P]=F[_]=F[M]=F[j]=!0,F["[object Error]"]=F[u]=F[b]=!1;var I="object"==typeof t.g&&t.g&&t.g.Object===Object&&t.g,O="object"==typeof self&&self&&self.Object===Object&&self,L=I||O||Function("return this")(),A=n&&!n.nodeType&&n,D=A&&e&&!e.nodeType&&e,R=D&&D.exports===A;function B(e,n){return e.set(n[0],n[1]),e}function $(e,n){return e.add(n),e}function U(e,n,t,r){var a=-1,l=e?e.length:0;for(r&&l&&(t=e[++a]);++a<l;)t=n(t,e[a],a,e);return t}function V(e){var n=!1;if(null!=e&&"function"!=typeof e.toString)try{n=!!(e+"")}catch(e){}return n}function H(e){var n=-1,t=Array(e.size);return e.forEach((function(e,r){t[++n]=[r,e]})),t}function Z(e,n){return function(t){return e(n(t))}}function W(e){var n=-1,t=Array(e.size);return e.forEach((function(e){t[++n]=e})),t}var q,Q=Array.prototype,K=Function.prototype,X=Object.prototype,Y=L["__core-js_shared__"],G=(q=/[^.]+$/.exec(Y&&Y.keys&&Y.keys.IE_PROTO||""))?"Symbol(src)_1."+q:"",J=K.toString,ee=X.hasOwnProperty,ne=X.toString,te=RegExp("^"+J.call(ee).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),re=R?L.Buffer:void 0,ae=L.Symbol,le=L.Uint8Array,oe=Z(Object.getPrototypeOf,Object),ie=Object.create,ue=X.propertyIsEnumerable,se=Q.splice,ce=Object.getOwnPropertySymbols,de=re?re.isBuffer:void 0,fe=Z(Object.keys,Object),pe=Le(L,"DataView"),me=Le(L,"Map"),he=Le(L,"Promise"),ve=Le(L,"Set"),ge=Le(L,"WeakMap"),be=Le(Object,"create"),ye=$e(pe),xe=$e(me),we=$e(he),ke=$e(ve),Se=$e(ge),Ce=ae?ae.prototype:void 0,Ee=Ce?Ce.valueOf:void 0;function Pe(e){var n=-1,t=e?e.length:0;for(this.clear();++n<t;){var r=e[n];this.set(r[0],r[1])}}function _e(e){var n=-1,t=e?e.length:0;for(this.clear();++n<t;){var r=e[n];this.set(r[0],r[1])}}function Me(e){var n=-1,t=e?e.length:0;for(this.clear();++n<t;){var r=e[n];this.set(r[0],r[1])}}function je(e){this.__data__=new _e(e)}function ze(e,n,t){var r=e[n];ee.call(e,n)&&Ue(r,t)&&(void 0!==t||n in e)||(e[n]=t)}function Ne(e,n){for(var t=e.length;t--;)if(Ue(e[t][0],n))return t;return-1}function Te(e,n,t,r,a,p,b){var N;if(r&&(N=p?r(e,a,p,b):r(e)),void 0!==N)return N;if(!qe(e))return e;var T=Ve(e);if(T){if(N=function(e){var n=e.length,t=e.constructor(n);return n&&"string"==typeof e[0]&&ee.call(e,"index")&&(t.index=e.index,t.input=e.input),t}(e),!n)return function(e,n){var t=-1,r=e.length;for(n||(n=Array(r));++t<r;)n[t]=e[t];return n}(e,N)}else{var I=De(e),O=I==u||I==s;if(Ze(e))return function(e,n){if(n)return e.slice();var t=new e.constructor(e.length);return e.copy(t),t}(e,n);if(I==f||I==l||O&&!p){if(V(e))return p?e:{};if(N=function(e){return"function"!=typeof e.constructor||Be(e)?{}:qe(n=oe(e))?ie(n):{};var n}(O?{}:e),!n)return function(e,n){return Ie(e,Ae(e),n)}(e,function(e,n){return e&&Ie(n,Qe(n),e)}(N,e))}else{if(!F[I])return p?e:{};N=function(e,n,t,r){var a,l=e.constructor;switch(n){case y:return Fe(e);case o:case i:return new l(+e);case x:return function(e,n){var t=n?Fe(e.buffer):e.buffer;return new e.constructor(t,e.byteOffset,e.byteLength)}(e,r);case w:case k:case S:case C:case E:case P:case _:case M:case j:return function(e,n){var t=n?Fe(e.buffer):e.buffer;return new e.constructor(t,e.byteOffset,e.length)}(e,r);case c:return function(e,n,t){return U(n?t(H(e),!0):H(e),B,new e.constructor)}(e,r,t);case d:case v:return new l(e);case m:return function(e){var n=new e.constructor(e.source,z.exec(e));return n.lastIndex=e.lastIndex,n}(e);case h:return function(e,n,t){return U(n?t(W(e),!0):W(e),$,new e.constructor)}(e,r,t);case g:return a=e,Ee?Object(Ee.call(a)):{}}}(e,I,Te,n)}}b||(b=new je);var L=b.get(e);if(L)return L;if(b.set(e,N),!T)var A=t?function(e){return function(e,n,t){var r=n(e);return Ve(e)?r:function(e,n){for(var t=-1,r=n.length,a=e.length;++t<r;)e[a+t]=n[t];return e}(r,t(e))}(e,Qe,Ae)}(e):Qe(e);return function(e,n){for(var t=-1,r=e?e.length:0;++t<r&&!1!==n(e[t],t););}(A||e,(function(a,l){A&&(a=e[l=a]),ze(N,l,Te(a,n,t,r,l,e,b))})),N}function Fe(e){var n=new e.constructor(e.byteLength);return new le(n).set(new le(e)),n}function Ie(e,n,t,r){t||(t={});for(var a=-1,l=n.length;++a<l;){var o=n[a],i=r?r(t[o],e[o],o,t,e):void 0;ze(t,o,void 0===i?e[o]:i)}return t}function Oe(e,n){var t,r,a=e.__data__;return("string"==(r=typeof(t=n))||"number"==r||"symbol"==r||"boolean"==r?"__proto__"!==t:null===t)?a["string"==typeof n?"string":"hash"]:a.map}function Le(e,n){var t=function(e,n){return null==e?void 0:e[n]}(e,n);return function(e){return!(!qe(e)||(n=e,G&&G in n))&&(We(e)||V(e)?te:N).test($e(e));var n}(t)?t:void 0}Pe.prototype.clear=function(){this.__data__=be?be(null):{}},Pe.prototype.delete=function(e){return this.has(e)&&delete this.__data__[e]},Pe.prototype.get=function(e){var n=this.__data__;if(be){var t=n[e];return t===r?void 0:t}return ee.call(n,e)?n[e]:void 0},Pe.prototype.has=function(e){var n=this.__data__;return be?void 0!==n[e]:ee.call(n,e)},Pe.prototype.set=function(e,n){return this.__data__[e]=be&&void 0===n?r:n,this},_e.prototype.clear=function(){this.__data__=[]},_e.prototype.delete=function(e){var n=this.__data__,t=Ne(n,e);return!(t<0||(t==n.length-1?n.pop():se.call(n,t,1),0))},_e.prototype.get=function(e){var n=this.__data__,t=Ne(n,e);return t<0?void 0:n[t][1]},_e.prototype.has=function(e){return Ne(this.__data__,e)>-1},_e.prototype.set=function(e,n){var t=this.__data__,r=Ne(t,e);return r<0?t.push([e,n]):t[r][1]=n,this},Me.prototype.clear=function(){this.__data__={hash:new Pe,map:new(me||_e),string:new Pe}},Me.prototype.delete=function(e){return Oe(this,e).delete(e)},Me.prototype.get=function(e){return Oe(this,e).get(e)},Me.prototype.has=function(e){return Oe(this,e).has(e)},Me.prototype.set=function(e,n){return Oe(this,e).set(e,n),this},je.prototype.clear=function(){this.__data__=new _e},je.prototype.delete=function(e){return this.__data__.delete(e)},je.prototype.get=function(e){return this.__data__.get(e)},je.prototype.has=function(e){return this.__data__.has(e)},je.prototype.set=function(e,n){var t=this.__data__;if(t instanceof _e){var r=t.__data__;if(!me||r.length<199)return r.push([e,n]),this;t=this.__data__=new Me(r)}return t.set(e,n),this};var Ae=ce?Z(ce,Object):function(){return[]},De=function(e){return ne.call(e)};function Re(e,n){return!!(n=null==n?a:n)&&("number"==typeof e||T.test(e))&&e>-1&&e%1==0&&e<n}function Be(e){var n=e&&e.constructor;return e===("function"==typeof n&&n.prototype||X)}function $e(e){if(null!=e){try{return J.call(e)}catch(e){}try{return e+""}catch(e){}}return""}function Ue(e,n){return e===n||e!=e&&n!=n}(pe&&De(new pe(new ArrayBuffer(1)))!=x||me&&De(new me)!=c||he&&De(he.resolve())!=p||ve&&De(new ve)!=h||ge&&De(new ge)!=b)&&(De=function(e){var n=ne.call(e),t=n==f?e.constructor:void 0,r=t?$e(t):void 0;if(r)switch(r){case ye:return x;case xe:return c;case we:return p;case ke:return h;case Se:return b}return n});var Ve=Array.isArray;function He(e){return null!=e&&function(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=a}(e.length)&&!We(e)}var Ze=de||function(){return!1};function We(e){var n=qe(e)?ne.call(e):"";return n==u||n==s}function qe(e){var n=typeof e;return!!e&&("object"==n||"function"==n)}function Qe(e){return He(e)?function(e,n){var t=Ve(e)||function(e){return function(e){return function(e){return!!e&&"object"==typeof e}(e)&&He(e)}(e)&&ee.call(e,"callee")&&(!ue.call(e,"callee")||ne.call(e)==l)}(e)?function(e,n){for(var t=-1,r=Array(e);++t<e;)r[t]=n(t);return r}(e.length,String):[],r=t.length,a=!!r;for(var o in e)!n&&!ee.call(e,o)||a&&("length"==o||Re(o,r))||t.push(o);return t}(e):function(e){if(!Be(e))return fe(e);var n=[];for(var t in Object(e))ee.call(e,t)&&"constructor"!=t&&n.push(t);return n}(e)}e.exports=function(e){return Te(e,!0,!0)}},1296:function(e,n,t){var r=/^\s+|\s+$/g,a=/^[-+]0x[0-9a-f]+$/i,l=/^0b[01]+$/i,o=/^0o[0-7]+$/i,i=parseInt,u="object"==typeof t.g&&t.g&&t.g.Object===Object&&t.g,s="object"==typeof self&&self&&self.Object===Object&&self,c=u||s||Function("return this")(),d=Object.prototype.toString,f=Math.max,p=Math.min,m=function(){return c.Date.now()};function h(e){var n=typeof e;return!!e&&("object"==n||"function"==n)}function v(e){if("number"==typeof e)return e;if(function(e){return"symbol"==typeof e||function(e){return!!e&&"object"==typeof e}(e)&&"[object Symbol]"==d.call(e)}(e))return NaN;if(h(e)){var n="function"==typeof e.valueOf?e.valueOf():e;e=h(n)?n+"":n}if("string"!=typeof e)return 0===e?e:+e;e=e.replace(r,"");var t=l.test(e);return t||o.test(e)?i(e.slice(2),t?2:8):a.test(e)?NaN:+e}e.exports=function(e,n,t){var r,a,l,o,i,u,s=0,c=!1,d=!1,g=!0;if("function"!=typeof e)throw new TypeError("Expected a function");function b(n){var t=r,l=a;return r=a=void 0,s=n,o=e.apply(l,t)}function y(e){var t=e-u;return void 0===u||t>=n||t<0||d&&e-s>=l}function x(){var e=m();if(y(e))return w(e);i=setTimeout(x,function(e){var t=n-(e-u);return d?p(t,l-(e-s)):t}(e))}function w(e){return i=void 0,g&&r?b(e):(r=a=void 0,o)}function k(){var e=m(),t=y(e);if(r=arguments,a=this,u=e,t){if(void 0===i)return function(e){return s=e,i=setTimeout(x,n),c?b(e):o}(u);if(d)return i=setTimeout(x,n),b(u)}return void 0===i&&(i=setTimeout(x,n)),o}return n=v(n)||0,h(t)&&(c=!!t.leading,l=(d="maxWait"in t)?f(v(t.maxWait)||0,n):l,g="trailing"in t?!!t.trailing:g),k.cancel=function(){void 0!==i&&clearTimeout(i),s=0,r=u=a=i=void 0},k.flush=function(){return void 0===i?o:w(m())},k}},4448:function(e,n,t){"use strict";var r=t(7294),a=t(3840);function l(e){for(var n="https://reactjs.org/docs/error-decoder.html?invariant="+e,t=1;t<arguments.length;t++)n+="&args[]="+encodeURIComponent(arguments[t]);return"Minified React error #"+e+"; visit "+n+" for the full message or use the non-minified dev environment for full errors and additional helpful warnings."}var o=new Set,i={};function u(e,n){s(e,n),s(e+"Capture",n)}function s(e,n){for(i[e]=n,e=0;e<n.length;e++)o.add(n[e])}var c=!("undefined"==typeof window||void 0===window.document||void 0===window.document.createElement),d=Object.prototype.hasOwnProperty,f=/^[:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD][:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\-.0-9\u00B7\u0300-\u036F\u203F-\u2040]*$/,p={},m={};function h(e,n,t,r,a,l,o){this.acceptsBooleans=2===n||3===n||4===n,this.attributeName=r,this.attributeNamespace=a,this.mustUseProperty=t,this.propertyName=e,this.type=n,this.sanitizeURL=l,this.removeEmptyString=o}var v={};"children dangerouslySetInnerHTML defaultValue defaultChecked innerHTML suppressContentEditableWarning suppressHydrationWarning style".split(" ").forEach((function(e){v[e]=new h(e,0,!1,e,null,!1,!1)})),[["acceptCharset","accept-charset"],["className","class"],["htmlFor","for"],["httpEquiv","http-equiv"]].forEach((function(e){var n=e[0];v[n]=new h(n,1,!1,e[1],null,!1,!1)})),["contentEditable","draggable","spellCheck","value"].forEach((function(e){v[e]=new h(e,2,!1,e.toLowerCase(),null,!1,!1)})),["autoReverse","externalResourcesRequired","focusable","preserveAlpha"].forEach((function(e){v[e]=new h(e,2,!1,e,null,!1,!1)})),"allowFullScreen async autoFocus autoPlay controls default defer disabled disablePictureInPicture disableRemotePlayback formNoValidate hidden loop noModule noValidate open playsInline readOnly required reversed scoped seamless itemScope".split(" ").forEach((function(e){v[e]=new h(e,3,!1,e.toLowerCase(),null,!1,!1)})),["checked","multiple","muted","selected"].forEach((function(e){v[e]=new h(e,3,!0,e,null,!1,!1)})),["capture","download"].forEach((function(e){v[e]=new h(e,4,!1,e,null,!1,!1)})),["cols","rows","size","span"].forEach((function(e){v[e]=new h(e,6,!1,e,null,!1,!1)})),["rowSpan","start"].forEach((function(e){v[e]=new h(e,5,!1,e.toLowerCase(),null,!1,!1)}));var g=/[\-:]([a-z])/g;function b(e){return e[1].toUpperCase()}function y(e,n,t,r){var a=v.hasOwnProperty(n)?v[n]:null;(null!==a?0!==a.type:r||!(2<n.length)||"o"!==n[0]&&"O"!==n[0]||"n"!==n[1]&&"N"!==n[1])&&(function(e,n,t,r){if(null==n||function(e,n,t,r){if(null!==t&&0===t.type)return!1;switch(typeof n){case"function":case"symbol":return!0;case"boolean":return!r&&(null!==t?!t.acceptsBooleans:"data-"!==(e=e.toLowerCase().slice(0,5))&&"aria-"!==e);default:return!1}}(e,n,t,r))return!0;if(r)return!1;if(null!==t)switch(t.type){case 3:return!n;case 4:return!1===n;case 5:return isNaN(n);case 6:return isNaN(n)||1>n}return!1}(n,t,a,r)&&(t=null),r||null===a?function(e){return!!d.call(m,e)||!d.call(p,e)&&(f.test(e)?m[e]=!0:(p[e]=!0,!1))}(n)&&(null===t?e.removeAttribute(n):e.setAttribute(n,""+t)):a.mustUseProperty?e[a.propertyName]=null===t?3!==a.type&&"":t:(n=a.attributeName,r=a.attributeNamespace,null===t?e.removeAttribute(n):(t=3===(a=a.type)||4===a&&!0===t?"":""+t,r?e.setAttributeNS(r,n,t):e.setAttribute(n,t))))}"accent-height alignment-baseline arabic-form baseline-shift cap-height clip-path clip-rule color-interpolation color-interpolation-filters color-profile color-rendering dominant-baseline enable-background fill-opacity fill-rule flood-color flood-opacity font-family font-size font-size-adjust font-stretch font-style font-variant font-weight glyph-name glyph-orientation-horizontal glyph-orientation-vertical horiz-adv-x horiz-origin-x image-rendering letter-spacing lighting-color marker-end marker-mid marker-start overline-position overline-thickness paint-order panose-1 pointer-events rendering-intent shape-rendering stop-color stop-opacity strikethrough-position strikethrough-thickness stroke-dasharray stroke-dashoffset stroke-linecap stroke-linejoin stroke-miterlimit stroke-opacity stroke-width text-anchor text-decoration text-rendering underline-position underline-thickness unicode-bidi unicode-range units-per-em v-alphabetic v-hanging v-ideographic v-mathematical vector-effect vert-adv-y vert-origin-x vert-origin-y word-spacing writing-mode xmlns:xlink x-height".split(" ").forEach((function(e){var n=e.replace(g,b);v[n]=new h(n,1,!1,e,null,!1,!1)})),"xlink:actuate xlink:arcrole xlink:role xlink:show xlink:title xlink:type".split(" ").forEach((function(e){var n=e.replace(g,b);v[n]=new h(n,1,!1,e,"http://www.w3.org/1999/xlink",!1,!1)})),["xml:base","xml:lang","xml:space"].forEach((function(e){var n=e.replace(g,b);v[n]=new h(n,1,!1,e,"http://www.w3.org/XML/1998/namespace",!1,!1)})),["tabIndex","crossOrigin"].forEach((function(e){v[e]=new h(e,1,!1,e.toLowerCase(),null,!1,!1)})),v.xlinkHref=new h("xlinkHref",1,!1,"xlink:href","http://www.w3.org/1999/xlink",!0,!1),["src","href","action","formAction"].forEach((function(e){v[e]=new h(e,1,!1,e.toLowerCase(),null,!0,!0)}));var x=r.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED,w=Symbol.for("react.element"),k=Symbol.for("react.portal"),S=Symbol.for("react.fragment"),C=Symbol.for("react.strict_mode"),E=Symbol.for("react.profiler"),P=Symbol.for("react.provider"),_=Symbol.for("react.context"),M=Symbol.for("react.forward_ref"),j=Symbol.for("react.suspense"),z=Symbol.for("react.suspense_list"),N=Symbol.for("react.memo"),T=Symbol.for("react.lazy");Symbol.for("react.scope"),Symbol.for("react.debug_trace_mode");var F=Symbol.for("react.offscreen");Symbol.for("react.legacy_hidden"),Symbol.for("react.cache"),Symbol.for("react.tracing_marker");var I=Symbol.iterator;function O(e){return null===e||"object"!=typeof e?null:"function"==typeof(e=I&&e[I]||e["@@iterator"])?e:null}var L,A=Object.assign;function D(e){if(void 0===L)try{throw Error()}catch(e){var n=e.stack.trim().match(/\n( *(at )?)/);L=n&&n[1]||""}return"\n"+L+e}var R=!1;function B(e,n){if(!e||R)return"";R=!0;var t=Error.prepareStackTrace;Error.prepareStackTrace=void 0;try{if(n)if(n=function(){throw Error()},Object.defineProperty(n.prototype,"props",{set:function(){throw Error()}}),"object"==typeof Reflect&&Reflect.construct){try{Reflect.construct(n,[])}catch(e){var r=e}Reflect.construct(e,[],n)}else{try{n.call()}catch(e){r=e}e.call(n.prototype)}else{try{throw Error()}catch(e){r=e}e()}}catch(n){if(n&&r&&"string"==typeof n.stack){for(var a=n.stack.split("\n"),l=r.stack.split("\n"),o=a.length-1,i=l.length-1;1<=o&&0<=i&&a[o]!==l[i];)i--;for(;1<=o&&0<=i;o--,i--)if(a[o]!==l[i]){if(1!==o||1!==i)do{if(o--,0>--i||a[o]!==l[i]){var u="\n"+a[o].replace(" at new "," at ");return e.displayName&&u.includes("<anonymous>")&&(u=u.replace("<anonymous>",e.displayName)),u}}while(1<=o&&0<=i);break}}}finally{R=!1,Error.prepareStackTrace=t}return(e=e?e.displayName||e.name:"")?D(e):""}function $(e){switch(e.tag){case 5:return D(e.type);case 16:return D("Lazy");case 13:return D("Suspense");case 19:return D("SuspenseList");case 0:case 2:case 15:return B(e.type,!1);case 11:return B(e.type.render,!1);case 1:return B(e.type,!0);default:return""}}function U(e){if(null==e)return null;if("function"==typeof e)return e.displayName||e.name||null;if("string"==typeof e)return e;switch(e){case S:return"Fragment";case k:return"Portal";case E:return"Profiler";case C:return"StrictMode";case j:return"Suspense";case z:return"SuspenseList"}if("object"==typeof e)switch(e.$$typeof){case _:return(e.displayName||"Context")+".Consumer";case P:return(e._context.displayName||"Context")+".Provider";case M:var n=e.render;return(e=e.displayName)||(e=""!==(e=n.displayName||n.name||"")?"ForwardRef("+e+")":"ForwardRef"),e;case N:return null!==(n=e.displayName||null)?n:U(e.type)||"Memo";case T:n=e._payload,e=e._init;try{return U(e(n))}catch(e){}}return null}function V(e){var n=e.type;switch(e.tag){case 24:return"Cache";case 9:return(n.displayName||"Context")+".Consumer";case 10:return(n._context.displayName||"Context")+".Provider";case 18:return"DehydratedFragment";case 11:return e=(e=n.render).displayName||e.name||"",n.displayName||(""!==e?"ForwardRef("+e+")":"ForwardRef");case 7:return"Fragment";case 5:return n;case 4:return"Portal";case 3:return"Root";case 6:return"Text";case 16:return U(n);case 8:return n===C?"StrictMode":"Mode";case 22:return"Offscreen";case 12:return"Profiler";case 21:return"Scope";case 13:return"Suspense";case 19:return"SuspenseList";case 25:return"TracingMarker";case 1:case 0:case 17:case 2:case 14:case 15:if("function"==typeof n)return n.displayName||n.name||null;if("string"==typeof n)return n}return null}function H(e){switch(typeof e){case"boolean":case"number":case"string":case"undefined":case"object":return e;default:return""}}function Z(e){var n=e.type;return(e=e.nodeName)&&"input"===e.toLowerCase()&&("checkbox"===n||"radio"===n)}function W(e){e._valueTracker||(e._valueTracker=function(e){var n=Z(e)?"checked":"value",t=Object.getOwnPropertyDescriptor(e.constructor.prototype,n),r=""+e[n];if(!e.hasOwnProperty(n)&&void 0!==t&&"function"==typeof t.get&&"function"==typeof t.set){var a=t.get,l=t.set;return Object.defineProperty(e,n,{configurable:!0,get:function(){return a.call(this)},set:function(e){r=""+e,l.call(this,e)}}),Object.defineProperty(e,n,{enumerable:t.enumerable}),{getValue:function(){return r},setValue:function(e){r=""+e},stopTracking:function(){e._valueTracker=null,delete e[n]}}}}(e))}function q(e){if(!e)return!1;var n=e._valueTracker;if(!n)return!0;var t=n.getValue(),r="";return e&&(r=Z(e)?e.checked?"true":"false":e.value),(e=r)!==t&&(n.setValue(e),!0)}function Q(e){if(void 0===(e=e||("undefined"!=typeof document?document:void 0)))return null;try{return e.activeElement||e.body}catch(n){return e.body}}function K(e,n){var t=n.checked;return A({},n,{defaultChecked:void 0,defaultValue:void 0,value:void 0,checked:null!=t?t:e._wrapperState.initialChecked})}function X(e,n){var t=null==n.defaultValue?"":n.defaultValue,r=null!=n.checked?n.checked:n.defaultChecked;t=H(null!=n.value?n.value:t),e._wrapperState={initialChecked:r,initialValue:t,controlled:"checkbox"===n.type||"radio"===n.type?null!=n.checked:null!=n.value}}function Y(e,n){null!=(n=n.checked)&&y(e,"checked",n,!1)}function G(e,n){Y(e,n);var t=H(n.value),r=n.type;if(null!=t)"number"===r?(0===t&&""===e.value||e.value!=t)&&(e.value=""+t):e.value!==""+t&&(e.value=""+t);else if("submit"===r||"reset"===r)return void e.removeAttribute("value");n.hasOwnProperty("value")?ee(e,n.type,t):n.hasOwnProperty("defaultValue")&&ee(e,n.type,H(n.defaultValue)),null==n.checked&&null!=n.defaultChecked&&(e.defaultChecked=!!n.defaultChecked)}function J(e,n,t){if(n.hasOwnProperty("value")||n.hasOwnProperty("defaultValue")){var r=n.type;if(!("submit"!==r&&"reset"!==r||void 0!==n.value&&null!==n.value))return;n=""+e._wrapperState.initialValue,t||n===e.value||(e.value=n),e.defaultValue=n}""!==(t=e.name)&&(e.name=""),e.defaultChecked=!!e._wrapperState.initialChecked,""!==t&&(e.name=t)}function ee(e,n,t){"number"===n&&Q(e.ownerDocument)===e||(null==t?e.defaultValue=""+e._wrapperState.initialValue:e.defaultValue!==""+t&&(e.defaultValue=""+t))}var ne=Array.isArray;function te(e,n,t,r){if(e=e.options,n){n={};for(var a=0;a<t.length;a++)n["$"+t[a]]=!0;for(t=0;t<e.length;t++)a=n.hasOwnProperty("$"+e[t].value),e[t].selected!==a&&(e[t].selected=a),a&&r&&(e[t].defaultSelected=!0)}else{for(t=""+H(t),n=null,a=0;a<e.length;a++){if(e[a].value===t)return e[a].selected=!0,void(r&&(e[a].defaultSelected=!0));null!==n||e[a].disabled||(n=e[a])}null!==n&&(n.selected=!0)}}function re(e,n){if(null!=n.dangerouslySetInnerHTML)throw Error(l(91));return A({},n,{value:void 0,defaultValue:void 0,children:""+e._wrapperState.initialValue})}function ae(e,n){var t=n.value;if(null==t){if(t=n.children,n=n.defaultValue,null!=t){if(null!=n)throw Error(l(92));if(ne(t)){if(1<t.length)throw Error(l(93));t=t[0]}n=t}null==n&&(n=""),t=n}e._wrapperState={initialValue:H(t)}}function le(e,n){var t=H(n.value),r=H(n.defaultValue);null!=t&&((t=""+t)!==e.value&&(e.value=t),null==n.defaultValue&&e.defaultValue!==t&&(e.defaultValue=t)),null!=r&&(e.defaultValue=""+r)}function oe(e){var n=e.textContent;n===e._wrapperState.initialValue&&""!==n&&null!==n&&(e.value=n)}function ie(e){switch(e){case"svg":return"http://www.w3.org/2000/svg";case"math":return"http://www.w3.org/1998/Math/MathML";default:return"http://www.w3.org/1999/xhtml"}}function ue(e,n){return null==e||"http://www.w3.org/1999/xhtml"===e?ie(n):"http://www.w3.org/2000/svg"===e&&"foreignObject"===n?"http://www.w3.org/1999/xhtml":e}var se,ce,de=(ce=function(e,n){if("http://www.w3.org/2000/svg"!==e.namespaceURI||"innerHTML"in e)e.innerHTML=n;else{for((se=se||document.createElement("div")).innerHTML="<svg>"+n.valueOf().toString()+"</svg>",n=se.firstChild;e.firstChild;)e.removeChild(e.firstChild);for(;n.firstChild;)e.appendChild(n.firstChild)}},"undefined"!=typeof MSApp&&MSApp.execUnsafeLocalFunction?function(e,n,t,r){MSApp.execUnsafeLocalFunction((function(){return ce(e,n)}))}:ce);function fe(e,n){if(n){var t=e.firstChild;if(t&&t===e.lastChild&&3===t.nodeType)return void(t.nodeValue=n)}e.textContent=n}var pe={animationIterationCount:!0,aspectRatio:!0,borderImageOutset:!0,borderImageSlice:!0,borderImageWidth:!0,boxFlex:!0,boxFlexGroup:!0,boxOrdinalGroup:!0,columnCount:!0,columns:!0,flex:!0,flexGrow:!0,flexPositive:!0,flexShrink:!0,flexNegative:!0,flexOrder:!0,gridArea:!0,gridRow:!0,gridRowEnd:!0,gridRowSpan:!0,gridRowStart:!0,gridColumn:!0,gridColumnEnd:!0,gridColumnSpan:!0,gridColumnStart:!0,fontWeight:!0,lineClamp:!0,lineHeight:!0,opacity:!0,order:!0,orphans:!0,tabSize:!0,widows:!0,zIndex:!0,zoom:!0,fillOpacity:!0,floodOpacity:!0,stopOpacity:!0,strokeDasharray:!0,strokeDashoffset:!0,strokeMiterlimit:!0,strokeOpacity:!0,strokeWidth:!0},me=["Webkit","ms","Moz","O"];function he(e,n,t){return null==n||"boolean"==typeof n||""===n?"":t||"number"!=typeof n||0===n||pe.hasOwnProperty(e)&&pe[e]?(""+n).trim():n+"px"}function ve(e,n){for(var t in e=e.style,n)if(n.hasOwnProperty(t)){var r=0===t.indexOf("--"),a=he(t,n[t],r);"float"===t&&(t="cssFloat"),r?e.setProperty(t,a):e[t]=a}}Object.keys(pe).forEach((function(e){me.forEach((function(n){n=n+e.charAt(0).toUpperCase()+e.substring(1),pe[n]=pe[e]}))}));var ge=A({menuitem:!0},{area:!0,base:!0,br:!0,col:!0,embed:!0,hr:!0,img:!0,input:!0,keygen:!0,link:!0,meta:!0,param:!0,source:!0,track:!0,wbr:!0});function be(e,n){if(n){if(ge[e]&&(null!=n.children||null!=n.dangerouslySetInnerHTML))throw Error(l(137,e));if(null!=n.dangerouslySetInnerHTML){if(null!=n.children)throw Error(l(60));if("object"!=typeof n.dangerouslySetInnerHTML||!("__html"in n.dangerouslySetInnerHTML))throw Error(l(61))}if(null!=n.style&&"object"!=typeof n.style)throw Error(l(62))}}function ye(e,n){if(-1===e.indexOf("-"))return"string"==typeof n.is;switch(e){case"annotation-xml":case"color-profile":case"font-face":case"font-face-src":case"font-face-uri":case"font-face-format":case"font-face-name":case"missing-glyph":return!1;default:return!0}}var xe=null;function we(e){return(e=e.target||e.srcElement||window).correspondingUseElement&&(e=e.correspondingUseElement),3===e.nodeType?e.parentNode:e}var ke=null,Se=null,Ce=null;function Ee(e){if(e=ya(e)){if("function"!=typeof ke)throw Error(l(280));var n=e.stateNode;n&&(n=wa(n),ke(e.stateNode,e.type,n))}}function Pe(e){Se?Ce?Ce.push(e):Ce=[e]:Se=e}function _e(){if(Se){var e=Se,n=Ce;if(Ce=Se=null,Ee(e),n)for(e=0;e<n.length;e++)Ee(n[e])}}function Me(e,n){return e(n)}function je(){}var ze=!1;function Ne(e,n,t){if(ze)return e(n,t);ze=!0;try{return Me(e,n,t)}finally{ze=!1,(null!==Se||null!==Ce)&&(je(),_e())}}function Te(e,n){var t=e.stateNode;if(null===t)return null;var r=wa(t);if(null===r)return null;t=r[n];e:switch(n){case"onClick":case"onClickCapture":case"onDoubleClick":case"onDoubleClickCapture":case"onMouseDown":case"onMouseDownCapture":case"onMouseMove":case"onMouseMoveCapture":case"onMouseUp":case"onMouseUpCapture":case"onMouseEnter":(r=!r.disabled)||(r=!("button"===(e=e.type)||"input"===e||"select"===e||"textarea"===e)),e=!r;break e;default:e=!1}if(e)return null;if(t&&"function"!=typeof t)throw Error(l(231,n,typeof t));return t}var Fe=!1;if(c)try{var Ie={};Object.defineProperty(Ie,"passive",{get:function(){Fe=!0}}),window.addEventListener("test",Ie,Ie),window.removeEventListener("test",Ie,Ie)}catch(ce){Fe=!1}function Oe(e,n,t,r,a,l,o,i,u){var s=Array.prototype.slice.call(arguments,3);try{n.apply(t,s)}catch(e){this.onError(e)}}var Le=!1,Ae=null,De=!1,Re=null,Be={onError:function(e){Le=!0,Ae=e}};function $e(e,n,t,r,a,l,o,i,u){Le=!1,Ae=null,Oe.apply(Be,arguments)}function Ue(e){var n=e,t=e;if(e.alternate)for(;n.return;)n=n.return;else{e=n;do{0!=(4098&(n=e).flags)&&(t=n.return),e=n.return}while(e)}return 3===n.tag?t:null}function Ve(e){if(13===e.tag){var n=e.memoizedState;if(null===n&&null!==(e=e.alternate)&&(n=e.memoizedState),null!==n)return n.dehydrated}return null}function He(e){if(Ue(e)!==e)throw Error(l(188))}function Ze(e){return null!==(e=function(e){var n=e.alternate;if(!n){if(null===(n=Ue(e)))throw Error(l(188));return n!==e?null:e}for(var t=e,r=n;;){var a=t.return;if(null===a)break;var o=a.alternate;if(null===o){if(null!==(r=a.return)){t=r;continue}break}if(a.child===o.child){for(o=a.child;o;){if(o===t)return He(a),e;if(o===r)return He(a),n;o=o.sibling}throw Error(l(188))}if(t.return!==r.return)t=a,r=o;else{for(var i=!1,u=a.child;u;){if(u===t){i=!0,t=a,r=o;break}if(u===r){i=!0,r=a,t=o;break}u=u.sibling}if(!i){for(u=o.child;u;){if(u===t){i=!0,t=o,r=a;break}if(u===r){i=!0,r=o,t=a;break}u=u.sibling}if(!i)throw Error(l(189))}}if(t.alternate!==r)throw Error(l(190))}if(3!==t.tag)throw Error(l(188));return t.stateNode.current===t?e:n}(e))?We(e):null}function We(e){if(5===e.tag||6===e.tag)return e;for(e=e.child;null!==e;){var n=We(e);if(null!==n)return n;e=e.sibling}return null}var qe=a.unstable_scheduleCallback,Qe=a.unstable_cancelCallback,Ke=a.unstable_shouldYield,Xe=a.unstable_requestPaint,Ye=a.unstable_now,Ge=a.unstable_getCurrentPriorityLevel,Je=a.unstable_ImmediatePriority,en=a.unstable_UserBlockingPriority,nn=a.unstable_NormalPriority,tn=a.unstable_LowPriority,rn=a.unstable_IdlePriority,an=null,ln=null,on=Math.clz32?Math.clz32:function(e){return 0===(e>>>=0)?32:31-(un(e)/sn|0)|0},un=Math.log,sn=Math.LN2,cn=64,dn=4194304;function fn(e){switch(e&-e){case 1:return 1;case 2:return 2;case 4:return 4;case 8:return 8;case 16:return 16;case 32:return 32;case 64:case 128:case 256:case 512:case 1024:case 2048:case 4096:case 8192:case 16384:case 32768:case 65536:case 131072:case 262144:case 524288:case 1048576:case 2097152:return 4194240&e;case 4194304:case 8388608:case 16777216:case 33554432:case 67108864:return 130023424&e;case 134217728:return 134217728;case 268435456:return 268435456;case 536870912:return 536870912;case 1073741824:return 1073741824;default:return e}}function pn(e,n){var t=e.pendingLanes;if(0===t)return 0;var r=0,a=e.suspendedLanes,l=e.pingedLanes,o=268435455&t;if(0!==o){var i=o&~a;0!==i?r=fn(i):0!=(l&=o)&&(r=fn(l))}else 0!=(o=t&~a)?r=fn(o):0!==l&&(r=fn(l));if(0===r)return 0;if(0!==n&&n!==r&&0==(n&a)&&((a=r&-r)>=(l=n&-n)||16===a&&0!=(4194240&l)))return n;if(0!=(4&r)&&(r|=16&t),0!==(n=e.entangledLanes))for(e=e.entanglements,n&=r;0<n;)a=1<<(t=31-on(n)),r|=e[t],n&=~a;return r}function mn(e,n){switch(e){case 1:case 2:case 4:return n+250;case 8:case 16:case 32:case 64:case 128:case 256:case 512:case 1024:case 2048:case 4096:case 8192:case 16384:case 32768:case 65536:case 131072:case 262144:case 524288:case 1048576:case 2097152:return n+5e3;default:return-1}}function hn(e){return 0!=(e=-1073741825&e.pendingLanes)?e:1073741824&e?1073741824:0}function vn(){var e=cn;return 0==(4194240&(cn<<=1))&&(cn=64),e}function gn(e){for(var n=[],t=0;31>t;t++)n.push(e);return n}function bn(e,n,t){e.pendingLanes|=n,536870912!==n&&(e.suspendedLanes=0,e.pingedLanes=0),(e=e.eventTimes)[n=31-on(n)]=t}function yn(e,n){var t=e.entangledLanes|=n;for(e=e.entanglements;t;){var r=31-on(t),a=1<<r;a&n|e[r]&n&&(e[r]|=n),t&=~a}}var xn=0;function wn(e){return 1<(e&=-e)?4<e?0!=(268435455&e)?16:536870912:4:1}var kn,Sn,Cn,En,Pn,_n=!1,Mn=[],jn=null,zn=null,Nn=null,Tn=new Map,Fn=new Map,In=[],On="mousedown mouseup touchcancel touchend touchstart auxclick dblclick pointercancel pointerdown pointerup dragend dragstart drop compositionend compositionstart keydown keypress keyup input textInput copy cut paste click change contextmenu reset submit".split(" ");function Ln(e,n){switch(e){case"focusin":case"focusout":jn=null;break;case"dragenter":case"dragleave":zn=null;break;case"mouseover":case"mouseout":Nn=null;break;case"pointerover":case"pointerout":Tn.delete(n.pointerId);break;case"gotpointercapture":case"lostpointercapture":Fn.delete(n.pointerId)}}function An(e,n,t,r,a,l){return null===e||e.nativeEvent!==l?(e={blockedOn:n,domEventName:t,eventSystemFlags:r,nativeEvent:l,targetContainers:[a]},null!==n&&null!==(n=ya(n))&&Sn(n),e):(e.eventSystemFlags|=r,n=e.targetContainers,null!==a&&-1===n.indexOf(a)&&n.push(a),e)}function Dn(e){var n=ba(e.target);if(null!==n){var t=Ue(n);if(null!==t)if(13===(n=t.tag)){if(null!==(n=Ve(t)))return e.blockedOn=n,void Pn(e.priority,(function(){Cn(t)}))}else if(3===n&&t.stateNode.current.memoizedState.isDehydrated)return void(e.blockedOn=3===t.tag?t.stateNode.containerInfo:null)}e.blockedOn=null}function Rn(e){if(null!==e.blockedOn)return!1;for(var n=e.targetContainers;0<n.length;){var t=Xn(e.domEventName,e.eventSystemFlags,n[0],e.nativeEvent);if(null!==t)return null!==(n=ya(t))&&Sn(n),e.blockedOn=t,!1;var r=new(t=e.nativeEvent).constructor(t.type,t);xe=r,t.target.dispatchEvent(r),xe=null,n.shift()}return!0}function Bn(e,n,t){Rn(e)&&t.delete(n)}function $n(){_n=!1,null!==jn&&Rn(jn)&&(jn=null),null!==zn&&Rn(zn)&&(zn=null),null!==Nn&&Rn(Nn)&&(Nn=null),Tn.forEach(Bn),Fn.forEach(Bn)}function Un(e,n){e.blockedOn===n&&(e.blockedOn=null,_n||(_n=!0,a.unstable_scheduleCallback(a.unstable_NormalPriority,$n)))}function Vn(e){function n(n){return Un(n,e)}if(0<Mn.length){Un(Mn[0],e);for(var t=1;t<Mn.length;t++){var r=Mn[t];r.blockedOn===e&&(r.blockedOn=null)}}for(null!==jn&&Un(jn,e),null!==zn&&Un(zn,e),null!==Nn&&Un(Nn,e),Tn.forEach(n),Fn.forEach(n),t=0;t<In.length;t++)(r=In[t]).blockedOn===e&&(r.blockedOn=null);for(;0<In.length&&null===(t=In[0]).blockedOn;)Dn(t),null===t.blockedOn&&In.shift()}var Hn=x.ReactCurrentBatchConfig,Zn=!0;function Wn(e,n,t,r){var a=xn,l=Hn.transition;Hn.transition=null;try{xn=1,Qn(e,n,t,r)}finally{xn=a,Hn.transition=l}}function qn(e,n,t,r){var a=xn,l=Hn.transition;Hn.transition=null;try{xn=4,Qn(e,n,t,r)}finally{xn=a,Hn.transition=l}}function Qn(e,n,t,r){if(Zn){var a=Xn(e,n,t,r);if(null===a)Hr(e,n,r,Kn,t),Ln(e,r);else if(function(e,n,t,r,a){switch(n){case"focusin":return jn=An(jn,e,n,t,r,a),!0;case"dragenter":return zn=An(zn,e,n,t,r,a),!0;case"mouseover":return Nn=An(Nn,e,n,t,r,a),!0;case"pointerover":var l=a.pointerId;return Tn.set(l,An(Tn.get(l)||null,e,n,t,r,a)),!0;case"gotpointercapture":return l=a.pointerId,Fn.set(l,An(Fn.get(l)||null,e,n,t,r,a)),!0}return!1}(a,e,n,t,r))r.stopPropagation();else if(Ln(e,r),4&n&&-1<On.indexOf(e)){for(;null!==a;){var l=ya(a);if(null!==l&&kn(l),null===(l=Xn(e,n,t,r))&&Hr(e,n,r,Kn,t),l===a)break;a=l}null!==a&&r.stopPropagation()}else Hr(e,n,r,null,t)}}var Kn=null;function Xn(e,n,t,r){if(Kn=null,null!==(e=ba(e=we(r))))if(null===(n=Ue(e)))e=null;else if(13===(t=n.tag)){if(null!==(e=Ve(n)))return e;e=null}else if(3===t){if(n.stateNode.current.memoizedState.isDehydrated)return 3===n.tag?n.stateNode.containerInfo:null;e=null}else n!==e&&(e=null);return Kn=e,null}function Yn(e){switch(e){case"cancel":case"click":case"close":case"contextmenu":case"copy":case"cut":case"auxclick":case"dblclick":case"dragend":case"dragstart":case"drop":case"focusin":case"focusout":case"input":case"invalid":case"keydown":case"keypress":case"keyup":case"mousedown":case"mouseup":case"paste":case"pause":case"play":case"pointercancel":case"pointerdown":case"pointerup":case"ratechange":case"reset":case"resize":case"seeked":case"submit":case"touchcancel":case"touchend":case"touchstart":case"volumechange":case"change":case"selectionchange":case"textInput":case"compositionstart":case"compositionend":case"compositionupdate":case"beforeblur":case"afterblur":case"beforeinput":case"blur":case"fullscreenchange":case"focus":case"hashchange":case"popstate":case"select":case"selectstart":return 1;case"drag":case"dragenter":case"dragexit":case"dragleave":case"dragover":case"mousemove":case"mouseout":case"mouseover":case"pointermove":case"pointerout":case"pointerover":case"scroll":case"toggle":case"touchmove":case"wheel":case"mouseenter":case"mouseleave":case"pointerenter":case"pointerleave":return 4;case"message":switch(Ge()){case Je:return 1;case en:return 4;case nn:case tn:return 16;case rn:return 536870912;default:return 16}default:return 16}}var Gn=null,Jn=null,et=null;function nt(){if(et)return et;var e,n,t=Jn,r=t.length,a="value"in Gn?Gn.value:Gn.textContent,l=a.length;for(e=0;e<r&&t[e]===a[e];e++);var o=r-e;for(n=1;n<=o&&t[r-n]===a[l-n];n++);return et=a.slice(e,1<n?1-n:void 0)}function tt(e){var n=e.keyCode;return"charCode"in e?0===(e=e.charCode)&&13===n&&(e=13):e=n,10===e&&(e=13),32<=e||13===e?e:0}function rt(){return!0}function at(){return!1}function lt(e){function n(n,t,r,a,l){for(var o in this._reactName=n,this._targetInst=r,this.type=t,this.nativeEvent=a,this.target=l,this.currentTarget=null,e)e.hasOwnProperty(o)&&(n=e[o],this[o]=n?n(a):a[o]);return this.isDefaultPrevented=(null!=a.defaultPrevented?a.defaultPrevented:!1===a.returnValue)?rt:at,this.isPropagationStopped=at,this}return A(n.prototype,{preventDefault:function(){this.defaultPrevented=!0;var e=this.nativeEvent;e&&(e.preventDefault?e.preventDefault():"unknown"!=typeof e.returnValue&&(e.returnValue=!1),this.isDefaultPrevented=rt)},stopPropagation:function(){var e=this.nativeEvent;e&&(e.stopPropagation?e.stopPropagation():"unknown"!=typeof e.cancelBubble&&(e.cancelBubble=!0),this.isPropagationStopped=rt)},persist:function(){},isPersistent:rt}),n}var ot,it,ut,st={eventPhase:0,bubbles:0,cancelable:0,timeStamp:function(e){return e.timeStamp||Date.now()},defaultPrevented:0,isTrusted:0},ct=lt(st),dt=A({},st,{view:0,detail:0}),ft=lt(dt),pt=A({},dt,{screenX:0,screenY:0,clientX:0,clientY:0,pageX:0,pageY:0,ctrlKey:0,shiftKey:0,altKey:0,metaKey:0,getModifierState:Et,button:0,buttons:0,relatedTarget:function(e){return void 0===e.relatedTarget?e.fromElement===e.srcElement?e.toElement:e.fromElement:e.relatedTarget},movementX:function(e){return"movementX"in e?e.movementX:(e!==ut&&(ut&&"mousemove"===e.type?(ot=e.screenX-ut.screenX,it=e.screenY-ut.screenY):it=ot=0,ut=e),ot)},movementY:function(e){return"movementY"in e?e.movementY:it}}),mt=lt(pt),ht=lt(A({},pt,{dataTransfer:0})),vt=lt(A({},dt,{relatedTarget:0})),gt=lt(A({},st,{animationName:0,elapsedTime:0,pseudoElement:0})),bt=A({},st,{clipboardData:function(e){return"clipboardData"in e?e.clipboardData:window.clipboardData}}),yt=lt(bt),xt=lt(A({},st,{data:0})),wt={Esc:"Escape",Spacebar:" ",Left:"ArrowLeft",Up:"ArrowUp",Right:"ArrowRight",Down:"ArrowDown",Del:"Delete",Win:"OS",Menu:"ContextMenu",Apps:"ContextMenu",Scroll:"ScrollLock",MozPrintableKey:"Unidentified"},kt={8:"Backspace",9:"Tab",12:"Clear",13:"Enter",16:"Shift",17:"Control",18:"Alt",19:"Pause",20:"CapsLock",27:"Escape",32:" ",33:"PageUp",34:"PageDown",35:"End",36:"Home",37:"ArrowLeft",38:"ArrowUp",39:"ArrowRight",40:"ArrowDown",45:"Insert",46:"Delete",112:"F1",113:"F2",114:"F3",115:"F4",116:"F5",117:"F6",118:"F7",119:"F8",120:"F9",121:"F10",122:"F11",123:"F12",144:"NumLock",145:"ScrollLock",224:"Meta"},St={Alt:"altKey",Control:"ctrlKey",Meta:"metaKey",Shift:"shiftKey"};function Ct(e){var n=this.nativeEvent;return n.getModifierState?n.getModifierState(e):!!(e=St[e])&&!!n[e]}function Et(){return Ct}var Pt=A({},dt,{key:function(e){if(e.key){var n=wt[e.key]||e.key;if("Unidentified"!==n)return n}return"keypress"===e.type?13===(e=tt(e))?"Enter":String.fromCharCode(e):"keydown"===e.type||"keyup"===e.type?kt[e.keyCode]||"Unidentified":""},code:0,location:0,ctrlKey:0,shiftKey:0,altKey:0,metaKey:0,repeat:0,locale:0,getModifierState:Et,charCode:function(e){return"keypress"===e.type?tt(e):0},keyCode:function(e){return"keydown"===e.type||"keyup"===e.type?e.keyCode:0},which:function(e){return"keypress"===e.type?tt(e):"keydown"===e.type||"keyup"===e.type?e.keyCode:0}}),_t=lt(Pt),Mt=lt(A({},pt,{pointerId:0,width:0,height:0,pressure:0,tangentialPressure:0,tiltX:0,tiltY:0,twist:0,pointerType:0,isPrimary:0})),jt=lt(A({},dt,{touches:0,targetTouches:0,changedTouches:0,altKey:0,metaKey:0,ctrlKey:0,shiftKey:0,getModifierState:Et})),zt=lt(A({},st,{propertyName:0,elapsedTime:0,pseudoElement:0})),Nt=A({},pt,{deltaX:function(e){return"deltaX"in e?e.deltaX:"wheelDeltaX"in e?-e.wheelDeltaX:0},deltaY:function(e){return"deltaY"in e?e.deltaY:"wheelDeltaY"in e?-e.wheelDeltaY:"wheelDelta"in e?-e.wheelDelta:0},deltaZ:0,deltaMode:0}),Tt=lt(Nt),Ft=[9,13,27,32],It=c&&"CompositionEvent"in window,Ot=null;c&&"documentMode"in document&&(Ot=document.documentMode);var Lt=c&&"TextEvent"in window&&!Ot,At=c&&(!It||Ot&&8<Ot&&11>=Ot),Dt=String.fromCharCode(32),Rt=!1;function Bt(e,n){switch(e){case"keyup":return-1!==Ft.indexOf(n.keyCode);case"keydown":return 229!==n.keyCode;case"keypress":case"mousedown":case"focusout":return!0;default:return!1}}function $t(e){return"object"==typeof(e=e.detail)&&"data"in e?e.data:null}var Ut=!1,Vt={color:!0,date:!0,datetime:!0,"datetime-local":!0,email:!0,month:!0,number:!0,password:!0,range:!0,search:!0,tel:!0,text:!0,time:!0,url:!0,week:!0};function Ht(e){var n=e&&e.nodeName&&e.nodeName.toLowerCase();return"input"===n?!!Vt[e.type]:"textarea"===n}function Zt(e,n,t,r){Pe(r),0<(n=Wr(n,"onChange")).length&&(t=new ct("onChange","change",null,t,r),e.push({event:t,listeners:n}))}var Wt=null,qt=null;function Qt(e){Dr(e,0)}function Kt(e){if(q(xa(e)))return e}function Xt(e,n){if("change"===e)return n}var Yt=!1;if(c){var Gt;if(c){var Jt="oninput"in document;if(!Jt){var er=document.createElement("div");er.setAttribute("oninput","return;"),Jt="function"==typeof er.oninput}Gt=Jt}else Gt=!1;Yt=Gt&&(!document.documentMode||9<document.documentMode)}function nr(){Wt&&(Wt.detachEvent("onpropertychange",tr),qt=Wt=null)}function tr(e){if("value"===e.propertyName&&Kt(qt)){var n=[];Zt(n,qt,e,we(e)),Ne(Qt,n)}}function rr(e,n,t){"focusin"===e?(nr(),qt=t,(Wt=n).attachEvent("onpropertychange",tr)):"focusout"===e&&nr()}function ar(e){if("selectionchange"===e||"keyup"===e||"keydown"===e)return Kt(qt)}function lr(e,n){if("click"===e)return Kt(n)}function or(e,n){if("input"===e||"change"===e)return Kt(n)}var ir="function"==typeof Object.is?Object.is:function(e,n){return e===n&&(0!==e||1/e==1/n)||e!=e&&n!=n};function ur(e,n){if(ir(e,n))return!0;if("object"!=typeof e||null===e||"object"!=typeof n||null===n)return!1;var t=Object.keys(e),r=Object.keys(n);if(t.length!==r.length)return!1;for(r=0;r<t.length;r++){var a=t[r];if(!d.call(n,a)||!ir(e[a],n[a]))return!1}return!0}function sr(e){for(;e&&e.firstChild;)e=e.firstChild;return e}function cr(e,n){var t,r=sr(e);for(e=0;r;){if(3===r.nodeType){if(t=e+r.textContent.length,e<=n&&t>=n)return{node:r,offset:n-e};e=t}e:{for(;r;){if(r.nextSibling){r=r.nextSibling;break e}r=r.parentNode}r=void 0}r=sr(r)}}function dr(e,n){return!(!e||!n)&&(e===n||(!e||3!==e.nodeType)&&(n&&3===n.nodeType?dr(e,n.parentNode):"contains"in e?e.contains(n):!!e.compareDocumentPosition&&!!(16&e.compareDocumentPosition(n))))}function fr(){for(var e=window,n=Q();n instanceof e.HTMLIFrameElement;){try{var t="string"==typeof n.contentWindow.location.href}catch(e){t=!1}if(!t)break;n=Q((e=n.contentWindow).document)}return n}function pr(e){var n=e&&e.nodeName&&e.nodeName.toLowerCase();return n&&("input"===n&&("text"===e.type||"search"===e.type||"tel"===e.type||"url"===e.type||"password"===e.type)||"textarea"===n||"true"===e.contentEditable)}function mr(e){var n=fr(),t=e.focusedElem,r=e.selectionRange;if(n!==t&&t&&t.ownerDocument&&dr(t.ownerDocument.documentElement,t)){if(null!==r&&pr(t))if(n=r.start,void 0===(e=r.end)&&(e=n),"selectionStart"in t)t.selectionStart=n,t.selectionEnd=Math.min(e,t.value.length);else if((e=(n=t.ownerDocument||document)&&n.defaultView||window).getSelection){e=e.getSelection();var a=t.textContent.length,l=Math.min(r.start,a);r=void 0===r.end?l:Math.min(r.end,a),!e.extend&&l>r&&(a=r,r=l,l=a),a=cr(t,l);var o=cr(t,r);a&&o&&(1!==e.rangeCount||e.anchorNode!==a.node||e.anchorOffset!==a.offset||e.focusNode!==o.node||e.focusOffset!==o.offset)&&((n=n.createRange()).setStart(a.node,a.offset),e.removeAllRanges(),l>r?(e.addRange(n),e.extend(o.node,o.offset)):(n.setEnd(o.node,o.offset),e.addRange(n)))}for(n=[],e=t;e=e.parentNode;)1===e.nodeType&&n.push({element:e,left:e.scrollLeft,top:e.scrollTop});for("function"==typeof t.focus&&t.focus(),t=0;t<n.length;t++)(e=n[t]).element.scrollLeft=e.left,e.element.scrollTop=e.top}}var hr=c&&"documentMode"in document&&11>=document.documentMode,vr=null,gr=null,br=null,yr=!1;function xr(e,n,t){var r=t.window===t?t.document:9===t.nodeType?t:t.ownerDocument;yr||null==vr||vr!==Q(r)||(r="selectionStart"in(r=vr)&&pr(r)?{start:r.selectionStart,end:r.selectionEnd}:{anchorNode:(r=(r.ownerDocument&&r.ownerDocument.defaultView||window).getSelection()).anchorNode,anchorOffset:r.anchorOffset,focusNode:r.focusNode,focusOffset:r.focusOffset},br&&ur(br,r)||(br=r,0<(r=Wr(gr,"onSelect")).length&&(n=new ct("onSelect","select",null,n,t),e.push({event:n,listeners:r}),n.target=vr)))}function wr(e,n){var t={};return t[e.toLowerCase()]=n.toLowerCase(),t["Webkit"+e]="webkit"+n,t["Moz"+e]="moz"+n,t}var kr={animationend:wr("Animation","AnimationEnd"),animationiteration:wr("Animation","AnimationIteration"),animationstart:wr("Animation","AnimationStart"),transitionend:wr("Transition","TransitionEnd")},Sr={},Cr={};function Er(e){if(Sr[e])return Sr[e];if(!kr[e])return e;var n,t=kr[e];for(n in t)if(t.hasOwnProperty(n)&&n in Cr)return Sr[e]=t[n];return e}c&&(Cr=document.createElement("div").style,"AnimationEvent"in window||(delete kr.animationend.animation,delete kr.animationiteration.animation,delete kr.animationstart.animation),"TransitionEvent"in window||delete kr.transitionend.transition);var Pr=Er("animationend"),_r=Er("animationiteration"),Mr=Er("animationstart"),jr=Er("transitionend"),zr=new Map,Nr="abort auxClick cancel canPlay canPlayThrough click close contextMenu copy cut drag dragEnd dragEnter dragExit dragLeave dragOver dragStart drop durationChange emptied encrypted ended error gotPointerCapture input invalid keyDown keyPress keyUp load loadedData loadedMetadata loadStart lostPointerCapture mouseDown mouseMove mouseOut mouseOver mouseUp paste pause play playing pointerCancel pointerDown pointerMove pointerOut pointerOver pointerUp progress rateChange reset resize seeked seeking stalled submit suspend timeUpdate touchCancel touchEnd touchStart volumeChange scroll toggle touchMove waiting wheel".split(" ");function Tr(e,n){zr.set(e,n),u(n,[e])}for(var Fr=0;Fr<Nr.length;Fr++){var Ir=Nr[Fr];Tr(Ir.toLowerCase(),"on"+(Ir[0].toUpperCase()+Ir.slice(1)))}Tr(Pr,"onAnimationEnd"),Tr(_r,"onAnimationIteration"),Tr(Mr,"onAnimationStart"),Tr("dblclick","onDoubleClick"),Tr("focusin","onFocus"),Tr("focusout","onBlur"),Tr(jr,"onTransitionEnd"),s("onMouseEnter",["mouseout","mouseover"]),s("onMouseLeave",["mouseout","mouseover"]),s("onPointerEnter",["pointerout","pointerover"]),s("onPointerLeave",["pointerout","pointerover"]),u("onChange","change click focusin focusout input keydown keyup selectionchange".split(" ")),u("onSelect","focusout contextmenu dragend focusin keydown keyup mousedown mouseup selectionchange".split(" ")),u("onBeforeInput",["compositionend","keypress","textInput","paste"]),u("onCompositionEnd","compositionend focusout keydown keypress keyup mousedown".split(" ")),u("onCompositionStart","compositionstart focusout keydown keypress keyup mousedown".split(" ")),u("onCompositionUpdate","compositionupdate focusout keydown keypress keyup mousedown".split(" "));var Or="abort canplay canplaythrough durationchange emptied encrypted ended error loadeddata loadedmetadata loadstart pause play playing progress ratechange resize seeked seeking stalled suspend timeupdate volumechange waiting".split(" "),Lr=new Set("cancel close invalid load scroll toggle".split(" ").concat(Or));function Ar(e,n,t){var r=e.type||"unknown-event";e.currentTarget=t,function(e,n,t,r,a,o,i,u,s){if($e.apply(this,arguments),Le){if(!Le)throw Error(l(198));var c=Ae;Le=!1,Ae=null,De||(De=!0,Re=c)}}(r,n,void 0,e),e.currentTarget=null}function Dr(e,n){n=0!=(4&n);for(var t=0;t<e.length;t++){var r=e[t],a=r.event;r=r.listeners;e:{var l=void 0;if(n)for(var o=r.length-1;0<=o;o--){var i=r[o],u=i.instance,s=i.currentTarget;if(i=i.listener,u!==l&&a.isPropagationStopped())break e;Ar(a,i,s),l=u}else for(o=0;o<r.length;o++){if(u=(i=r[o]).instance,s=i.currentTarget,i=i.listener,u!==l&&a.isPropagationStopped())break e;Ar(a,i,s),l=u}}}if(De)throw e=Re,De=!1,Re=null,e}function Rr(e,n){var t=n[ha];void 0===t&&(t=n[ha]=new Set);var r=e+"__bubble";t.has(r)||(Vr(n,e,2,!1),t.add(r))}function Br(e,n,t){var r=0;n&&(r|=4),Vr(t,e,r,n)}var $r="_reactListening"+Math.random().toString(36).slice(2);function Ur(e){if(!e[$r]){e[$r]=!0,o.forEach((function(n){"selectionchange"!==n&&(Lr.has(n)||Br(n,!1,e),Br(n,!0,e))}));var n=9===e.nodeType?e:e.ownerDocument;null===n||n[$r]||(n[$r]=!0,Br("selectionchange",!1,n))}}function Vr(e,n,t,r){switch(Yn(n)){case 1:var a=Wn;break;case 4:a=qn;break;default:a=Qn}t=a.bind(null,n,t,e),a=void 0,!Fe||"touchstart"!==n&&"touchmove"!==n&&"wheel"!==n||(a=!0),r?void 0!==a?e.addEventListener(n,t,{capture:!0,passive:a}):e.addEventListener(n,t,!0):void 0!==a?e.addEventListener(n,t,{passive:a}):e.addEventListener(n,t,!1)}function Hr(e,n,t,r,a){var l=r;if(0==(1&n)&&0==(2&n)&&null!==r)e:for(;;){if(null===r)return;var o=r.tag;if(3===o||4===o){var i=r.stateNode.containerInfo;if(i===a||8===i.nodeType&&i.parentNode===a)break;if(4===o)for(o=r.return;null!==o;){var u=o.tag;if((3===u||4===u)&&((u=o.stateNode.containerInfo)===a||8===u.nodeType&&u.parentNode===a))return;o=o.return}for(;null!==i;){if(null===(o=ba(i)))return;if(5===(u=o.tag)||6===u){r=l=o;continue e}i=i.parentNode}}r=r.return}Ne((function(){var r=l,a=we(t),o=[];e:{var i=zr.get(e);if(void 0!==i){var u=ct,s=e;switch(e){case"keypress":if(0===tt(t))break e;case"keydown":case"keyup":u=_t;break;case"focusin":s="focus",u=vt;break;case"focusout":s="blur",u=vt;break;case"beforeblur":case"afterblur":u=vt;break;case"click":if(2===t.button)break e;case"auxclick":case"dblclick":case"mousedown":case"mousemove":case"mouseup":case"mouseout":case"mouseover":case"contextmenu":u=mt;break;case"drag":case"dragend":case"dragenter":case"dragexit":case"dragleave":case"dragover":case"dragstart":case"drop":u=ht;break;case"touchcancel":case"touchend":case"touchmove":case"touchstart":u=jt;break;case Pr:case _r:case Mr:u=gt;break;case jr:u=zt;break;case"scroll":u=ft;break;case"wheel":u=Tt;break;case"copy":case"cut":case"paste":u=yt;break;case"gotpointercapture":case"lostpointercapture":case"pointercancel":case"pointerdown":case"pointermove":case"pointerout":case"pointerover":case"pointerup":u=Mt}var c=0!=(4&n),d=!c&&"scroll"===e,f=c?null!==i?i+"Capture":null:i;c=[];for(var p,m=r;null!==m;){var h=(p=m).stateNode;if(5===p.tag&&null!==h&&(p=h,null!==f&&null!=(h=Te(m,f))&&c.push(Zr(m,h,p))),d)break;m=m.return}0<c.length&&(i=new u(i,s,null,t,a),o.push({event:i,listeners:c}))}}if(0==(7&n)){if(u="mouseout"===e||"pointerout"===e,(!(i="mouseover"===e||"pointerover"===e)||t===xe||!(s=t.relatedTarget||t.fromElement)||!ba(s)&&!s[ma])&&(u||i)&&(i=a.window===a?a:(i=a.ownerDocument)?i.defaultView||i.parentWindow:window,u?(u=r,null!==(s=(s=t.relatedTarget||t.toElement)?ba(s):null)&&(s!==(d=Ue(s))||5!==s.tag&&6!==s.tag)&&(s=null)):(u=null,s=r),u!==s)){if(c=mt,h="onMouseLeave",f="onMouseEnter",m="mouse","pointerout"!==e&&"pointerover"!==e||(c=Mt,h="onPointerLeave",f="onPointerEnter",m="pointer"),d=null==u?i:xa(u),p=null==s?i:xa(s),(i=new c(h,m+"leave",u,t,a)).target=d,i.relatedTarget=p,h=null,ba(a)===r&&((c=new c(f,m+"enter",s,t,a)).target=p,c.relatedTarget=d,h=c),d=h,u&&s)e:{for(f=s,m=0,p=c=u;p;p=qr(p))m++;for(p=0,h=f;h;h=qr(h))p++;for(;0<m-p;)c=qr(c),m--;for(;0<p-m;)f=qr(f),p--;for(;m--;){if(c===f||null!==f&&c===f.alternate)break e;c=qr(c),f=qr(f)}c=null}else c=null;null!==u&&Qr(o,i,u,c,!1),null!==s&&null!==d&&Qr(o,d,s,c,!0)}if("select"===(u=(i=r?xa(r):window).nodeName&&i.nodeName.toLowerCase())||"input"===u&&"file"===i.type)var v=Xt;else if(Ht(i))if(Yt)v=or;else{v=ar;var g=rr}else(u=i.nodeName)&&"input"===u.toLowerCase()&&("checkbox"===i.type||"radio"===i.type)&&(v=lr);switch(v&&(v=v(e,r))?Zt(o,v,t,a):(g&&g(e,i,r),"focusout"===e&&(g=i._wrapperState)&&g.controlled&&"number"===i.type&&ee(i,"number",i.value)),g=r?xa(r):window,e){case"focusin":(Ht(g)||"true"===g.contentEditable)&&(vr=g,gr=r,br=null);break;case"focusout":br=gr=vr=null;break;case"mousedown":yr=!0;break;case"contextmenu":case"mouseup":case"dragend":yr=!1,xr(o,t,a);break;case"selectionchange":if(hr)break;case"keydown":case"keyup":xr(o,t,a)}var b;if(It)e:{switch(e){case"compositionstart":var y="onCompositionStart";break e;case"compositionend":y="onCompositionEnd";break e;case"compositionupdate":y="onCompositionUpdate";break e}y=void 0}else Ut?Bt(e,t)&&(y="onCompositionEnd"):"keydown"===e&&229===t.keyCode&&(y="onCompositionStart");y&&(At&&"ko"!==t.locale&&(Ut||"onCompositionStart"!==y?"onCompositionEnd"===y&&Ut&&(b=nt()):(Jn="value"in(Gn=a)?Gn.value:Gn.textContent,Ut=!0)),0<(g=Wr(r,y)).length&&(y=new xt(y,e,null,t,a),o.push({event:y,listeners:g}),(b||null!==(b=$t(t)))&&(y.data=b))),(b=Lt?function(e,n){switch(e){case"compositionend":return $t(n);case"keypress":return 32!==n.which?null:(Rt=!0,Dt);case"textInput":return(e=n.data)===Dt&&Rt?null:e;default:return null}}(e,t):function(e,n){if(Ut)return"compositionend"===e||!It&&Bt(e,n)?(e=nt(),et=Jn=Gn=null,Ut=!1,e):null;switch(e){case"paste":default:return null;case"keypress":if(!(n.ctrlKey||n.altKey||n.metaKey)||n.ctrlKey&&n.altKey){if(n.char&&1<n.char.length)return n.char;if(n.which)return String.fromCharCode(n.which)}return null;case"compositionend":return At&&"ko"!==n.locale?null:n.data}}(e,t))&&0<(r=Wr(r,"onBeforeInput")).length&&(a=new xt("onBeforeInput","beforeinput",null,t,a),o.push({event:a,listeners:r}),a.data=b)}Dr(o,n)}))}function Zr(e,n,t){return{instance:e,listener:n,currentTarget:t}}function Wr(e,n){for(var t=n+"Capture",r=[];null!==e;){var a=e,l=a.stateNode;5===a.tag&&null!==l&&(a=l,null!=(l=Te(e,t))&&r.unshift(Zr(e,l,a)),null!=(l=Te(e,n))&&r.push(Zr(e,l,a))),e=e.return}return r}function qr(e){if(null===e)return null;do{e=e.return}while(e&&5!==e.tag);return e||null}function Qr(e,n,t,r,a){for(var l=n._reactName,o=[];null!==t&&t!==r;){var i=t,u=i.alternate,s=i.stateNode;if(null!==u&&u===r)break;5===i.tag&&null!==s&&(i=s,a?null!=(u=Te(t,l))&&o.unshift(Zr(t,u,i)):a||null!=(u=Te(t,l))&&o.push(Zr(t,u,i))),t=t.return}0!==o.length&&e.push({event:n,listeners:o})}var Kr=/\r\n?/g,Xr=/\u0000|\uFFFD/g;function Yr(e){return("string"==typeof e?e:""+e).replace(Kr,"\n").replace(Xr,"")}function Gr(e,n,t){if(n=Yr(n),Yr(e)!==n&&t)throw Error(l(425))}function Jr(){}var ea=null,na=null;function ta(e,n){return"textarea"===e||"noscript"===e||"string"==typeof n.children||"number"==typeof n.children||"object"==typeof n.dangerouslySetInnerHTML&&null!==n.dangerouslySetInnerHTML&&null!=n.dangerouslySetInnerHTML.__html}var ra="function"==typeof setTimeout?setTimeout:void 0,aa="function"==typeof clearTimeout?clearTimeout:void 0,la="function"==typeof Promise?Promise:void 0,oa="function"==typeof queueMicrotask?queueMicrotask:void 0!==la?function(e){return la.resolve(null).then(e).catch(ia)}:ra;function ia(e){setTimeout((function(){throw e}))}function ua(e,n){var t=n,r=0;do{var a=t.nextSibling;if(e.removeChild(t),a&&8===a.nodeType)if("/$"===(t=a.data)){if(0===r)return e.removeChild(a),void Vn(n);r--}else"$"!==t&&"$?"!==t&&"$!"!==t||r++;t=a}while(t);Vn(n)}function sa(e){for(;null!=e;e=e.nextSibling){var n=e.nodeType;if(1===n||3===n)break;if(8===n){if("$"===(n=e.data)||"$!"===n||"$?"===n)break;if("/$"===n)return null}}return e}function ca(e){e=e.previousSibling;for(var n=0;e;){if(8===e.nodeType){var t=e.data;if("$"===t||"$!"===t||"$?"===t){if(0===n)return e;n--}else"/$"===t&&n++}e=e.previousSibling}return null}var da=Math.random().toString(36).slice(2),fa="__reactFiber$"+da,pa="__reactProps$"+da,ma="__reactContainer$"+da,ha="__reactEvents$"+da,va="__reactListeners$"+da,ga="__reactHandles$"+da;function ba(e){var n=e[fa];if(n)return n;for(var t=e.parentNode;t;){if(n=t[ma]||t[fa]){if(t=n.alternate,null!==n.child||null!==t&&null!==t.child)for(e=ca(e);null!==e;){if(t=e[fa])return t;e=ca(e)}return n}t=(e=t).parentNode}return null}function ya(e){return!(e=e[fa]||e[ma])||5!==e.tag&&6!==e.tag&&13!==e.tag&&3!==e.tag?null:e}function xa(e){if(5===e.tag||6===e.tag)return e.stateNode;throw Error(l(33))}function wa(e){return e[pa]||null}var ka=[],Sa=-1;function Ca(e){return{current:e}}function Ea(e){0>Sa||(e.current=ka[Sa],ka[Sa]=null,Sa--)}function Pa(e,n){Sa++,ka[Sa]=e.current,e.current=n}var _a={},Ma=Ca(_a),ja=Ca(!1),za=_a;function Na(e,n){var t=e.type.contextTypes;if(!t)return _a;var r=e.stateNode;if(r&&r.__reactInternalMemoizedUnmaskedChildContext===n)return r.__reactInternalMemoizedMaskedChildContext;var a,l={};for(a in t)l[a]=n[a];return r&&((e=e.stateNode).__reactInternalMemoizedUnmaskedChildContext=n,e.__reactInternalMemoizedMaskedChildContext=l),l}function Ta(e){return null!=e.childContextTypes}function Fa(){Ea(ja),Ea(Ma)}function Ia(e,n,t){if(Ma.current!==_a)throw Error(l(168));Pa(Ma,n),Pa(ja,t)}function Oa(e,n,t){var r=e.stateNode;if(n=n.childContextTypes,"function"!=typeof r.getChildContext)return t;for(var a in r=r.getChildContext())if(!(a in n))throw Error(l(108,V(e)||"Unknown",a));return A({},t,r)}function La(e){return e=(e=e.stateNode)&&e.__reactInternalMemoizedMergedChildContext||_a,za=Ma.current,Pa(Ma,e),Pa(ja,ja.current),!0}function Aa(e,n,t){var r=e.stateNode;if(!r)throw Error(l(169));t?(e=Oa(e,n,za),r.__reactInternalMemoizedMergedChildContext=e,Ea(ja),Ea(Ma),Pa(Ma,e)):Ea(ja),Pa(ja,t)}var Da=null,Ra=!1,Ba=!1;function $a(e){null===Da?Da=[e]:Da.push(e)}function Ua(){if(!Ba&&null!==Da){Ba=!0;var e=0,n=xn;try{var t=Da;for(xn=1;e<t.length;e++){var r=t[e];do{r=r(!0)}while(null!==r)}Da=null,Ra=!1}catch(n){throw null!==Da&&(Da=Da.slice(e+1)),qe(Je,Ua),n}finally{xn=n,Ba=!1}}return null}var Va=[],Ha=0,Za=null,Wa=0,qa=[],Qa=0,Ka=null,Xa=1,Ya="";function Ga(e,n){Va[Ha++]=Wa,Va[Ha++]=Za,Za=e,Wa=n}function Ja(e,n,t){qa[Qa++]=Xa,qa[Qa++]=Ya,qa[Qa++]=Ka,Ka=e;var r=Xa;e=Ya;var a=32-on(r)-1;r&=~(1<<a),t+=1;var l=32-on(n)+a;if(30<l){var o=a-a%5;l=(r&(1<<o)-1).toString(32),r>>=o,a-=o,Xa=1<<32-on(n)+a|t<<a|r,Ya=l+e}else Xa=1<<l|t<<a|r,Ya=e}function el(e){null!==e.return&&(Ga(e,1),Ja(e,1,0))}function nl(e){for(;e===Za;)Za=Va[--Ha],Va[Ha]=null,Wa=Va[--Ha],Va[Ha]=null;for(;e===Ka;)Ka=qa[--Qa],qa[Qa]=null,Ya=qa[--Qa],qa[Qa]=null,Xa=qa[--Qa],qa[Qa]=null}var tl=null,rl=null,al=!1,ll=null;function ol(e,n){var t=Ts(5,null,null,0);t.elementType="DELETED",t.stateNode=n,t.return=e,null===(n=e.deletions)?(e.deletions=[t],e.flags|=16):n.push(t)}function il(e,n){switch(e.tag){case 5:var t=e.type;return null!==(n=1!==n.nodeType||t.toLowerCase()!==n.nodeName.toLowerCase()?null:n)&&(e.stateNode=n,tl=e,rl=sa(n.firstChild),!0);case 6:return null!==(n=""===e.pendingProps||3!==n.nodeType?null:n)&&(e.stateNode=n,tl=e,rl=null,!0);case 13:return null!==(n=8!==n.nodeType?null:n)&&(t=null!==Ka?{id:Xa,overflow:Ya}:null,e.memoizedState={dehydrated:n,treeContext:t,retryLane:1073741824},(t=Ts(18,null,null,0)).stateNode=n,t.return=e,e.child=t,tl=e,rl=null,!0);default:return!1}}function ul(e){return 0!=(1&e.mode)&&0==(128&e.flags)}function sl(e){if(al){var n=rl;if(n){var t=n;if(!il(e,n)){if(ul(e))throw Error(l(418));n=sa(t.nextSibling);var r=tl;n&&il(e,n)?ol(r,t):(e.flags=-4097&e.flags|2,al=!1,tl=e)}}else{if(ul(e))throw Error(l(418));e.flags=-4097&e.flags|2,al=!1,tl=e}}}function cl(e){for(e=e.return;null!==e&&5!==e.tag&&3!==e.tag&&13!==e.tag;)e=e.return;tl=e}function dl(e){if(e!==tl)return!1;if(!al)return cl(e),al=!0,!1;var n;if((n=3!==e.tag)&&!(n=5!==e.tag)&&(n="head"!==(n=e.type)&&"body"!==n&&!ta(e.type,e.memoizedProps)),n&&(n=rl)){if(ul(e))throw fl(),Error(l(418));for(;n;)ol(e,n),n=sa(n.nextSibling)}if(cl(e),13===e.tag){if(!(e=null!==(e=e.memoizedState)?e.dehydrated:null))throw Error(l(317));e:{for(e=e.nextSibling,n=0;e;){if(8===e.nodeType){var t=e.data;if("/$"===t){if(0===n){rl=sa(e.nextSibling);break e}n--}else"$"!==t&&"$!"!==t&&"$?"!==t||n++}e=e.nextSibling}rl=null}}else rl=tl?sa(e.stateNode.nextSibling):null;return!0}function fl(){for(var e=rl;e;)e=sa(e.nextSibling)}function pl(){rl=tl=null,al=!1}function ml(e){null===ll?ll=[e]:ll.push(e)}var hl=x.ReactCurrentBatchConfig;function vl(e,n){if(e&&e.defaultProps){for(var t in n=A({},n),e=e.defaultProps)void 0===n[t]&&(n[t]=e[t]);return n}return n}var gl=Ca(null),bl=null,yl=null,xl=null;function wl(){xl=yl=bl=null}function kl(e){var n=gl.current;Ea(gl),e._currentValue=n}function Sl(e,n,t){for(;null!==e;){var r=e.alternate;if((e.childLanes&n)!==n?(e.childLanes|=n,null!==r&&(r.childLanes|=n)):null!==r&&(r.childLanes&n)!==n&&(r.childLanes|=n),e===t)break;e=e.return}}function Cl(e,n){bl=e,xl=yl=null,null!==(e=e.dependencies)&&null!==e.firstContext&&(0!=(e.lanes&n)&&(xi=!0),e.firstContext=null)}function El(e){var n=e._currentValue;if(xl!==e)if(e={context:e,memoizedValue:n,next:null},null===yl){if(null===bl)throw Error(l(308));yl=e,bl.dependencies={lanes:0,firstContext:e}}else yl=yl.next=e;return n}var Pl=null;function _l(e){null===Pl?Pl=[e]:Pl.push(e)}function Ml(e,n,t,r){var a=n.interleaved;return null===a?(t.next=t,_l(n)):(t.next=a.next,a.next=t),n.interleaved=t,jl(e,r)}function jl(e,n){e.lanes|=n;var t=e.alternate;for(null!==t&&(t.lanes|=n),t=e,e=e.return;null!==e;)e.childLanes|=n,null!==(t=e.alternate)&&(t.childLanes|=n),t=e,e=e.return;return 3===t.tag?t.stateNode:null}var zl=!1;function Nl(e){e.updateQueue={baseState:e.memoizedState,firstBaseUpdate:null,lastBaseUpdate:null,shared:{pending:null,interleaved:null,lanes:0},effects:null}}function Tl(e,n){e=e.updateQueue,n.updateQueue===e&&(n.updateQueue={baseState:e.baseState,firstBaseUpdate:e.firstBaseUpdate,lastBaseUpdate:e.lastBaseUpdate,shared:e.shared,effects:e.effects})}function Fl(e,n){return{eventTime:e,lane:n,tag:0,payload:null,callback:null,next:null}}function Il(e,n,t){var r=e.updateQueue;if(null===r)return null;if(r=r.shared,0!=(2&ju)){var a=r.pending;return null===a?n.next=n:(n.next=a.next,a.next=n),r.pending=n,jl(e,t)}return null===(a=r.interleaved)?(n.next=n,_l(r)):(n.next=a.next,a.next=n),r.interleaved=n,jl(e,t)}function Ol(e,n,t){if(null!==(n=n.updateQueue)&&(n=n.shared,0!=(4194240&t))){var r=n.lanes;t|=r&=e.pendingLanes,n.lanes=t,yn(e,t)}}function Ll(e,n){var t=e.updateQueue,r=e.alternate;if(null!==r&&t===(r=r.updateQueue)){var a=null,l=null;if(null!==(t=t.firstBaseUpdate)){do{var o={eventTime:t.eventTime,lane:t.lane,tag:t.tag,payload:t.payload,callback:t.callback,next:null};null===l?a=l=o:l=l.next=o,t=t.next}while(null!==t);null===l?a=l=n:l=l.next=n}else a=l=n;return t={baseState:r.baseState,firstBaseUpdate:a,lastBaseUpdate:l,shared:r.shared,effects:r.effects},void(e.updateQueue=t)}null===(e=t.lastBaseUpdate)?t.firstBaseUpdate=n:e.next=n,t.lastBaseUpdate=n}function Al(e,n,t,r){var a=e.updateQueue;zl=!1;var l=a.firstBaseUpdate,o=a.lastBaseUpdate,i=a.shared.pending;if(null!==i){a.shared.pending=null;var u=i,s=u.next;u.next=null,null===o?l=s:o.next=s,o=u;var c=e.alternate;null!==c&&(i=(c=c.updateQueue).lastBaseUpdate)!==o&&(null===i?c.firstBaseUpdate=s:i.next=s,c.lastBaseUpdate=u)}if(null!==l){var d=a.baseState;for(o=0,c=s=u=null,i=l;;){var f=i.lane,p=i.eventTime;if((r&f)===f){null!==c&&(c=c.next={eventTime:p,lane:0,tag:i.tag,payload:i.payload,callback:i.callback,next:null});e:{var m=e,h=i;switch(f=n,p=t,h.tag){case 1:if("function"==typeof(m=h.payload)){d=m.call(p,d,f);break e}d=m;break e;case 3:m.flags=-65537&m.flags|128;case 0:if(null==(f="function"==typeof(m=h.payload)?m.call(p,d,f):m))break e;d=A({},d,f);break e;case 2:zl=!0}}null!==i.callback&&0!==i.lane&&(e.flags|=64,null===(f=a.effects)?a.effects=[i]:f.push(i))}else p={eventTime:p,lane:f,tag:i.tag,payload:i.payload,callback:i.callback,next:null},null===c?(s=c=p,u=d):c=c.next=p,o|=f;if(null===(i=i.next)){if(null===(i=a.shared.pending))break;i=(f=i).next,f.next=null,a.lastBaseUpdate=f,a.shared.pending=null}}if(null===c&&(u=d),a.baseState=u,a.firstBaseUpdate=s,a.lastBaseUpdate=c,null!==(n=a.shared.interleaved)){a=n;do{o|=a.lane,a=a.next}while(a!==n)}else null===l&&(a.shared.lanes=0);Au|=o,e.lanes=o,e.memoizedState=d}}function Dl(e,n,t){if(e=n.effects,n.effects=null,null!==e)for(n=0;n<e.length;n++){var r=e[n],a=r.callback;if(null!==a){if(r.callback=null,r=t,"function"!=typeof a)throw Error(l(191,a));a.call(r)}}}var Rl=(new r.Component).refs;function Bl(e,n,t,r){t=null==(t=t(r,n=e.memoizedState))?n:A({},n,t),e.memoizedState=t,0===e.lanes&&(e.updateQueue.baseState=t)}var $l={isMounted:function(e){return!!(e=e._reactInternals)&&Ue(e)===e},enqueueSetState:function(e,n,t){e=e._reactInternals;var r=ns(),a=ts(e),l=Fl(r,a);l.payload=n,null!=t&&(l.callback=t),null!==(n=Il(e,l,a))&&(rs(n,e,a,r),Ol(n,e,a))},enqueueReplaceState:function(e,n,t){e=e._reactInternals;var r=ns(),a=ts(e),l=Fl(r,a);l.tag=1,l.payload=n,null!=t&&(l.callback=t),null!==(n=Il(e,l,a))&&(rs(n,e,a,r),Ol(n,e,a))},enqueueForceUpdate:function(e,n){e=e._reactInternals;var t=ns(),r=ts(e),a=Fl(t,r);a.tag=2,null!=n&&(a.callback=n),null!==(n=Il(e,a,r))&&(rs(n,e,r,t),Ol(n,e,r))}};function Ul(e,n,t,r,a,l,o){return"function"==typeof(e=e.stateNode).shouldComponentUpdate?e.shouldComponentUpdate(r,l,o):!(n.prototype&&n.prototype.isPureReactComponent&&ur(t,r)&&ur(a,l))}function Vl(e,n,t){var r=!1,a=_a,l=n.contextType;return"object"==typeof l&&null!==l?l=El(l):(a=Ta(n)?za:Ma.current,l=(r=null!=(r=n.contextTypes))?Na(e,a):_a),n=new n(t,l),e.memoizedState=null!==n.state&&void 0!==n.state?n.state:null,n.updater=$l,e.stateNode=n,n._reactInternals=e,r&&((e=e.stateNode).__reactInternalMemoizedUnmaskedChildContext=a,e.__reactInternalMemoizedMaskedChildContext=l),n}function Hl(e,n,t,r){e=n.state,"function"==typeof n.componentWillReceiveProps&&n.componentWillReceiveProps(t,r),"function"==typeof n.UNSAFE_componentWillReceiveProps&&n.UNSAFE_componentWillReceiveProps(t,r),n.state!==e&&$l.enqueueReplaceState(n,n.state,null)}function Zl(e,n,t,r){var a=e.stateNode;a.props=t,a.state=e.memoizedState,a.refs=Rl,Nl(e);var l=n.contextType;"object"==typeof l&&null!==l?a.context=El(l):(l=Ta(n)?za:Ma.current,a.context=Na(e,l)),a.state=e.memoizedState,"function"==typeof(l=n.getDerivedStateFromProps)&&(Bl(e,n,l,t),a.state=e.memoizedState),"function"==typeof n.getDerivedStateFromProps||"function"==typeof a.getSnapshotBeforeUpdate||"function"!=typeof a.UNSAFE_componentWillMount&&"function"!=typeof a.componentWillMount||(n=a.state,"function"==typeof a.componentWillMount&&a.componentWillMount(),"function"==typeof a.UNSAFE_componentWillMount&&a.UNSAFE_componentWillMount(),n!==a.state&&$l.enqueueReplaceState(a,a.state,null),Al(e,t,a,r),a.state=e.memoizedState),"function"==typeof a.componentDidMount&&(e.flags|=4194308)}function Wl(e,n,t){if(null!==(e=t.ref)&&"function"!=typeof e&&"object"!=typeof e){if(t._owner){if(t=t._owner){if(1!==t.tag)throw Error(l(309));var r=t.stateNode}if(!r)throw Error(l(147,e));var a=r,o=""+e;return null!==n&&null!==n.ref&&"function"==typeof n.ref&&n.ref._stringRef===o?n.ref:(n=function(e){var n=a.refs;n===Rl&&(n=a.refs={}),null===e?delete n[o]:n[o]=e},n._stringRef=o,n)}if("string"!=typeof e)throw Error(l(284));if(!t._owner)throw Error(l(290,e))}return e}function ql(e,n){throw e=Object.prototype.toString.call(n),Error(l(31,"[object Object]"===e?"object with keys {"+Object.keys(n).join(", ")+"}":e))}function Ql(e){return(0,e._init)(e._payload)}function Kl(e){function n(n,t){if(e){var r=n.deletions;null===r?(n.deletions=[t],n.flags|=16):r.push(t)}}function t(t,r){if(!e)return null;for(;null!==r;)n(t,r),r=r.sibling;return null}function r(e,n){for(e=new Map;null!==n;)null!==n.key?e.set(n.key,n):e.set(n.index,n),n=n.sibling;return e}function a(e,n){return(e=Is(e,n)).index=0,e.sibling=null,e}function o(n,t,r){return n.index=r,e?null!==(r=n.alternate)?(r=r.index)<t?(n.flags|=2,t):r:(n.flags|=2,t):(n.flags|=1048576,t)}function i(n){return e&&null===n.alternate&&(n.flags|=2),n}function u(e,n,t,r){return null===n||6!==n.tag?((n=Ds(t,e.mode,r)).return=e,n):((n=a(n,t)).return=e,n)}function s(e,n,t,r){var l=t.type;return l===S?d(e,n,t.props.children,r,t.key):null!==n&&(n.elementType===l||"object"==typeof l&&null!==l&&l.$$typeof===T&&Ql(l)===n.type)?((r=a(n,t.props)).ref=Wl(e,n,t),r.return=e,r):((r=Os(t.type,t.key,t.props,null,e.mode,r)).ref=Wl(e,n,t),r.return=e,r)}function c(e,n,t,r){return null===n||4!==n.tag||n.stateNode.containerInfo!==t.containerInfo||n.stateNode.implementation!==t.implementation?((n=Rs(t,e.mode,r)).return=e,n):((n=a(n,t.children||[])).return=e,n)}function d(e,n,t,r,l){return null===n||7!==n.tag?((n=Ls(t,e.mode,r,l)).return=e,n):((n=a(n,t)).return=e,n)}function f(e,n,t){if("string"==typeof n&&""!==n||"number"==typeof n)return(n=Ds(""+n,e.mode,t)).return=e,n;if("object"==typeof n&&null!==n){switch(n.$$typeof){case w:return(t=Os(n.type,n.key,n.props,null,e.mode,t)).ref=Wl(e,null,n),t.return=e,t;case k:return(n=Rs(n,e.mode,t)).return=e,n;case T:return f(e,(0,n._init)(n._payload),t)}if(ne(n)||O(n))return(n=Ls(n,e.mode,t,null)).return=e,n;ql(e,n)}return null}function p(e,n,t,r){var a=null!==n?n.key:null;if("string"==typeof t&&""!==t||"number"==typeof t)return null!==a?null:u(e,n,""+t,r);if("object"==typeof t&&null!==t){switch(t.$$typeof){case w:return t.key===a?s(e,n,t,r):null;case k:return t.key===a?c(e,n,t,r):null;case T:return p(e,n,(a=t._init)(t._payload),r)}if(ne(t)||O(t))return null!==a?null:d(e,n,t,r,null);ql(e,t)}return null}function m(e,n,t,r,a){if("string"==typeof r&&""!==r||"number"==typeof r)return u(n,e=e.get(t)||null,""+r,a);if("object"==typeof r&&null!==r){switch(r.$$typeof){case w:return s(n,e=e.get(null===r.key?t:r.key)||null,r,a);case k:return c(n,e=e.get(null===r.key?t:r.key)||null,r,a);case T:return m(e,n,t,(0,r._init)(r._payload),a)}if(ne(r)||O(r))return d(n,e=e.get(t)||null,r,a,null);ql(n,r)}return null}function h(a,l,i,u){for(var s=null,c=null,d=l,h=l=0,v=null;null!==d&&h<i.length;h++){d.index>h?(v=d,d=null):v=d.sibling;var g=p(a,d,i[h],u);if(null===g){null===d&&(d=v);break}e&&d&&null===g.alternate&&n(a,d),l=o(g,l,h),null===c?s=g:c.sibling=g,c=g,d=v}if(h===i.length)return t(a,d),al&&Ga(a,h),s;if(null===d){for(;h<i.length;h++)null!==(d=f(a,i[h],u))&&(l=o(d,l,h),null===c?s=d:c.sibling=d,c=d);return al&&Ga(a,h),s}for(d=r(a,d);h<i.length;h++)null!==(v=m(d,a,h,i[h],u))&&(e&&null!==v.alternate&&d.delete(null===v.key?h:v.key),l=o(v,l,h),null===c?s=v:c.sibling=v,c=v);return e&&d.forEach((function(e){return n(a,e)})),al&&Ga(a,h),s}function v(a,i,u,s){var c=O(u);if("function"!=typeof c)throw Error(l(150));if(null==(u=c.call(u)))throw Error(l(151));for(var d=c=null,h=i,v=i=0,g=null,b=u.next();null!==h&&!b.done;v++,b=u.next()){h.index>v?(g=h,h=null):g=h.sibling;var y=p(a,h,b.value,s);if(null===y){null===h&&(h=g);break}e&&h&&null===y.alternate&&n(a,h),i=o(y,i,v),null===d?c=y:d.sibling=y,d=y,h=g}if(b.done)return t(a,h),al&&Ga(a,v),c;if(null===h){for(;!b.done;v++,b=u.next())null!==(b=f(a,b.value,s))&&(i=o(b,i,v),null===d?c=b:d.sibling=b,d=b);return al&&Ga(a,v),c}for(h=r(a,h);!b.done;v++,b=u.next())null!==(b=m(h,a,v,b.value,s))&&(e&&null!==b.alternate&&h.delete(null===b.key?v:b.key),i=o(b,i,v),null===d?c=b:d.sibling=b,d=b);return e&&h.forEach((function(e){return n(a,e)})),al&&Ga(a,v),c}return function e(r,l,o,u){if("object"==typeof o&&null!==o&&o.type===S&&null===o.key&&(o=o.props.children),"object"==typeof o&&null!==o){switch(o.$$typeof){case w:e:{for(var s=o.key,c=l;null!==c;){if(c.key===s){if((s=o.type)===S){if(7===c.tag){t(r,c.sibling),(l=a(c,o.props.children)).return=r,r=l;break e}}else if(c.elementType===s||"object"==typeof s&&null!==s&&s.$$typeof===T&&Ql(s)===c.type){t(r,c.sibling),(l=a(c,o.props)).ref=Wl(r,c,o),l.return=r,r=l;break e}t(r,c);break}n(r,c),c=c.sibling}o.type===S?((l=Ls(o.props.children,r.mode,u,o.key)).return=r,r=l):((u=Os(o.type,o.key,o.props,null,r.mode,u)).ref=Wl(r,l,o),u.return=r,r=u)}return i(r);case k:e:{for(c=o.key;null!==l;){if(l.key===c){if(4===l.tag&&l.stateNode.containerInfo===o.containerInfo&&l.stateNode.implementation===o.implementation){t(r,l.sibling),(l=a(l,o.children||[])).return=r,r=l;break e}t(r,l);break}n(r,l),l=l.sibling}(l=Rs(o,r.mode,u)).return=r,r=l}return i(r);case T:return e(r,l,(c=o._init)(o._payload),u)}if(ne(o))return h(r,l,o,u);if(O(o))return v(r,l,o,u);ql(r,o)}return"string"==typeof o&&""!==o||"number"==typeof o?(o=""+o,null!==l&&6===l.tag?(t(r,l.sibling),(l=a(l,o)).return=r,r=l):(t(r,l),(l=Ds(o,r.mode,u)).return=r,r=l),i(r)):t(r,l)}}var Xl=Kl(!0),Yl=Kl(!1),Gl={},Jl=Ca(Gl),eo=Ca(Gl),no=Ca(Gl);function to(e){if(e===Gl)throw Error(l(174));return e}function ro(e,n){switch(Pa(no,n),Pa(eo,e),Pa(Jl,Gl),e=n.nodeType){case 9:case 11:n=(n=n.documentElement)?n.namespaceURI:ue(null,"");break;default:n=ue(n=(e=8===e?n.parentNode:n).namespaceURI||null,e=e.tagName)}Ea(Jl),Pa(Jl,n)}function ao(){Ea(Jl),Ea(eo),Ea(no)}function lo(e){to(no.current);var n=to(Jl.current),t=ue(n,e.type);n!==t&&(Pa(eo,e),Pa(Jl,t))}function oo(e){eo.current===e&&(Ea(Jl),Ea(eo))}var io=Ca(0);function uo(e){for(var n=e;null!==n;){if(13===n.tag){var t=n.memoizedState;if(null!==t&&(null===(t=t.dehydrated)||"$?"===t.data||"$!"===t.data))return n}else if(19===n.tag&&void 0!==n.memoizedProps.revealOrder){if(0!=(128&n.flags))return n}else if(null!==n.child){n.child.return=n,n=n.child;continue}if(n===e)break;for(;null===n.sibling;){if(null===n.return||n.return===e)return null;n=n.return}n.sibling.return=n.return,n=n.sibling}return null}var so=[];function co(){for(var e=0;e<so.length;e++)so[e]._workInProgressVersionPrimary=null;so.length=0}var fo=x.ReactCurrentDispatcher,po=x.ReactCurrentBatchConfig,mo=0,ho=null,vo=null,go=null,bo=!1,yo=!1,xo=0,wo=0;function ko(){throw Error(l(321))}function So(e,n){if(null===n)return!1;for(var t=0;t<n.length&&t<e.length;t++)if(!ir(e[t],n[t]))return!1;return!0}function Co(e,n,t,r,a,o){if(mo=o,ho=n,n.memoizedState=null,n.updateQueue=null,n.lanes=0,fo.current=null===e||null===e.memoizedState?ii:ui,e=t(r,a),yo){o=0;do{if(yo=!1,xo=0,25<=o)throw Error(l(301));o+=1,go=vo=null,n.updateQueue=null,fo.current=si,e=t(r,a)}while(yo)}if(fo.current=oi,n=null!==vo&&null!==vo.next,mo=0,go=vo=ho=null,bo=!1,n)throw Error(l(300));return e}function Eo(){var e=0!==xo;return xo=0,e}function Po(){var e={memoizedState:null,baseState:null,baseQueue:null,queue:null,next:null};return null===go?ho.memoizedState=go=e:go=go.next=e,go}function _o(){if(null===vo){var e=ho.alternate;e=null!==e?e.memoizedState:null}else e=vo.next;var n=null===go?ho.memoizedState:go.next;if(null!==n)go=n,vo=e;else{if(null===e)throw Error(l(310));e={memoizedState:(vo=e).memoizedState,baseState:vo.baseState,baseQueue:vo.baseQueue,queue:vo.queue,next:null},null===go?ho.memoizedState=go=e:go=go.next=e}return go}function Mo(e,n){return"function"==typeof n?n(e):n}function jo(e){var n=_o(),t=n.queue;if(null===t)throw Error(l(311));t.lastRenderedReducer=e;var r=vo,a=r.baseQueue,o=t.pending;if(null!==o){if(null!==a){var i=a.next;a.next=o.next,o.next=i}r.baseQueue=a=o,t.pending=null}if(null!==a){o=a.next,r=r.baseState;var u=i=null,s=null,c=o;do{var d=c.lane;if((mo&d)===d)null!==s&&(s=s.next={lane:0,action:c.action,hasEagerState:c.hasEagerState,eagerState:c.eagerState,next:null}),r=c.hasEagerState?c.eagerState:e(r,c.action);else{var f={lane:d,action:c.action,hasEagerState:c.hasEagerState,eagerState:c.eagerState,next:null};null===s?(u=s=f,i=r):s=s.next=f,ho.lanes|=d,Au|=d}c=c.next}while(null!==c&&c!==o);null===s?i=r:s.next=u,ir(r,n.memoizedState)||(xi=!0),n.memoizedState=r,n.baseState=i,n.baseQueue=s,t.lastRenderedState=r}if(null!==(e=t.interleaved)){a=e;do{o=a.lane,ho.lanes|=o,Au|=o,a=a.next}while(a!==e)}else null===a&&(t.lanes=0);return[n.memoizedState,t.dispatch]}function zo(e){var n=_o(),t=n.queue;if(null===t)throw Error(l(311));t.lastRenderedReducer=e;var r=t.dispatch,a=t.pending,o=n.memoizedState;if(null!==a){t.pending=null;var i=a=a.next;do{o=e(o,i.action),i=i.next}while(i!==a);ir(o,n.memoizedState)||(xi=!0),n.memoizedState=o,null===n.baseQueue&&(n.baseState=o),t.lastRenderedState=o}return[o,r]}function No(){}function To(e,n){var t=ho,r=_o(),a=n(),o=!ir(r.memoizedState,a);if(o&&(r.memoizedState=a,xi=!0),r=r.queue,Ho(Oo.bind(null,t,r,e),[e]),r.getSnapshot!==n||o||null!==go&&1&go.memoizedState.tag){if(t.flags|=2048,Ro(9,Io.bind(null,t,r,a,n),void 0,null),null===zu)throw Error(l(349));0!=(30&mo)||Fo(t,n,a)}return a}function Fo(e,n,t){e.flags|=16384,e={getSnapshot:n,value:t},null===(n=ho.updateQueue)?(n={lastEffect:null,stores:null},ho.updateQueue=n,n.stores=[e]):null===(t=n.stores)?n.stores=[e]:t.push(e)}function Io(e,n,t,r){n.value=t,n.getSnapshot=r,Lo(n)&&Ao(e)}function Oo(e,n,t){return t((function(){Lo(n)&&Ao(e)}))}function Lo(e){var n=e.getSnapshot;e=e.value;try{var t=n();return!ir(e,t)}catch(e){return!0}}function Ao(e){var n=jl(e,1);null!==n&&rs(n,e,1,-1)}function Do(e){var n=Po();return"function"==typeof e&&(e=e()),n.memoizedState=n.baseState=e,e={pending:null,interleaved:null,lanes:0,dispatch:null,lastRenderedReducer:Mo,lastRenderedState:e},n.queue=e,e=e.dispatch=ti.bind(null,ho,e),[n.memoizedState,e]}function Ro(e,n,t,r){return e={tag:e,create:n,destroy:t,deps:r,next:null},null===(n=ho.updateQueue)?(n={lastEffect:null,stores:null},ho.updateQueue=n,n.lastEffect=e.next=e):null===(t=n.lastEffect)?n.lastEffect=e.next=e:(r=t.next,t.next=e,e.next=r,n.lastEffect=e),e}function Bo(){return _o().memoizedState}function $o(e,n,t,r){var a=Po();ho.flags|=e,a.memoizedState=Ro(1|n,t,void 0,void 0===r?null:r)}function Uo(e,n,t,r){var a=_o();r=void 0===r?null:r;var l=void 0;if(null!==vo){var o=vo.memoizedState;if(l=o.destroy,null!==r&&So(r,o.deps))return void(a.memoizedState=Ro(n,t,l,r))}ho.flags|=e,a.memoizedState=Ro(1|n,t,l,r)}function Vo(e,n){return $o(8390656,8,e,n)}function Ho(e,n){return Uo(2048,8,e,n)}function Zo(e,n){return Uo(4,2,e,n)}function Wo(e,n){return Uo(4,4,e,n)}function qo(e,n){return"function"==typeof n?(e=e(),n(e),function(){n(null)}):null!=n?(e=e(),n.current=e,function(){n.current=null}):void 0}function Qo(e,n,t){return t=null!=t?t.concat([e]):null,Uo(4,4,qo.bind(null,n,e),t)}function Ko(){}function Xo(e,n){var t=_o();n=void 0===n?null:n;var r=t.memoizedState;return null!==r&&null!==n&&So(n,r[1])?r[0]:(t.memoizedState=[e,n],e)}function Yo(e,n){var t=_o();n=void 0===n?null:n;var r=t.memoizedState;return null!==r&&null!==n&&So(n,r[1])?r[0]:(e=e(),t.memoizedState=[e,n],e)}function Go(e,n,t){return 0==(21&mo)?(e.baseState&&(e.baseState=!1,xi=!0),e.memoizedState=t):(ir(t,n)||(t=vn(),ho.lanes|=t,Au|=t,e.baseState=!0),n)}function Jo(e,n){var t=xn;xn=0!==t&&4>t?t:4,e(!0);var r=po.transition;po.transition={};try{e(!1),n()}finally{xn=t,po.transition=r}}function ei(){return _o().memoizedState}function ni(e,n,t){var r=ts(e);t={lane:r,action:t,hasEagerState:!1,eagerState:null,next:null},ri(e)?ai(n,t):null!==(t=Ml(e,n,t,r))&&(rs(t,e,r,ns()),li(t,n,r))}function ti(e,n,t){var r=ts(e),a={lane:r,action:t,hasEagerState:!1,eagerState:null,next:null};if(ri(e))ai(n,a);else{var l=e.alternate;if(0===e.lanes&&(null===l||0===l.lanes)&&null!==(l=n.lastRenderedReducer))try{var o=n.lastRenderedState,i=l(o,t);if(a.hasEagerState=!0,a.eagerState=i,ir(i,o)){var u=n.interleaved;return null===u?(a.next=a,_l(n)):(a.next=u.next,u.next=a),void(n.interleaved=a)}}catch(e){}null!==(t=Ml(e,n,a,r))&&(rs(t,e,r,a=ns()),li(t,n,r))}}function ri(e){var n=e.alternate;return e===ho||null!==n&&n===ho}function ai(e,n){yo=bo=!0;var t=e.pending;null===t?n.next=n:(n.next=t.next,t.next=n),e.pending=n}function li(e,n,t){if(0!=(4194240&t)){var r=n.lanes;t|=r&=e.pendingLanes,n.lanes=t,yn(e,t)}}var oi={readContext:El,useCallback:ko,useContext:ko,useEffect:ko,useImperativeHandle:ko,useInsertionEffect:ko,useLayoutEffect:ko,useMemo:ko,useReducer:ko,useRef:ko,useState:ko,useDebugValue:ko,useDeferredValue:ko,useTransition:ko,useMutableSource:ko,useSyncExternalStore:ko,useId:ko,unstable_isNewReconciler:!1},ii={readContext:El,useCallback:function(e,n){return Po().memoizedState=[e,void 0===n?null:n],e},useContext:El,useEffect:Vo,useImperativeHandle:function(e,n,t){return t=null!=t?t.concat([e]):null,$o(4194308,4,qo.bind(null,n,e),t)},useLayoutEffect:function(e,n){return $o(4194308,4,e,n)},useInsertionEffect:function(e,n){return $o(4,2,e,n)},useMemo:function(e,n){var t=Po();return n=void 0===n?null:n,e=e(),t.memoizedState=[e,n],e},useReducer:function(e,n,t){var r=Po();return n=void 0!==t?t(n):n,r.memoizedState=r.baseState=n,e={pending:null,interleaved:null,lanes:0,dispatch:null,lastRenderedReducer:e,lastRenderedState:n},r.queue=e,e=e.dispatch=ni.bind(null,ho,e),[r.memoizedState,e]},useRef:function(e){return e={current:e},Po().memoizedState=e},useState:Do,useDebugValue:Ko,useDeferredValue:function(e){return Po().memoizedState=e},useTransition:function(){var e=Do(!1),n=e[0];return e=Jo.bind(null,e[1]),Po().memoizedState=e,[n,e]},useMutableSource:function(){},useSyncExternalStore:function(e,n,t){var r=ho,a=Po();if(al){if(void 0===t)throw Error(l(407));t=t()}else{if(t=n(),null===zu)throw Error(l(349));0!=(30&mo)||Fo(r,n,t)}a.memoizedState=t;var o={value:t,getSnapshot:n};return a.queue=o,Vo(Oo.bind(null,r,o,e),[e]),r.flags|=2048,Ro(9,Io.bind(null,r,o,t,n),void 0,null),t},useId:function(){var e=Po(),n=zu.identifierPrefix;if(al){var t=Ya;n=":"+n+"R"+(t=(Xa&~(1<<32-on(Xa)-1)).toString(32)+t),0<(t=xo++)&&(n+="H"+t.toString(32)),n+=":"}else n=":"+n+"r"+(t=wo++).toString(32)+":";return e.memoizedState=n},unstable_isNewReconciler:!1},ui={readContext:El,useCallback:Xo,useContext:El,useEffect:Ho,useImperativeHandle:Qo,useInsertionEffect:Zo,useLayoutEffect:Wo,useMemo:Yo,useReducer:jo,useRef:Bo,useState:function(){return jo(Mo)},useDebugValue:Ko,useDeferredValue:function(e){return Go(_o(),vo.memoizedState,e)},useTransition:function(){return[jo(Mo)[0],_o().memoizedState]},useMutableSource:No,useSyncExternalStore:To,useId:ei,unstable_isNewReconciler:!1},si={readContext:El,useCallback:Xo,useContext:El,useEffect:Ho,useImperativeHandle:Qo,useInsertionEffect:Zo,useLayoutEffect:Wo,useMemo:Yo,useReducer:zo,useRef:Bo,useState:function(){return zo(Mo)},useDebugValue:Ko,useDeferredValue:function(e){var n=_o();return null===vo?n.memoizedState=e:Go(n,vo.memoizedState,e)},useTransition:function(){return[zo(Mo)[0],_o().memoizedState]},useMutableSource:No,useSyncExternalStore:To,useId:ei,unstable_isNewReconciler:!1};function ci(e,n){try{var t="",r=n;do{t+=$(r),r=r.return}while(r);var a=t}catch(e){a="\nError generating stack: "+e.message+"\n"+e.stack}return{value:e,source:n,stack:a,digest:null}}function di(e,n,t){return{value:e,source:null,stack:null!=t?t:null,digest:null!=n?n:null}}function fi(e,n){try{console.error(n.value)}catch(e){setTimeout((function(){throw e}))}}var pi="function"==typeof WeakMap?WeakMap:Map;function mi(e,n,t){(t=Fl(-1,t)).tag=3,t.payload={element:null};var r=n.value;return t.callback=function(){Zu||(Zu=!0,Wu=r),fi(0,n)},t}function hi(e,n,t){(t=Fl(-1,t)).tag=3;var r=e.type.getDerivedStateFromError;if("function"==typeof r){var a=n.value;t.payload=function(){return r(a)},t.callback=function(){fi(0,n)}}var l=e.stateNode;return null!==l&&"function"==typeof l.componentDidCatch&&(t.callback=function(){fi(0,n),"function"!=typeof r&&(null===qu?qu=new Set([this]):qu.add(this));var e=n.stack;this.componentDidCatch(n.value,{componentStack:null!==e?e:""})}),t}function vi(e,n,t){var r=e.pingCache;if(null===r){r=e.pingCache=new pi;var a=new Set;r.set(n,a)}else void 0===(a=r.get(n))&&(a=new Set,r.set(n,a));a.has(t)||(a.add(t),e=Ps.bind(null,e,n,t),n.then(e,e))}function gi(e){do{var n;if((n=13===e.tag)&&(n=null===(n=e.memoizedState)||null!==n.dehydrated),n)return e;e=e.return}while(null!==e);return null}function bi(e,n,t,r,a){return 0==(1&e.mode)?(e===n?e.flags|=65536:(e.flags|=128,t.flags|=131072,t.flags&=-52805,1===t.tag&&(null===t.alternate?t.tag=17:((n=Fl(-1,1)).tag=2,Il(t,n,1))),t.lanes|=1),e):(e.flags|=65536,e.lanes=a,e)}var yi=x.ReactCurrentOwner,xi=!1;function wi(e,n,t,r){n.child=null===e?Yl(n,null,t,r):Xl(n,e.child,t,r)}function ki(e,n,t,r,a){t=t.render;var l=n.ref;return Cl(n,a),r=Co(e,n,t,r,l,a),t=Eo(),null===e||xi?(al&&t&&el(n),n.flags|=1,wi(e,n,r,a),n.child):(n.updateQueue=e.updateQueue,n.flags&=-2053,e.lanes&=~a,Zi(e,n,a))}function Si(e,n,t,r,a){if(null===e){var l=t.type;return"function"!=typeof l||Fs(l)||void 0!==l.defaultProps||null!==t.compare||void 0!==t.defaultProps?((e=Os(t.type,null,r,n,n.mode,a)).ref=n.ref,e.return=n,n.child=e):(n.tag=15,n.type=l,Ci(e,n,l,r,a))}if(l=e.child,0==(e.lanes&a)){var o=l.memoizedProps;if((t=null!==(t=t.compare)?t:ur)(o,r)&&e.ref===n.ref)return Zi(e,n,a)}return n.flags|=1,(e=Is(l,r)).ref=n.ref,e.return=n,n.child=e}function Ci(e,n,t,r,a){if(null!==e){var l=e.memoizedProps;if(ur(l,r)&&e.ref===n.ref){if(xi=!1,n.pendingProps=r=l,0==(e.lanes&a))return n.lanes=e.lanes,Zi(e,n,a);0!=(131072&e.flags)&&(xi=!0)}}return _i(e,n,t,r,a)}function Ei(e,n,t){var r=n.pendingProps,a=r.children,l=null!==e?e.memoizedState:null;if("hidden"===r.mode)if(0==(1&n.mode))n.memoizedState={baseLanes:0,cachePool:null,transitions:null},Pa(Iu,Fu),Fu|=t;else{if(0==(1073741824&t))return e=null!==l?l.baseLanes|t:t,n.lanes=n.childLanes=1073741824,n.memoizedState={baseLanes:e,cachePool:null,transitions:null},n.updateQueue=null,Pa(Iu,Fu),Fu|=e,null;n.memoizedState={baseLanes:0,cachePool:null,transitions:null},r=null!==l?l.baseLanes:t,Pa(Iu,Fu),Fu|=r}else null!==l?(r=l.baseLanes|t,n.memoizedState=null):r=t,Pa(Iu,Fu),Fu|=r;return wi(e,n,a,t),n.child}function Pi(e,n){var t=n.ref;(null===e&&null!==t||null!==e&&e.ref!==t)&&(n.flags|=512,n.flags|=2097152)}function _i(e,n,t,r,a){var l=Ta(t)?za:Ma.current;return l=Na(n,l),Cl(n,a),t=Co(e,n,t,r,l,a),r=Eo(),null===e||xi?(al&&r&&el(n),n.flags|=1,wi(e,n,t,a),n.child):(n.updateQueue=e.updateQueue,n.flags&=-2053,e.lanes&=~a,Zi(e,n,a))}function Mi(e,n,t,r,a){if(Ta(t)){var l=!0;La(n)}else l=!1;if(Cl(n,a),null===n.stateNode)Hi(e,n),Vl(n,t,r),Zl(n,t,r,a),r=!0;else if(null===e){var o=n.stateNode,i=n.memoizedProps;o.props=i;var u=o.context,s=t.contextType;s="object"==typeof s&&null!==s?El(s):Na(n,s=Ta(t)?za:Ma.current);var c=t.getDerivedStateFromProps,d="function"==typeof c||"function"==typeof o.getSnapshotBeforeUpdate;d||"function"!=typeof o.UNSAFE_componentWillReceiveProps&&"function"!=typeof o.componentWillReceiveProps||(i!==r||u!==s)&&Hl(n,o,r,s),zl=!1;var f=n.memoizedState;o.state=f,Al(n,r,o,a),u=n.memoizedState,i!==r||f!==u||ja.current||zl?("function"==typeof c&&(Bl(n,t,c,r),u=n.memoizedState),(i=zl||Ul(n,t,i,r,f,u,s))?(d||"function"!=typeof o.UNSAFE_componentWillMount&&"function"!=typeof o.componentWillMount||("function"==typeof o.componentWillMount&&o.componentWillMount(),"function"==typeof o.UNSAFE_componentWillMount&&o.UNSAFE_componentWillMount()),"function"==typeof o.componentDidMount&&(n.flags|=4194308)):("function"==typeof o.componentDidMount&&(n.flags|=4194308),n.memoizedProps=r,n.memoizedState=u),o.props=r,o.state=u,o.context=s,r=i):("function"==typeof o.componentDidMount&&(n.flags|=4194308),r=!1)}else{o=n.stateNode,Tl(e,n),i=n.memoizedProps,s=n.type===n.elementType?i:vl(n.type,i),o.props=s,d=n.pendingProps,f=o.context,u="object"==typeof(u=t.contextType)&&null!==u?El(u):Na(n,u=Ta(t)?za:Ma.current);var p=t.getDerivedStateFromProps;(c="function"==typeof p||"function"==typeof o.getSnapshotBeforeUpdate)||"function"!=typeof o.UNSAFE_componentWillReceiveProps&&"function"!=typeof o.componentWillReceiveProps||(i!==d||f!==u)&&Hl(n,o,r,u),zl=!1,f=n.memoizedState,o.state=f,Al(n,r,o,a);var m=n.memoizedState;i!==d||f!==m||ja.current||zl?("function"==typeof p&&(Bl(n,t,p,r),m=n.memoizedState),(s=zl||Ul(n,t,s,r,f,m,u)||!1)?(c||"function"!=typeof o.UNSAFE_componentWillUpdate&&"function"!=typeof o.componentWillUpdate||("function"==typeof o.componentWillUpdate&&o.componentWillUpdate(r,m,u),"function"==typeof o.UNSAFE_componentWillUpdate&&o.UNSAFE_componentWillUpdate(r,m,u)),"function"==typeof o.componentDidUpdate&&(n.flags|=4),"function"==typeof o.getSnapshotBeforeUpdate&&(n.flags|=1024)):("function"!=typeof o.componentDidUpdate||i===e.memoizedProps&&f===e.memoizedState||(n.flags|=4),"function"!=typeof o.getSnapshotBeforeUpdate||i===e.memoizedProps&&f===e.memoizedState||(n.flags|=1024),n.memoizedProps=r,n.memoizedState=m),o.props=r,o.state=m,o.context=u,r=s):("function"!=typeof o.componentDidUpdate||i===e.memoizedProps&&f===e.memoizedState||(n.flags|=4),"function"!=typeof o.getSnapshotBeforeUpdate||i===e.memoizedProps&&f===e.memoizedState||(n.flags|=1024),r=!1)}return ji(e,n,t,r,l,a)}function ji(e,n,t,r,a,l){Pi(e,n);var o=0!=(128&n.flags);if(!r&&!o)return a&&Aa(n,t,!1),Zi(e,n,l);r=n.stateNode,yi.current=n;var i=o&&"function"!=typeof t.getDerivedStateFromError?null:r.render();return n.flags|=1,null!==e&&o?(n.child=Xl(n,e.child,null,l),n.child=Xl(n,null,i,l)):wi(e,n,i,l),n.memoizedState=r.state,a&&Aa(n,t,!0),n.child}function zi(e){var n=e.stateNode;n.pendingContext?Ia(0,n.pendingContext,n.pendingContext!==n.context):n.context&&Ia(0,n.context,!1),ro(e,n.containerInfo)}function Ni(e,n,t,r,a){return pl(),ml(a),n.flags|=256,wi(e,n,t,r),n.child}var Ti,Fi,Ii,Oi,Li={dehydrated:null,treeContext:null,retryLane:0};function Ai(e){return{baseLanes:e,cachePool:null,transitions:null}}function Di(e,n,t){var r,a=n.pendingProps,o=io.current,i=!1,u=0!=(128&n.flags);if((r=u)||(r=(null===e||null!==e.memoizedState)&&0!=(2&o)),r?(i=!0,n.flags&=-129):null!==e&&null===e.memoizedState||(o|=1),Pa(io,1&o),null===e)return sl(n),null!==(e=n.memoizedState)&&null!==(e=e.dehydrated)?(0==(1&n.mode)?n.lanes=1:"$!"===e.data?n.lanes=8:n.lanes=1073741824,null):(u=a.children,e=a.fallback,i?(a=n.mode,i=n.child,u={mode:"hidden",children:u},0==(1&a)&&null!==i?(i.childLanes=0,i.pendingProps=u):i=As(u,a,0,null),e=Ls(e,a,t,null),i.return=n,e.return=n,i.sibling=e,n.child=i,n.child.memoizedState=Ai(t),n.memoizedState=Li,e):Ri(n,u));if(null!==(o=e.memoizedState)&&null!==(r=o.dehydrated))return function(e,n,t,r,a,o,i){if(t)return 256&n.flags?(n.flags&=-257,Bi(e,n,i,r=di(Error(l(422))))):null!==n.memoizedState?(n.child=e.child,n.flags|=128,null):(o=r.fallback,a=n.mode,r=As({mode:"visible",children:r.children},a,0,null),(o=Ls(o,a,i,null)).flags|=2,r.return=n,o.return=n,r.sibling=o,n.child=r,0!=(1&n.mode)&&Xl(n,e.child,null,i),n.child.memoizedState=Ai(i),n.memoizedState=Li,o);if(0==(1&n.mode))return Bi(e,n,i,null);if("$!"===a.data){if(r=a.nextSibling&&a.nextSibling.dataset)var u=r.dgst;return r=u,Bi(e,n,i,r=di(o=Error(l(419)),r,void 0))}if(u=0!=(i&e.childLanes),xi||u){if(null!==(r=zu)){switch(i&-i){case 4:a=2;break;case 16:a=8;break;case 64:case 128:case 256:case 512:case 1024:case 2048:case 4096:case 8192:case 16384:case 32768:case 65536:case 131072:case 262144:case 524288:case 1048576:case 2097152:case 4194304:case 8388608:case 16777216:case 33554432:case 67108864:a=32;break;case 536870912:a=268435456;break;default:a=0}0!==(a=0!=(a&(r.suspendedLanes|i))?0:a)&&a!==o.retryLane&&(o.retryLane=a,jl(e,a),rs(r,e,a,-1))}return vs(),Bi(e,n,i,r=di(Error(l(421))))}return"$?"===a.data?(n.flags|=128,n.child=e.child,n=Ms.bind(null,e),a._reactRetry=n,null):(e=o.treeContext,rl=sa(a.nextSibling),tl=n,al=!0,ll=null,null!==e&&(qa[Qa++]=Xa,qa[Qa++]=Ya,qa[Qa++]=Ka,Xa=e.id,Ya=e.overflow,Ka=n),(n=Ri(n,r.children)).flags|=4096,n)}(e,n,u,a,r,o,t);if(i){i=a.fallback,u=n.mode,r=(o=e.child).sibling;var s={mode:"hidden",children:a.children};return 0==(1&u)&&n.child!==o?((a=n.child).childLanes=0,a.pendingProps=s,n.deletions=null):(a=Is(o,s)).subtreeFlags=14680064&o.subtreeFlags,null!==r?i=Is(r,i):(i=Ls(i,u,t,null)).flags|=2,i.return=n,a.return=n,a.sibling=i,n.child=a,a=i,i=n.child,u=null===(u=e.child.memoizedState)?Ai(t):{baseLanes:u.baseLanes|t,cachePool:null,transitions:u.transitions},i.memoizedState=u,i.childLanes=e.childLanes&~t,n.memoizedState=Li,a}return e=(i=e.child).sibling,a=Is(i,{mode:"visible",children:a.children}),0==(1&n.mode)&&(a.lanes=t),a.return=n,a.sibling=null,null!==e&&(null===(t=n.deletions)?(n.deletions=[e],n.flags|=16):t.push(e)),n.child=a,n.memoizedState=null,a}function Ri(e,n){return(n=As({mode:"visible",children:n},e.mode,0,null)).return=e,e.child=n}function Bi(e,n,t,r){return null!==r&&ml(r),Xl(n,e.child,null,t),(e=Ri(n,n.pendingProps.children)).flags|=2,n.memoizedState=null,e}function $i(e,n,t){e.lanes|=n;var r=e.alternate;null!==r&&(r.lanes|=n),Sl(e.return,n,t)}function Ui(e,n,t,r,a){var l=e.memoizedState;null===l?e.memoizedState={isBackwards:n,rendering:null,renderingStartTime:0,last:r,tail:t,tailMode:a}:(l.isBackwards=n,l.rendering=null,l.renderingStartTime=0,l.last=r,l.tail=t,l.tailMode=a)}function Vi(e,n,t){var r=n.pendingProps,a=r.revealOrder,l=r.tail;if(wi(e,n,r.children,t),0!=(2&(r=io.current)))r=1&r|2,n.flags|=128;else{if(null!==e&&0!=(128&e.flags))e:for(e=n.child;null!==e;){if(13===e.tag)null!==e.memoizedState&&$i(e,t,n);else if(19===e.tag)$i(e,t,n);else if(null!==e.child){e.child.return=e,e=e.child;continue}if(e===n)break e;for(;null===e.sibling;){if(null===e.return||e.return===n)break e;e=e.return}e.sibling.return=e.return,e=e.sibling}r&=1}if(Pa(io,r),0==(1&n.mode))n.memoizedState=null;else switch(a){case"forwards":for(t=n.child,a=null;null!==t;)null!==(e=t.alternate)&&null===uo(e)&&(a=t),t=t.sibling;null===(t=a)?(a=n.child,n.child=null):(a=t.sibling,t.sibling=null),Ui(n,!1,a,t,l);break;case"backwards":for(t=null,a=n.child,n.child=null;null!==a;){if(null!==(e=a.alternate)&&null===uo(e)){n.child=a;break}e=a.sibling,a.sibling=t,t=a,a=e}Ui(n,!0,t,null,l);break;case"together":Ui(n,!1,null,null,void 0);break;default:n.memoizedState=null}return n.child}function Hi(e,n){0==(1&n.mode)&&null!==e&&(e.alternate=null,n.alternate=null,n.flags|=2)}function Zi(e,n,t){if(null!==e&&(n.dependencies=e.dependencies),Au|=n.lanes,0==(t&n.childLanes))return null;if(null!==e&&n.child!==e.child)throw Error(l(153));if(null!==n.child){for(t=Is(e=n.child,e.pendingProps),n.child=t,t.return=n;null!==e.sibling;)e=e.sibling,(t=t.sibling=Is(e,e.pendingProps)).return=n;t.sibling=null}return n.child}function Wi(e,n){if(!al)switch(e.tailMode){case"hidden":n=e.tail;for(var t=null;null!==n;)null!==n.alternate&&(t=n),n=n.sibling;null===t?e.tail=null:t.sibling=null;break;case"collapsed":t=e.tail;for(var r=null;null!==t;)null!==t.alternate&&(r=t),t=t.sibling;null===r?n||null===e.tail?e.tail=null:e.tail.sibling=null:r.sibling=null}}function qi(e){var n=null!==e.alternate&&e.alternate.child===e.child,t=0,r=0;if(n)for(var a=e.child;null!==a;)t|=a.lanes|a.childLanes,r|=14680064&a.subtreeFlags,r|=14680064&a.flags,a.return=e,a=a.sibling;else for(a=e.child;null!==a;)t|=a.lanes|a.childLanes,r|=a.subtreeFlags,r|=a.flags,a.return=e,a=a.sibling;return e.subtreeFlags|=r,e.childLanes=t,n}function Qi(e,n,t){var r=n.pendingProps;switch(nl(n),n.tag){case 2:case 16:case 15:case 0:case 11:case 7:case 8:case 12:case 9:case 14:return qi(n),null;case 1:case 17:return Ta(n.type)&&Fa(),qi(n),null;case 3:return r=n.stateNode,ao(),Ea(ja),Ea(Ma),co(),r.pendingContext&&(r.context=r.pendingContext,r.pendingContext=null),null!==e&&null!==e.child||(dl(n)?n.flags|=4:null===e||e.memoizedState.isDehydrated&&0==(256&n.flags)||(n.flags|=1024,null!==ll&&(is(ll),ll=null))),Fi(e,n),qi(n),null;case 5:oo(n);var a=to(no.current);if(t=n.type,null!==e&&null!=n.stateNode)Ii(e,n,t,r,a),e.ref!==n.ref&&(n.flags|=512,n.flags|=2097152);else{if(!r){if(null===n.stateNode)throw Error(l(166));return qi(n),null}if(e=to(Jl.current),dl(n)){r=n.stateNode,t=n.type;var o=n.memoizedProps;switch(r[fa]=n,r[pa]=o,e=0!=(1&n.mode),t){case"dialog":Rr("cancel",r),Rr("close",r);break;case"iframe":case"object":case"embed":Rr("load",r);break;case"video":case"audio":for(a=0;a<Or.length;a++)Rr(Or[a],r);break;case"source":Rr("error",r);break;case"img":case"image":case"link":Rr("error",r),Rr("load",r);break;case"details":Rr("toggle",r);break;case"input":X(r,o),Rr("invalid",r);break;case"select":r._wrapperState={wasMultiple:!!o.multiple},Rr("invalid",r);break;case"textarea":ae(r,o),Rr("invalid",r)}for(var u in be(t,o),a=null,o)if(o.hasOwnProperty(u)){var s=o[u];"children"===u?"string"==typeof s?r.textContent!==s&&(!0!==o.suppressHydrationWarning&&Gr(r.textContent,s,e),a=["children",s]):"number"==typeof s&&r.textContent!==""+s&&(!0!==o.suppressHydrationWarning&&Gr(r.textContent,s,e),a=["children",""+s]):i.hasOwnProperty(u)&&null!=s&&"onScroll"===u&&Rr("scroll",r)}switch(t){case"input":W(r),J(r,o,!0);break;case"textarea":W(r),oe(r);break;case"select":case"option":break;default:"function"==typeof o.onClick&&(r.onclick=Jr)}r=a,n.updateQueue=r,null!==r&&(n.flags|=4)}else{u=9===a.nodeType?a:a.ownerDocument,"http://www.w3.org/1999/xhtml"===e&&(e=ie(t)),"http://www.w3.org/1999/xhtml"===e?"script"===t?((e=u.createElement("div")).innerHTML="<script><\/script>",e=e.removeChild(e.firstChild)):"string"==typeof r.is?e=u.createElement(t,{is:r.is}):(e=u.createElement(t),"select"===t&&(u=e,r.multiple?u.multiple=!0:r.size&&(u.size=r.size))):e=u.createElementNS(e,t),e[fa]=n,e[pa]=r,Ti(e,n,!1,!1),n.stateNode=e;e:{switch(u=ye(t,r),t){case"dialog":Rr("cancel",e),Rr("close",e),a=r;break;case"iframe":case"object":case"embed":Rr("load",e),a=r;break;case"video":case"audio":for(a=0;a<Or.length;a++)Rr(Or[a],e);a=r;break;case"source":Rr("error",e),a=r;break;case"img":case"image":case"link":Rr("error",e),Rr("load",e),a=r;break;case"details":Rr("toggle",e),a=r;break;case"input":X(e,r),a=K(e,r),Rr("invalid",e);break;case"option":default:a=r;break;case"select":e._wrapperState={wasMultiple:!!r.multiple},a=A({},r,{value:void 0}),Rr("invalid",e);break;case"textarea":ae(e,r),a=re(e,r),Rr("invalid",e)}for(o in be(t,a),s=a)if(s.hasOwnProperty(o)){var c=s[o];"style"===o?ve(e,c):"dangerouslySetInnerHTML"===o?null!=(c=c?c.__html:void 0)&&de(e,c):"children"===o?"string"==typeof c?("textarea"!==t||""!==c)&&fe(e,c):"number"==typeof c&&fe(e,""+c):"suppressContentEditableWarning"!==o&&"suppressHydrationWarning"!==o&&"autoFocus"!==o&&(i.hasOwnProperty(o)?null!=c&&"onScroll"===o&&Rr("scroll",e):null!=c&&y(e,o,c,u))}switch(t){case"input":W(e),J(e,r,!1);break;case"textarea":W(e),oe(e);break;case"option":null!=r.value&&e.setAttribute("value",""+H(r.value));break;case"select":e.multiple=!!r.multiple,null!=(o=r.value)?te(e,!!r.multiple,o,!1):null!=r.defaultValue&&te(e,!!r.multiple,r.defaultValue,!0);break;default:"function"==typeof a.onClick&&(e.onclick=Jr)}switch(t){case"button":case"input":case"select":case"textarea":r=!!r.autoFocus;break e;case"img":r=!0;break e;default:r=!1}}r&&(n.flags|=4)}null!==n.ref&&(n.flags|=512,n.flags|=2097152)}return qi(n),null;case 6:if(e&&null!=n.stateNode)Oi(e,n,e.memoizedProps,r);else{if("string"!=typeof r&&null===n.stateNode)throw Error(l(166));if(t=to(no.current),to(Jl.current),dl(n)){if(r=n.stateNode,t=n.memoizedProps,r[fa]=n,(o=r.nodeValue!==t)&&null!==(e=tl))switch(e.tag){case 3:Gr(r.nodeValue,t,0!=(1&e.mode));break;case 5:!0!==e.memoizedProps.suppressHydrationWarning&&Gr(r.nodeValue,t,0!=(1&e.mode))}o&&(n.flags|=4)}else(r=(9===t.nodeType?t:t.ownerDocument).createTextNode(r))[fa]=n,n.stateNode=r}return qi(n),null;case 13:if(Ea(io),r=n.memoizedState,null===e||null!==e.memoizedState&&null!==e.memoizedState.dehydrated){if(al&&null!==rl&&0!=(1&n.mode)&&0==(128&n.flags))fl(),pl(),n.flags|=98560,o=!1;else if(o=dl(n),null!==r&&null!==r.dehydrated){if(null===e){if(!o)throw Error(l(318));if(!(o=null!==(o=n.memoizedState)?o.dehydrated:null))throw Error(l(317));o[fa]=n}else pl(),0==(128&n.flags)&&(n.memoizedState=null),n.flags|=4;qi(n),o=!1}else null!==ll&&(is(ll),ll=null),o=!0;if(!o)return 65536&n.flags?n:null}return 0!=(128&n.flags)?(n.lanes=t,n):((r=null!==r)!=(null!==e&&null!==e.memoizedState)&&r&&(n.child.flags|=8192,0!=(1&n.mode)&&(null===e||0!=(1&io.current)?0===Ou&&(Ou=3):vs())),null!==n.updateQueue&&(n.flags|=4),qi(n),null);case 4:return ao(),Fi(e,n),null===e&&Ur(n.stateNode.containerInfo),qi(n),null;case 10:return kl(n.type._context),qi(n),null;case 19:if(Ea(io),null===(o=n.memoizedState))return qi(n),null;if(r=0!=(128&n.flags),null===(u=o.rendering))if(r)Wi(o,!1);else{if(0!==Ou||null!==e&&0!=(128&e.flags))for(e=n.child;null!==e;){if(null!==(u=uo(e))){for(n.flags|=128,Wi(o,!1),null!==(r=u.updateQueue)&&(n.updateQueue=r,n.flags|=4),n.subtreeFlags=0,r=t,t=n.child;null!==t;)e=r,(o=t).flags&=14680066,null===(u=o.alternate)?(o.childLanes=0,o.lanes=e,o.child=null,o.subtreeFlags=0,o.memoizedProps=null,o.memoizedState=null,o.updateQueue=null,o.dependencies=null,o.stateNode=null):(o.childLanes=u.childLanes,o.lanes=u.lanes,o.child=u.child,o.subtreeFlags=0,o.deletions=null,o.memoizedProps=u.memoizedProps,o.memoizedState=u.memoizedState,o.updateQueue=u.updateQueue,o.type=u.type,e=u.dependencies,o.dependencies=null===e?null:{lanes:e.lanes,firstContext:e.firstContext}),t=t.sibling;return Pa(io,1&io.current|2),n.child}e=e.sibling}null!==o.tail&&Ye()>Vu&&(n.flags|=128,r=!0,Wi(o,!1),n.lanes=4194304)}else{if(!r)if(null!==(e=uo(u))){if(n.flags|=128,r=!0,null!==(t=e.updateQueue)&&(n.updateQueue=t,n.flags|=4),Wi(o,!0),null===o.tail&&"hidden"===o.tailMode&&!u.alternate&&!al)return qi(n),null}else 2*Ye()-o.renderingStartTime>Vu&&1073741824!==t&&(n.flags|=128,r=!0,Wi(o,!1),n.lanes=4194304);o.isBackwards?(u.sibling=n.child,n.child=u):(null!==(t=o.last)?t.sibling=u:n.child=u,o.last=u)}return null!==o.tail?(n=o.tail,o.rendering=n,o.tail=n.sibling,o.renderingStartTime=Ye(),n.sibling=null,t=io.current,Pa(io,r?1&t|2:1&t),n):(qi(n),null);case 22:case 23:return fs(),r=null!==n.memoizedState,null!==e&&null!==e.memoizedState!==r&&(n.flags|=8192),r&&0!=(1&n.mode)?0!=(1073741824&Fu)&&(qi(n),6&n.subtreeFlags&&(n.flags|=8192)):qi(n),null;case 24:case 25:return null}throw Error(l(156,n.tag))}function Ki(e,n){switch(nl(n),n.tag){case 1:return Ta(n.type)&&Fa(),65536&(e=n.flags)?(n.flags=-65537&e|128,n):null;case 3:return ao(),Ea(ja),Ea(Ma),co(),0!=(65536&(e=n.flags))&&0==(128&e)?(n.flags=-65537&e|128,n):null;case 5:return oo(n),null;case 13:if(Ea(io),null!==(e=n.memoizedState)&&null!==e.dehydrated){if(null===n.alternate)throw Error(l(340));pl()}return 65536&(e=n.flags)?(n.flags=-65537&e|128,n):null;case 19:return Ea(io),null;case 4:return ao(),null;case 10:return kl(n.type._context),null;case 22:case 23:return fs(),null;default:return null}}Ti=function(e,n){for(var t=n.child;null!==t;){if(5===t.tag||6===t.tag)e.appendChild(t.stateNode);else if(4!==t.tag&&null!==t.child){t.child.return=t,t=t.child;continue}if(t===n)break;for(;null===t.sibling;){if(null===t.return||t.return===n)return;t=t.return}t.sibling.return=t.return,t=t.sibling}},Fi=function(){},Ii=function(e,n,t,r){var a=e.memoizedProps;if(a!==r){e=n.stateNode,to(Jl.current);var l,o=null;switch(t){case"input":a=K(e,a),r=K(e,r),o=[];break;case"select":a=A({},a,{value:void 0}),r=A({},r,{value:void 0}),o=[];break;case"textarea":a=re(e,a),r=re(e,r),o=[];break;default:"function"!=typeof a.onClick&&"function"==typeof r.onClick&&(e.onclick=Jr)}for(c in be(t,r),t=null,a)if(!r.hasOwnProperty(c)&&a.hasOwnProperty(c)&&null!=a[c])if("style"===c){var u=a[c];for(l in u)u.hasOwnProperty(l)&&(t||(t={}),t[l]="")}else"dangerouslySetInnerHTML"!==c&&"children"!==c&&"suppressContentEditableWarning"!==c&&"suppressHydrationWarning"!==c&&"autoFocus"!==c&&(i.hasOwnProperty(c)?o||(o=[]):(o=o||[]).push(c,null));for(c in r){var s=r[c];if(u=null!=a?a[c]:void 0,r.hasOwnProperty(c)&&s!==u&&(null!=s||null!=u))if("style"===c)if(u){for(l in u)!u.hasOwnProperty(l)||s&&s.hasOwnProperty(l)||(t||(t={}),t[l]="");for(l in s)s.hasOwnProperty(l)&&u[l]!==s[l]&&(t||(t={}),t[l]=s[l])}else t||(o||(o=[]),o.push(c,t)),t=s;else"dangerouslySetInnerHTML"===c?(s=s?s.__html:void 0,u=u?u.__html:void 0,null!=s&&u!==s&&(o=o||[]).push(c,s)):"children"===c?"string"!=typeof s&&"number"!=typeof s||(o=o||[]).push(c,""+s):"suppressContentEditableWarning"!==c&&"suppressHydrationWarning"!==c&&(i.hasOwnProperty(c)?(null!=s&&"onScroll"===c&&Rr("scroll",e),o||u===s||(o=[])):(o=o||[]).push(c,s))}t&&(o=o||[]).push("style",t);var c=o;(n.updateQueue=c)&&(n.flags|=4)}},Oi=function(e,n,t,r){t!==r&&(n.flags|=4)};var Xi=!1,Yi=!1,Gi="function"==typeof WeakSet?WeakSet:Set,Ji=null;function eu(e,n){var t=e.ref;if(null!==t)if("function"==typeof t)try{t(null)}catch(t){Es(e,n,t)}else t.current=null}function nu(e,n,t){try{t()}catch(t){Es(e,n,t)}}var tu=!1;function ru(e,n,t){var r=n.updateQueue;if(null!==(r=null!==r?r.lastEffect:null)){var a=r=r.next;do{if((a.tag&e)===e){var l=a.destroy;a.destroy=void 0,void 0!==l&&nu(n,t,l)}a=a.next}while(a!==r)}}function au(e,n){if(null!==(n=null!==(n=n.updateQueue)?n.lastEffect:null)){var t=n=n.next;do{if((t.tag&e)===e){var r=t.create;t.destroy=r()}t=t.next}while(t!==n)}}function lu(e){var n=e.ref;if(null!==n){var t=e.stateNode;e.tag,e=t,"function"==typeof n?n(e):n.current=e}}function ou(e){var n=e.alternate;null!==n&&(e.alternate=null,ou(n)),e.child=null,e.deletions=null,e.sibling=null,5===e.tag&&null!==(n=e.stateNode)&&(delete n[fa],delete n[pa],delete n[ha],delete n[va],delete n[ga]),e.stateNode=null,e.return=null,e.dependencies=null,e.memoizedProps=null,e.memoizedState=null,e.pendingProps=null,e.stateNode=null,e.updateQueue=null}function iu(e){return 5===e.tag||3===e.tag||4===e.tag}function uu(e){e:for(;;){for(;null===e.sibling;){if(null===e.return||iu(e.return))return null;e=e.return}for(e.sibling.return=e.return,e=e.sibling;5!==e.tag&&6!==e.tag&&18!==e.tag;){if(2&e.flags)continue e;if(null===e.child||4===e.tag)continue e;e.child.return=e,e=e.child}if(!(2&e.flags))return e.stateNode}}function su(e,n,t){var r=e.tag;if(5===r||6===r)e=e.stateNode,n?8===t.nodeType?t.parentNode.insertBefore(e,n):t.insertBefore(e,n):(8===t.nodeType?(n=t.parentNode).insertBefore(e,t):(n=t).appendChild(e),null!=(t=t._reactRootContainer)||null!==n.onclick||(n.onclick=Jr));else if(4!==r&&null!==(e=e.child))for(su(e,n,t),e=e.sibling;null!==e;)su(e,n,t),e=e.sibling}function cu(e,n,t){var r=e.tag;if(5===r||6===r)e=e.stateNode,n?t.insertBefore(e,n):t.appendChild(e);else if(4!==r&&null!==(e=e.child))for(cu(e,n,t),e=e.sibling;null!==e;)cu(e,n,t),e=e.sibling}var du=null,fu=!1;function pu(e,n,t){for(t=t.child;null!==t;)mu(e,n,t),t=t.sibling}function mu(e,n,t){if(ln&&"function"==typeof ln.onCommitFiberUnmount)try{ln.onCommitFiberUnmount(an,t)}catch(e){}switch(t.tag){case 5:Yi||eu(t,n);case 6:var r=du,a=fu;du=null,pu(e,n,t),fu=a,null!==(du=r)&&(fu?(e=du,t=t.stateNode,8===e.nodeType?e.parentNode.removeChild(t):e.removeChild(t)):du.removeChild(t.stateNode));break;case 18:null!==du&&(fu?(e=du,t=t.stateNode,8===e.nodeType?ua(e.parentNode,t):1===e.nodeType&&ua(e,t),Vn(e)):ua(du,t.stateNode));break;case 4:r=du,a=fu,du=t.stateNode.containerInfo,fu=!0,pu(e,n,t),du=r,fu=a;break;case 0:case 11:case 14:case 15:if(!Yi&&null!==(r=t.updateQueue)&&null!==(r=r.lastEffect)){a=r=r.next;do{var l=a,o=l.destroy;l=l.tag,void 0!==o&&(0!=(2&l)||0!=(4&l))&&nu(t,n,o),a=a.next}while(a!==r)}pu(e,n,t);break;case 1:if(!Yi&&(eu(t,n),"function"==typeof(r=t.stateNode).componentWillUnmount))try{r.props=t.memoizedProps,r.state=t.memoizedState,r.componentWillUnmount()}catch(e){Es(t,n,e)}pu(e,n,t);break;case 21:pu(e,n,t);break;case 22:1&t.mode?(Yi=(r=Yi)||null!==t.memoizedState,pu(e,n,t),Yi=r):pu(e,n,t);break;default:pu(e,n,t)}}function hu(e){var n=e.updateQueue;if(null!==n){e.updateQueue=null;var t=e.stateNode;null===t&&(t=e.stateNode=new Gi),n.forEach((function(n){var r=js.bind(null,e,n);t.has(n)||(t.add(n),n.then(r,r))}))}}function vu(e,n){var t=n.deletions;if(null!==t)for(var r=0;r<t.length;r++){var a=t[r];try{var o=e,i=n,u=i;e:for(;null!==u;){switch(u.tag){case 5:du=u.stateNode,fu=!1;break e;case 3:case 4:du=u.stateNode.containerInfo,fu=!0;break e}u=u.return}if(null===du)throw Error(l(160));mu(o,i,a),du=null,fu=!1;var s=a.alternate;null!==s&&(s.return=null),a.return=null}catch(e){Es(a,n,e)}}if(12854&n.subtreeFlags)for(n=n.child;null!==n;)gu(n,e),n=n.sibling}function gu(e,n){var t=e.alternate,r=e.flags;switch(e.tag){case 0:case 11:case 14:case 15:if(vu(n,e),bu(e),4&r){try{ru(3,e,e.return),au(3,e)}catch(n){Es(e,e.return,n)}try{ru(5,e,e.return)}catch(n){Es(e,e.return,n)}}break;case 1:vu(n,e),bu(e),512&r&&null!==t&&eu(t,t.return);break;case 5:if(vu(n,e),bu(e),512&r&&null!==t&&eu(t,t.return),32&e.flags){var a=e.stateNode;try{fe(a,"")}catch(n){Es(e,e.return,n)}}if(4&r&&null!=(a=e.stateNode)){var o=e.memoizedProps,i=null!==t?t.memoizedProps:o,u=e.type,s=e.updateQueue;if(e.updateQueue=null,null!==s)try{"input"===u&&"radio"===o.type&&null!=o.name&&Y(a,o),ye(u,i);var c=ye(u,o);for(i=0;i<s.length;i+=2){var d=s[i],f=s[i+1];"style"===d?ve(a,f):"dangerouslySetInnerHTML"===d?de(a,f):"children"===d?fe(a,f):y(a,d,f,c)}switch(u){case"input":G(a,o);break;case"textarea":le(a,o);break;case"select":var p=a._wrapperState.wasMultiple;a._wrapperState.wasMultiple=!!o.multiple;var m=o.value;null!=m?te(a,!!o.multiple,m,!1):p!==!!o.multiple&&(null!=o.defaultValue?te(a,!!o.multiple,o.defaultValue,!0):te(a,!!o.multiple,o.multiple?[]:"",!1))}a[pa]=o}catch(n){Es(e,e.return,n)}}break;case 6:if(vu(n,e),bu(e),4&r){if(null===e.stateNode)throw Error(l(162));a=e.stateNode,o=e.memoizedProps;try{a.nodeValue=o}catch(n){Es(e,e.return,n)}}break;case 3:if(vu(n,e),bu(e),4&r&&null!==t&&t.memoizedState.isDehydrated)try{Vn(n.containerInfo)}catch(n){Es(e,e.return,n)}break;case 4:default:vu(n,e),bu(e);break;case 13:vu(n,e),bu(e),8192&(a=e.child).flags&&(o=null!==a.memoizedState,a.stateNode.isHidden=o,!o||null!==a.alternate&&null!==a.alternate.memoizedState||(Uu=Ye())),4&r&&hu(e);break;case 22:if(d=null!==t&&null!==t.memoizedState,1&e.mode?(Yi=(c=Yi)||d,vu(n,e),Yi=c):vu(n,e),bu(e),8192&r){if(c=null!==e.memoizedState,(e.stateNode.isHidden=c)&&!d&&0!=(1&e.mode))for(Ji=e,d=e.child;null!==d;){for(f=Ji=d;null!==Ji;){switch(m=(p=Ji).child,p.tag){case 0:case 11:case 14:case 15:ru(4,p,p.return);break;case 1:eu(p,p.return);var h=p.stateNode;if("function"==typeof h.componentWillUnmount){r=p,t=p.return;try{n=r,h.props=n.memoizedProps,h.state=n.memoizedState,h.componentWillUnmount()}catch(e){Es(r,t,e)}}break;case 5:eu(p,p.return);break;case 22:if(null!==p.memoizedState){ku(f);continue}}null!==m?(m.return=p,Ji=m):ku(f)}d=d.sibling}e:for(d=null,f=e;;){if(5===f.tag){if(null===d){d=f;try{a=f.stateNode,c?"function"==typeof(o=a.style).setProperty?o.setProperty("display","none","important"):o.display="none":(u=f.stateNode,i=null!=(s=f.memoizedProps.style)&&s.hasOwnProperty("display")?s.display:null,u.style.display=he("display",i))}catch(n){Es(e,e.return,n)}}}else if(6===f.tag){if(null===d)try{f.stateNode.nodeValue=c?"":f.memoizedProps}catch(n){Es(e,e.return,n)}}else if((22!==f.tag&&23!==f.tag||null===f.memoizedState||f===e)&&null!==f.child){f.child.return=f,f=f.child;continue}if(f===e)break e;for(;null===f.sibling;){if(null===f.return||f.return===e)break e;d===f&&(d=null),f=f.return}d===f&&(d=null),f.sibling.return=f.return,f=f.sibling}}break;case 19:vu(n,e),bu(e),4&r&&hu(e);case 21:}}function bu(e){var n=e.flags;if(2&n){try{e:{for(var t=e.return;null!==t;){if(iu(t)){var r=t;break e}t=t.return}throw Error(l(160))}switch(r.tag){case 5:var a=r.stateNode;32&r.flags&&(fe(a,""),r.flags&=-33),cu(e,uu(e),a);break;case 3:case 4:var o=r.stateNode.containerInfo;su(e,uu(e),o);break;default:throw Error(l(161))}}catch(n){Es(e,e.return,n)}e.flags&=-3}4096&n&&(e.flags&=-4097)}function yu(e,n,t){Ji=e,xu(e,n,t)}function xu(e,n,t){for(var r=0!=(1&e.mode);null!==Ji;){var a=Ji,l=a.child;if(22===a.tag&&r){var o=null!==a.memoizedState||Xi;if(!o){var i=a.alternate,u=null!==i&&null!==i.memoizedState||Yi;i=Xi;var s=Yi;if(Xi=o,(Yi=u)&&!s)for(Ji=a;null!==Ji;)u=(o=Ji).child,22===o.tag&&null!==o.memoizedState?Su(a):null!==u?(u.return=o,Ji=u):Su(a);for(;null!==l;)Ji=l,xu(l,n,t),l=l.sibling;Ji=a,Xi=i,Yi=s}wu(e)}else 0!=(8772&a.subtreeFlags)&&null!==l?(l.return=a,Ji=l):wu(e)}}function wu(e){for(;null!==Ji;){var n=Ji;if(0!=(8772&n.flags)){var t=n.alternate;try{if(0!=(8772&n.flags))switch(n.tag){case 0:case 11:case 15:Yi||au(5,n);break;case 1:var r=n.stateNode;if(4&n.flags&&!Yi)if(null===t)r.componentDidMount();else{var a=n.elementType===n.type?t.memoizedProps:vl(n.type,t.memoizedProps);r.componentDidUpdate(a,t.memoizedState,r.__reactInternalSnapshotBeforeUpdate)}var o=n.updateQueue;null!==o&&Dl(n,o,r);break;case 3:var i=n.updateQueue;if(null!==i){if(t=null,null!==n.child)switch(n.child.tag){case 5:case 1:t=n.child.stateNode}Dl(n,i,t)}break;case 5:var u=n.stateNode;if(null===t&&4&n.flags){t=u;var s=n.memoizedProps;switch(n.type){case"button":case"input":case"select":case"textarea":s.autoFocus&&t.focus();break;case"img":s.src&&(t.src=s.src)}}break;case 6:case 4:case 12:case 19:case 17:case 21:case 22:case 23:case 25:break;case 13:if(null===n.memoizedState){var c=n.alternate;if(null!==c){var d=c.memoizedState;if(null!==d){var f=d.dehydrated;null!==f&&Vn(f)}}}break;default:throw Error(l(163))}Yi||512&n.flags&&lu(n)}catch(e){Es(n,n.return,e)}}if(n===e){Ji=null;break}if(null!==(t=n.sibling)){t.return=n.return,Ji=t;break}Ji=n.return}}function ku(e){for(;null!==Ji;){var n=Ji;if(n===e){Ji=null;break}var t=n.sibling;if(null!==t){t.return=n.return,Ji=t;break}Ji=n.return}}function Su(e){for(;null!==Ji;){var n=Ji;try{switch(n.tag){case 0:case 11:case 15:var t=n.return;try{au(4,n)}catch(e){Es(n,t,e)}break;case 1:var r=n.stateNode;if("function"==typeof r.componentDidMount){var a=n.return;try{r.componentDidMount()}catch(e){Es(n,a,e)}}var l=n.return;try{lu(n)}catch(e){Es(n,l,e)}break;case 5:var o=n.return;try{lu(n)}catch(e){Es(n,o,e)}}}catch(e){Es(n,n.return,e)}if(n===e){Ji=null;break}var i=n.sibling;if(null!==i){i.return=n.return,Ji=i;break}Ji=n.return}}var Cu,Eu=Math.ceil,Pu=x.ReactCurrentDispatcher,_u=x.ReactCurrentOwner,Mu=x.ReactCurrentBatchConfig,ju=0,zu=null,Nu=null,Tu=0,Fu=0,Iu=Ca(0),Ou=0,Lu=null,Au=0,Du=0,Ru=0,Bu=null,$u=null,Uu=0,Vu=1/0,Hu=null,Zu=!1,Wu=null,qu=null,Qu=!1,Ku=null,Xu=0,Yu=0,Gu=null,Ju=-1,es=0;function ns(){return 0!=(6&ju)?Ye():-1!==Ju?Ju:Ju=Ye()}function ts(e){return 0==(1&e.mode)?1:0!=(2&ju)&&0!==Tu?Tu&-Tu:null!==hl.transition?(0===es&&(es=vn()),es):0!==(e=xn)?e:e=void 0===(e=window.event)?16:Yn(e.type)}function rs(e,n,t,r){if(50<Yu)throw Yu=0,Gu=null,Error(l(185));bn(e,t,r),0!=(2&ju)&&e===zu||(e===zu&&(0==(2&ju)&&(Du|=t),4===Ou&&us(e,Tu)),as(e,r),1===t&&0===ju&&0==(1&n.mode)&&(Vu=Ye()+500,Ra&&Ua()))}function as(e,n){var t=e.callbackNode;!function(e,n){for(var t=e.suspendedLanes,r=e.pingedLanes,a=e.expirationTimes,l=e.pendingLanes;0<l;){var o=31-on(l),i=1<<o,u=a[o];-1===u?0!=(i&t)&&0==(i&r)||(a[o]=mn(i,n)):u<=n&&(e.expiredLanes|=i),l&=~i}}(e,n);var r=pn(e,e===zu?Tu:0);if(0===r)null!==t&&Qe(t),e.callbackNode=null,e.callbackPriority=0;else if(n=r&-r,e.callbackPriority!==n){if(null!=t&&Qe(t),1===n)0===e.tag?function(e){Ra=!0,$a(e)}(ss.bind(null,e)):$a(ss.bind(null,e)),oa((function(){0==(6&ju)&&Ua()})),t=null;else{switch(wn(r)){case 1:t=Je;break;case 4:t=en;break;case 16:default:t=nn;break;case 536870912:t=rn}t=zs(t,ls.bind(null,e))}e.callbackPriority=n,e.callbackNode=t}}function ls(e,n){if(Ju=-1,es=0,0!=(6&ju))throw Error(l(327));var t=e.callbackNode;if(Ss()&&e.callbackNode!==t)return null;var r=pn(e,e===zu?Tu:0);if(0===r)return null;if(0!=(30&r)||0!=(r&e.expiredLanes)||n)n=gs(e,r);else{n=r;var a=ju;ju|=2;var o=hs();for(zu===e&&Tu===n||(Hu=null,Vu=Ye()+500,ps(e,n));;)try{ys();break}catch(n){ms(e,n)}wl(),Pu.current=o,ju=a,null!==Nu?n=0:(zu=null,Tu=0,n=Ou)}if(0!==n){if(2===n&&0!==(a=hn(e))&&(r=a,n=os(e,a)),1===n)throw t=Lu,ps(e,0),us(e,r),as(e,Ye()),t;if(6===n)us(e,r);else{if(a=e.current.alternate,0==(30&r)&&!function(e){for(var n=e;;){if(16384&n.flags){var t=n.updateQueue;if(null!==t&&null!==(t=t.stores))for(var r=0;r<t.length;r++){var a=t[r],l=a.getSnapshot;a=a.value;try{if(!ir(l(),a))return!1}catch(e){return!1}}}if(t=n.child,16384&n.subtreeFlags&&null!==t)t.return=n,n=t;else{if(n===e)break;for(;null===n.sibling;){if(null===n.return||n.return===e)return!0;n=n.return}n.sibling.return=n.return,n=n.sibling}}return!0}(a)&&(2===(n=gs(e,r))&&0!==(o=hn(e))&&(r=o,n=os(e,o)),1===n))throw t=Lu,ps(e,0),us(e,r),as(e,Ye()),t;switch(e.finishedWork=a,e.finishedLanes=r,n){case 0:case 1:throw Error(l(345));case 2:case 5:ks(e,$u,Hu);break;case 3:if(us(e,r),(130023424&r)===r&&10<(n=Uu+500-Ye())){if(0!==pn(e,0))break;if(((a=e.suspendedLanes)&r)!==r){ns(),e.pingedLanes|=e.suspendedLanes&a;break}e.timeoutHandle=ra(ks.bind(null,e,$u,Hu),n);break}ks(e,$u,Hu);break;case 4:if(us(e,r),(4194240&r)===r)break;for(n=e.eventTimes,a=-1;0<r;){var i=31-on(r);o=1<<i,(i=n[i])>a&&(a=i),r&=~o}if(r=a,10<(r=(120>(r=Ye()-r)?120:480>r?480:1080>r?1080:1920>r?1920:3e3>r?3e3:4320>r?4320:1960*Eu(r/1960))-r)){e.timeoutHandle=ra(ks.bind(null,e,$u,Hu),r);break}ks(e,$u,Hu);break;default:throw Error(l(329))}}}return as(e,Ye()),e.callbackNode===t?ls.bind(null,e):null}function os(e,n){var t=Bu;return e.current.memoizedState.isDehydrated&&(ps(e,n).flags|=256),2!==(e=gs(e,n))&&(n=$u,$u=t,null!==n&&is(n)),e}function is(e){null===$u?$u=e:$u.push.apply($u,e)}function us(e,n){for(n&=~Ru,n&=~Du,e.suspendedLanes|=n,e.pingedLanes&=~n,e=e.expirationTimes;0<n;){var t=31-on(n),r=1<<t;e[t]=-1,n&=~r}}function ss(e){if(0!=(6&ju))throw Error(l(327));Ss();var n=pn(e,0);if(0==(1&n))return as(e,Ye()),null;var t=gs(e,n);if(0!==e.tag&&2===t){var r=hn(e);0!==r&&(n=r,t=os(e,r))}if(1===t)throw t=Lu,ps(e,0),us(e,n),as(e,Ye()),t;if(6===t)throw Error(l(345));return e.finishedWork=e.current.alternate,e.finishedLanes=n,ks(e,$u,Hu),as(e,Ye()),null}function cs(e,n){var t=ju;ju|=1;try{return e(n)}finally{0===(ju=t)&&(Vu=Ye()+500,Ra&&Ua())}}function ds(e){null!==Ku&&0===Ku.tag&&0==(6&ju)&&Ss();var n=ju;ju|=1;var t=Mu.transition,r=xn;try{if(Mu.transition=null,xn=1,e)return e()}finally{xn=r,Mu.transition=t,0==(6&(ju=n))&&Ua()}}function fs(){Fu=Iu.current,Ea(Iu)}function ps(e,n){e.finishedWork=null,e.finishedLanes=0;var t=e.timeoutHandle;if(-1!==t&&(e.timeoutHandle=-1,aa(t)),null!==Nu)for(t=Nu.return;null!==t;){var r=t;switch(nl(r),r.tag){case 1:null!=(r=r.type.childContextTypes)&&Fa();break;case 3:ao(),Ea(ja),Ea(Ma),co();break;case 5:oo(r);break;case 4:ao();break;case 13:case 19:Ea(io);break;case 10:kl(r.type._context);break;case 22:case 23:fs()}t=t.return}if(zu=e,Nu=e=Is(e.current,null),Tu=Fu=n,Ou=0,Lu=null,Ru=Du=Au=0,$u=Bu=null,null!==Pl){for(n=0;n<Pl.length;n++)if(null!==(r=(t=Pl[n]).interleaved)){t.interleaved=null;var a=r.next,l=t.pending;if(null!==l){var o=l.next;l.next=a,r.next=o}t.pending=r}Pl=null}return e}function ms(e,n){for(;;){var t=Nu;try{if(wl(),fo.current=oi,bo){for(var r=ho.memoizedState;null!==r;){var a=r.queue;null!==a&&(a.pending=null),r=r.next}bo=!1}if(mo=0,go=vo=ho=null,yo=!1,xo=0,_u.current=null,null===t||null===t.return){Ou=1,Lu=n,Nu=null;break}e:{var o=e,i=t.return,u=t,s=n;if(n=Tu,u.flags|=32768,null!==s&&"object"==typeof s&&"function"==typeof s.then){var c=s,d=u,f=d.tag;if(0==(1&d.mode)&&(0===f||11===f||15===f)){var p=d.alternate;p?(d.updateQueue=p.updateQueue,d.memoizedState=p.memoizedState,d.lanes=p.lanes):(d.updateQueue=null,d.memoizedState=null)}var m=gi(i);if(null!==m){m.flags&=-257,bi(m,i,u,0,n),1&m.mode&&vi(o,c,n),s=c;var h=(n=m).updateQueue;if(null===h){var v=new Set;v.add(s),n.updateQueue=v}else h.add(s);break e}if(0==(1&n)){vi(o,c,n),vs();break e}s=Error(l(426))}else if(al&&1&u.mode){var g=gi(i);if(null!==g){0==(65536&g.flags)&&(g.flags|=256),bi(g,i,u,0,n),ml(ci(s,u));break e}}o=s=ci(s,u),4!==Ou&&(Ou=2),null===Bu?Bu=[o]:Bu.push(o),o=i;do{switch(o.tag){case 3:o.flags|=65536,n&=-n,o.lanes|=n,Ll(o,mi(0,s,n));break e;case 1:u=s;var b=o.type,y=o.stateNode;if(0==(128&o.flags)&&("function"==typeof b.getDerivedStateFromError||null!==y&&"function"==typeof y.componentDidCatch&&(null===qu||!qu.has(y)))){o.flags|=65536,n&=-n,o.lanes|=n,Ll(o,hi(o,u,n));break e}}o=o.return}while(null!==o)}ws(t)}catch(e){n=e,Nu===t&&null!==t&&(Nu=t=t.return);continue}break}}function hs(){var e=Pu.current;return Pu.current=oi,null===e?oi:e}function vs(){0!==Ou&&3!==Ou&&2!==Ou||(Ou=4),null===zu||0==(268435455&Au)&&0==(268435455&Du)||us(zu,Tu)}function gs(e,n){var t=ju;ju|=2;var r=hs();for(zu===e&&Tu===n||(Hu=null,ps(e,n));;)try{bs();break}catch(n){ms(e,n)}if(wl(),ju=t,Pu.current=r,null!==Nu)throw Error(l(261));return zu=null,Tu=0,Ou}function bs(){for(;null!==Nu;)xs(Nu)}function ys(){for(;null!==Nu&&!Ke();)xs(Nu)}function xs(e){var n=Cu(e.alternate,e,Fu);e.memoizedProps=e.pendingProps,null===n?ws(e):Nu=n,_u.current=null}function ws(e){var n=e;do{var t=n.alternate;if(e=n.return,0==(32768&n.flags)){if(null!==(t=Qi(t,n,Fu)))return void(Nu=t)}else{if(null!==(t=Ki(t,n)))return t.flags&=32767,void(Nu=t);if(null===e)return Ou=6,void(Nu=null);e.flags|=32768,e.subtreeFlags=0,e.deletions=null}if(null!==(n=n.sibling))return void(Nu=n);Nu=n=e}while(null!==n);0===Ou&&(Ou=5)}function ks(e,n,t){var r=xn,a=Mu.transition;try{Mu.transition=null,xn=1,function(e,n,t,r){do{Ss()}while(null!==Ku);if(0!=(6&ju))throw Error(l(327));t=e.finishedWork;var a=e.finishedLanes;if(null===t)return null;if(e.finishedWork=null,e.finishedLanes=0,t===e.current)throw Error(l(177));e.callbackNode=null,e.callbackPriority=0;var o=t.lanes|t.childLanes;if(function(e,n){var t=e.pendingLanes&~n;e.pendingLanes=n,e.suspendedLanes=0,e.pingedLanes=0,e.expiredLanes&=n,e.mutableReadLanes&=n,e.entangledLanes&=n,n=e.entanglements;var r=e.eventTimes;for(e=e.expirationTimes;0<t;){var a=31-on(t),l=1<<a;n[a]=0,r[a]=-1,e[a]=-1,t&=~l}}(e,o),e===zu&&(Nu=zu=null,Tu=0),0==(2064&t.subtreeFlags)&&0==(2064&t.flags)||Qu||(Qu=!0,zs(nn,(function(){return Ss(),null}))),o=0!=(15990&t.flags),0!=(15990&t.subtreeFlags)||o){o=Mu.transition,Mu.transition=null;var i=xn;xn=1;var u=ju;ju|=4,_u.current=null,function(e,n){if(ea=Zn,pr(e=fr())){if("selectionStart"in e)var t={start:e.selectionStart,end:e.selectionEnd};else e:{var r=(t=(t=e.ownerDocument)&&t.defaultView||window).getSelection&&t.getSelection();if(r&&0!==r.rangeCount){t=r.anchorNode;var a=r.anchorOffset,o=r.focusNode;r=r.focusOffset;try{t.nodeType,o.nodeType}catch(e){t=null;break e}var i=0,u=-1,s=-1,c=0,d=0,f=e,p=null;n:for(;;){for(var m;f!==t||0!==a&&3!==f.nodeType||(u=i+a),f!==o||0!==r&&3!==f.nodeType||(s=i+r),3===f.nodeType&&(i+=f.nodeValue.length),null!==(m=f.firstChild);)p=f,f=m;for(;;){if(f===e)break n;if(p===t&&++c===a&&(u=i),p===o&&++d===r&&(s=i),null!==(m=f.nextSibling))break;p=(f=p).parentNode}f=m}t=-1===u||-1===s?null:{start:u,end:s}}else t=null}t=t||{start:0,end:0}}else t=null;for(na={focusedElem:e,selectionRange:t},Zn=!1,Ji=n;null!==Ji;)if(e=(n=Ji).child,0!=(1028&n.subtreeFlags)&&null!==e)e.return=n,Ji=e;else for(;null!==Ji;){n=Ji;try{var h=n.alternate;if(0!=(1024&n.flags))switch(n.tag){case 0:case 11:case 15:case 5:case 6:case 4:case 17:break;case 1:if(null!==h){var v=h.memoizedProps,g=h.memoizedState,b=n.stateNode,y=b.getSnapshotBeforeUpdate(n.elementType===n.type?v:vl(n.type,v),g);b.__reactInternalSnapshotBeforeUpdate=y}break;case 3:var x=n.stateNode.containerInfo;1===x.nodeType?x.textContent="":9===x.nodeType&&x.documentElement&&x.removeChild(x.documentElement);break;default:throw Error(l(163))}}catch(e){Es(n,n.return,e)}if(null!==(e=n.sibling)){e.return=n.return,Ji=e;break}Ji=n.return}h=tu,tu=!1}(e,t),gu(t,e),mr(na),Zn=!!ea,na=ea=null,e.current=t,yu(t,e,a),Xe(),ju=u,xn=i,Mu.transition=o}else e.current=t;if(Qu&&(Qu=!1,Ku=e,Xu=a),0===(o=e.pendingLanes)&&(qu=null),function(e){if(ln&&"function"==typeof ln.onCommitFiberRoot)try{ln.onCommitFiberRoot(an,e,void 0,128==(128&e.current.flags))}catch(e){}}(t.stateNode),as(e,Ye()),null!==n)for(r=e.onRecoverableError,t=0;t<n.length;t++)r((a=n[t]).value,{componentStack:a.stack,digest:a.digest});if(Zu)throw Zu=!1,e=Wu,Wu=null,e;0!=(1&Xu)&&0!==e.tag&&Ss(),0!=(1&(o=e.pendingLanes))?e===Gu?Yu++:(Yu=0,Gu=e):Yu=0,Ua()}(e,n,t,r)}finally{Mu.transition=a,xn=r}return null}function Ss(){if(null!==Ku){var e=wn(Xu),n=Mu.transition,t=xn;try{if(Mu.transition=null,xn=16>e?16:e,null===Ku)var r=!1;else{if(e=Ku,Ku=null,Xu=0,0!=(6&ju))throw Error(l(331));var a=ju;for(ju|=4,Ji=e.current;null!==Ji;){var o=Ji,i=o.child;if(0!=(16&Ji.flags)){var u=o.deletions;if(null!==u){for(var s=0;s<u.length;s++){var c=u[s];for(Ji=c;null!==Ji;){var d=Ji;switch(d.tag){case 0:case 11:case 15:ru(8,d,o)}var f=d.child;if(null!==f)f.return=d,Ji=f;else for(;null!==Ji;){var p=(d=Ji).sibling,m=d.return;if(ou(d),d===c){Ji=null;break}if(null!==p){p.return=m,Ji=p;break}Ji=m}}}var h=o.alternate;if(null!==h){var v=h.child;if(null!==v){h.child=null;do{var g=v.sibling;v.sibling=null,v=g}while(null!==v)}}Ji=o}}if(0!=(2064&o.subtreeFlags)&&null!==i)i.return=o,Ji=i;else e:for(;null!==Ji;){if(0!=(2048&(o=Ji).flags))switch(o.tag){case 0:case 11:case 15:ru(9,o,o.return)}var b=o.sibling;if(null!==b){b.return=o.return,Ji=b;break e}Ji=o.return}}var y=e.current;for(Ji=y;null!==Ji;){var x=(i=Ji).child;if(0!=(2064&i.subtreeFlags)&&null!==x)x.return=i,Ji=x;else e:for(i=y;null!==Ji;){if(0!=(2048&(u=Ji).flags))try{switch(u.tag){case 0:case 11:case 15:au(9,u)}}catch(e){Es(u,u.return,e)}if(u===i){Ji=null;break e}var w=u.sibling;if(null!==w){w.return=u.return,Ji=w;break e}Ji=u.return}}if(ju=a,Ua(),ln&&"function"==typeof ln.onPostCommitFiberRoot)try{ln.onPostCommitFiberRoot(an,e)}catch(e){}r=!0}return r}finally{xn=t,Mu.transition=n}}return!1}function Cs(e,n,t){e=Il(e,n=mi(0,n=ci(t,n),1),1),n=ns(),null!==e&&(bn(e,1,n),as(e,n))}function Es(e,n,t){if(3===e.tag)Cs(e,e,t);else for(;null!==n;){if(3===n.tag){Cs(n,e,t);break}if(1===n.tag){var r=n.stateNode;if("function"==typeof n.type.getDerivedStateFromError||"function"==typeof r.componentDidCatch&&(null===qu||!qu.has(r))){n=Il(n,e=hi(n,e=ci(t,e),1),1),e=ns(),null!==n&&(bn(n,1,e),as(n,e));break}}n=n.return}}function Ps(e,n,t){var r=e.pingCache;null!==r&&r.delete(n),n=ns(),e.pingedLanes|=e.suspendedLanes&t,zu===e&&(Tu&t)===t&&(4===Ou||3===Ou&&(130023424&Tu)===Tu&&500>Ye()-Uu?ps(e,0):Ru|=t),as(e,n)}function _s(e,n){0===n&&(0==(1&e.mode)?n=1:(n=dn,0==(130023424&(dn<<=1))&&(dn=4194304)));var t=ns();null!==(e=jl(e,n))&&(bn(e,n,t),as(e,t))}function Ms(e){var n=e.memoizedState,t=0;null!==n&&(t=n.retryLane),_s(e,t)}function js(e,n){var t=0;switch(e.tag){case 13:var r=e.stateNode,a=e.memoizedState;null!==a&&(t=a.retryLane);break;case 19:r=e.stateNode;break;default:throw Error(l(314))}null!==r&&r.delete(n),_s(e,t)}function zs(e,n){return qe(e,n)}function Ns(e,n,t,r){this.tag=e,this.key=t,this.sibling=this.child=this.return=this.stateNode=this.type=this.elementType=null,this.index=0,this.ref=null,this.pendingProps=n,this.dependencies=this.memoizedState=this.updateQueue=this.memoizedProps=null,this.mode=r,this.subtreeFlags=this.flags=0,this.deletions=null,this.childLanes=this.lanes=0,this.alternate=null}function Ts(e,n,t,r){return new Ns(e,n,t,r)}function Fs(e){return!(!(e=e.prototype)||!e.isReactComponent)}function Is(e,n){var t=e.alternate;return null===t?((t=Ts(e.tag,n,e.key,e.mode)).elementType=e.elementType,t.type=e.type,t.stateNode=e.stateNode,t.alternate=e,e.alternate=t):(t.pendingProps=n,t.type=e.type,t.flags=0,t.subtreeFlags=0,t.deletions=null),t.flags=14680064&e.flags,t.childLanes=e.childLanes,t.lanes=e.lanes,t.child=e.child,t.memoizedProps=e.memoizedProps,t.memoizedState=e.memoizedState,t.updateQueue=e.updateQueue,n=e.dependencies,t.dependencies=null===n?null:{lanes:n.lanes,firstContext:n.firstContext},t.sibling=e.sibling,t.index=e.index,t.ref=e.ref,t}function Os(e,n,t,r,a,o){var i=2;if(r=e,"function"==typeof e)Fs(e)&&(i=1);else if("string"==typeof e)i=5;else e:switch(e){case S:return Ls(t.children,a,o,n);case C:i=8,a|=8;break;case E:return(e=Ts(12,t,n,2|a)).elementType=E,e.lanes=o,e;case j:return(e=Ts(13,t,n,a)).elementType=j,e.lanes=o,e;case z:return(e=Ts(19,t,n,a)).elementType=z,e.lanes=o,e;case F:return As(t,a,o,n);default:if("object"==typeof e&&null!==e)switch(e.$$typeof){case P:i=10;break e;case _:i=9;break e;case M:i=11;break e;case N:i=14;break e;case T:i=16,r=null;break e}throw Error(l(130,null==e?e:typeof e,""))}return(n=Ts(i,t,n,a)).elementType=e,n.type=r,n.lanes=o,n}function Ls(e,n,t,r){return(e=Ts(7,e,r,n)).lanes=t,e}function As(e,n,t,r){return(e=Ts(22,e,r,n)).elementType=F,e.lanes=t,e.stateNode={isHidden:!1},e}function Ds(e,n,t){return(e=Ts(6,e,null,n)).lanes=t,e}function Rs(e,n,t){return(n=Ts(4,null!==e.children?e.children:[],e.key,n)).lanes=t,n.stateNode={containerInfo:e.containerInfo,pendingChildren:null,implementation:e.implementation},n}function Bs(e,n,t,r,a){this.tag=n,this.containerInfo=e,this.finishedWork=this.pingCache=this.current=this.pendingChildren=null,this.timeoutHandle=-1,this.callbackNode=this.pendingContext=this.context=null,this.callbackPriority=0,this.eventTimes=gn(0),this.expirationTimes=gn(-1),this.entangledLanes=this.finishedLanes=this.mutableReadLanes=this.expiredLanes=this.pingedLanes=this.suspendedLanes=this.pendingLanes=0,this.entanglements=gn(0),this.identifierPrefix=r,this.onRecoverableError=a,this.mutableSourceEagerHydrationData=null}function $s(e,n,t,r,a,l,o,i,u){return e=new Bs(e,n,t,i,u),1===n?(n=1,!0===l&&(n|=8)):n=0,l=Ts(3,null,null,n),e.current=l,l.stateNode=e,l.memoizedState={element:r,isDehydrated:t,cache:null,transitions:null,pendingSuspenseBoundaries:null},Nl(l),e}function Us(e){if(!e)return _a;e:{if(Ue(e=e._reactInternals)!==e||1!==e.tag)throw Error(l(170));var n=e;do{switch(n.tag){case 3:n=n.stateNode.context;break e;case 1:if(Ta(n.type)){n=n.stateNode.__reactInternalMemoizedMergedChildContext;break e}}n=n.return}while(null!==n);throw Error(l(171))}if(1===e.tag){var t=e.type;if(Ta(t))return Oa(e,t,n)}return n}function Vs(e,n,t,r,a,l,o,i,u){return(e=$s(t,r,!0,e,0,l,0,i,u)).context=Us(null),t=e.current,(l=Fl(r=ns(),a=ts(t))).callback=null!=n?n:null,Il(t,l,a),e.current.lanes=a,bn(e,a,r),as(e,r),e}function Hs(e,n,t,r){var a=n.current,l=ns(),o=ts(a);return t=Us(t),null===n.context?n.context=t:n.pendingContext=t,(n=Fl(l,o)).payload={element:e},null!==(r=void 0===r?null:r)&&(n.callback=r),null!==(e=Il(a,n,o))&&(rs(e,a,o,l),Ol(e,a,o)),o}function Zs(e){return(e=e.current).child?(e.child.tag,e.child.stateNode):null}function Ws(e,n){if(null!==(e=e.memoizedState)&&null!==e.dehydrated){var t=e.retryLane;e.retryLane=0!==t&&t<n?t:n}}function qs(e,n){Ws(e,n),(e=e.alternate)&&Ws(e,n)}Cu=function(e,n,t){if(null!==e)if(e.memoizedProps!==n.pendingProps||ja.current)xi=!0;else{if(0==(e.lanes&t)&&0==(128&n.flags))return xi=!1,function(e,n,t){switch(n.tag){case 3:zi(n),pl();break;case 5:lo(n);break;case 1:Ta(n.type)&&La(n);break;case 4:ro(n,n.stateNode.containerInfo);break;case 10:var r=n.type._context,a=n.memoizedProps.value;Pa(gl,r._currentValue),r._currentValue=a;break;case 13:if(null!==(r=n.memoizedState))return null!==r.dehydrated?(Pa(io,1&io.current),n.flags|=128,null):0!=(t&n.child.childLanes)?Di(e,n,t):(Pa(io,1&io.current),null!==(e=Zi(e,n,t))?e.sibling:null);Pa(io,1&io.current);break;case 19:if(r=0!=(t&n.childLanes),0!=(128&e.flags)){if(r)return Vi(e,n,t);n.flags|=128}if(null!==(a=n.memoizedState)&&(a.rendering=null,a.tail=null,a.lastEffect=null),Pa(io,io.current),r)break;return null;case 22:case 23:return n.lanes=0,Ei(e,n,t)}return Zi(e,n,t)}(e,n,t);xi=0!=(131072&e.flags)}else xi=!1,al&&0!=(1048576&n.flags)&&Ja(n,Wa,n.index);switch(n.lanes=0,n.tag){case 2:var r=n.type;Hi(e,n),e=n.pendingProps;var a=Na(n,Ma.current);Cl(n,t),a=Co(null,n,r,e,a,t);var o=Eo();return n.flags|=1,"object"==typeof a&&null!==a&&"function"==typeof a.render&&void 0===a.$$typeof?(n.tag=1,n.memoizedState=null,n.updateQueue=null,Ta(r)?(o=!0,La(n)):o=!1,n.memoizedState=null!==a.state&&void 0!==a.state?a.state:null,Nl(n),a.updater=$l,n.stateNode=a,a._reactInternals=n,Zl(n,r,e,t),n=ji(null,n,r,!0,o,t)):(n.tag=0,al&&o&&el(n),wi(null,n,a,t),n=n.child),n;case 16:r=n.elementType;e:{switch(Hi(e,n),e=n.pendingProps,r=(a=r._init)(r._payload),n.type=r,a=n.tag=function(e){if("function"==typeof e)return Fs(e)?1:0;if(null!=e){if((e=e.$$typeof)===M)return 11;if(e===N)return 14}return 2}(r),e=vl(r,e),a){case 0:n=_i(null,n,r,e,t);break e;case 1:n=Mi(null,n,r,e,t);break e;case 11:n=ki(null,n,r,e,t);break e;case 14:n=Si(null,n,r,vl(r.type,e),t);break e}throw Error(l(306,r,""))}return n;case 0:return r=n.type,a=n.pendingProps,_i(e,n,r,a=n.elementType===r?a:vl(r,a),t);case 1:return r=n.type,a=n.pendingProps,Mi(e,n,r,a=n.elementType===r?a:vl(r,a),t);case 3:e:{if(zi(n),null===e)throw Error(l(387));r=n.pendingProps,a=(o=n.memoizedState).element,Tl(e,n),Al(n,r,null,t);var i=n.memoizedState;if(r=i.element,o.isDehydrated){if(o={element:r,isDehydrated:!1,cache:i.cache,pendingSuspenseBoundaries:i.pendingSuspenseBoundaries,transitions:i.transitions},n.updateQueue.baseState=o,n.memoizedState=o,256&n.flags){n=Ni(e,n,r,t,a=ci(Error(l(423)),n));break e}if(r!==a){n=Ni(e,n,r,t,a=ci(Error(l(424)),n));break e}for(rl=sa(n.stateNode.containerInfo.firstChild),tl=n,al=!0,ll=null,t=Yl(n,null,r,t),n.child=t;t;)t.flags=-3&t.flags|4096,t=t.sibling}else{if(pl(),r===a){n=Zi(e,n,t);break e}wi(e,n,r,t)}n=n.child}return n;case 5:return lo(n),null===e&&sl(n),r=n.type,a=n.pendingProps,o=null!==e?e.memoizedProps:null,i=a.children,ta(r,a)?i=null:null!==o&&ta(r,o)&&(n.flags|=32),Pi(e,n),wi(e,n,i,t),n.child;case 6:return null===e&&sl(n),null;case 13:return Di(e,n,t);case 4:return ro(n,n.stateNode.containerInfo),r=n.pendingProps,null===e?n.child=Xl(n,null,r,t):wi(e,n,r,t),n.child;case 11:return r=n.type,a=n.pendingProps,ki(e,n,r,a=n.elementType===r?a:vl(r,a),t);case 7:return wi(e,n,n.pendingProps,t),n.child;case 8:case 12:return wi(e,n,n.pendingProps.children,t),n.child;case 10:e:{if(r=n.type._context,a=n.pendingProps,o=n.memoizedProps,i=a.value,Pa(gl,r._currentValue),r._currentValue=i,null!==o)if(ir(o.value,i)){if(o.children===a.children&&!ja.current){n=Zi(e,n,t);break e}}else for(null!==(o=n.child)&&(o.return=n);null!==o;){var u=o.dependencies;if(null!==u){i=o.child;for(var s=u.firstContext;null!==s;){if(s.context===r){if(1===o.tag){(s=Fl(-1,t&-t)).tag=2;var c=o.updateQueue;if(null!==c){var d=(c=c.shared).pending;null===d?s.next=s:(s.next=d.next,d.next=s),c.pending=s}}o.lanes|=t,null!==(s=o.alternate)&&(s.lanes|=t),Sl(o.return,t,n),u.lanes|=t;break}s=s.next}}else if(10===o.tag)i=o.type===n.type?null:o.child;else if(18===o.tag){if(null===(i=o.return))throw Error(l(341));i.lanes|=t,null!==(u=i.alternate)&&(u.lanes|=t),Sl(i,t,n),i=o.sibling}else i=o.child;if(null!==i)i.return=o;else for(i=o;null!==i;){if(i===n){i=null;break}if(null!==(o=i.sibling)){o.return=i.return,i=o;break}i=i.return}o=i}wi(e,n,a.children,t),n=n.child}return n;case 9:return a=n.type,r=n.pendingProps.children,Cl(n,t),r=r(a=El(a)),n.flags|=1,wi(e,n,r,t),n.child;case 14:return a=vl(r=n.type,n.pendingProps),Si(e,n,r,a=vl(r.type,a),t);case 15:return Ci(e,n,n.type,n.pendingProps,t);case 17:return r=n.type,a=n.pendingProps,a=n.elementType===r?a:vl(r,a),Hi(e,n),n.tag=1,Ta(r)?(e=!0,La(n)):e=!1,Cl(n,t),Vl(n,r,a),Zl(n,r,a,t),ji(null,n,r,!0,e,t);case 19:return Vi(e,n,t);case 22:return Ei(e,n,t)}throw Error(l(156,n.tag))};var Qs="function"==typeof reportError?reportError:function(e){console.error(e)};function Ks(e){this._internalRoot=e}function Xs(e){this._internalRoot=e}function Ys(e){return!(!e||1!==e.nodeType&&9!==e.nodeType&&11!==e.nodeType)}function Gs(e){return!(!e||1!==e.nodeType&&9!==e.nodeType&&11!==e.nodeType&&(8!==e.nodeType||" react-mount-point-unstable "!==e.nodeValue))}function Js(){}function ec(e,n,t,r,a){var l=t._reactRootContainer;if(l){var o=l;if("function"==typeof a){var i=a;a=function(){var e=Zs(o);i.call(e)}}Hs(n,o,e,a)}else o=function(e,n,t,r,a){if(a){if("function"==typeof r){var l=r;r=function(){var e=Zs(o);l.call(e)}}var o=Vs(n,r,e,0,null,!1,0,"",Js);return e._reactRootContainer=o,e[ma]=o.current,Ur(8===e.nodeType?e.parentNode:e),ds(),o}for(;a=e.lastChild;)e.removeChild(a);if("function"==typeof r){var i=r;r=function(){var e=Zs(u);i.call(e)}}var u=$s(e,0,!1,null,0,!1,0,"",Js);return e._reactRootContainer=u,e[ma]=u.current,Ur(8===e.nodeType?e.parentNode:e),ds((function(){Hs(n,u,t,r)})),u}(t,n,e,a,r);return Zs(o)}Xs.prototype.render=Ks.prototype.render=function(e){var n=this._internalRoot;if(null===n)throw Error(l(409));Hs(e,n,null,null)},Xs.prototype.unmount=Ks.prototype.unmount=function(){var e=this._internalRoot;if(null!==e){this._internalRoot=null;var n=e.containerInfo;ds((function(){Hs(null,e,null,null)})),n[ma]=null}},Xs.prototype.unstable_scheduleHydration=function(e){if(e){var n=En();e={blockedOn:null,target:e,priority:n};for(var t=0;t<In.length&&0!==n&&n<In[t].priority;t++);In.splice(t,0,e),0===t&&Dn(e)}},kn=function(e){switch(e.tag){case 3:var n=e.stateNode;if(n.current.memoizedState.isDehydrated){var t=fn(n.pendingLanes);0!==t&&(yn(n,1|t),as(n,Ye()),0==(6&ju)&&(Vu=Ye()+500,Ua()))}break;case 13:ds((function(){var n=jl(e,1);if(null!==n){var t=ns();rs(n,e,1,t)}})),qs(e,1)}},Sn=function(e){if(13===e.tag){var n=jl(e,134217728);null!==n&&rs(n,e,134217728,ns()),qs(e,134217728)}},Cn=function(e){if(13===e.tag){var n=ts(e),t=jl(e,n);null!==t&&rs(t,e,n,ns()),qs(e,n)}},En=function(){return xn},Pn=function(e,n){var t=xn;try{return xn=e,n()}finally{xn=t}},ke=function(e,n,t){switch(n){case"input":if(G(e,t),n=t.name,"radio"===t.type&&null!=n){for(t=e;t.parentNode;)t=t.parentNode;for(t=t.querySelectorAll("input[name="+JSON.stringify(""+n)+'][type="radio"]'),n=0;n<t.length;n++){var r=t[n];if(r!==e&&r.form===e.form){var a=wa(r);if(!a)throw Error(l(90));q(r),G(r,a)}}}break;case"textarea":le(e,t);break;case"select":null!=(n=t.value)&&te(e,!!t.multiple,n,!1)}},Me=cs,je=ds;var nc={usingClientEntryPoint:!1,Events:[ya,xa,wa,Pe,_e,cs]},tc={findFiberByHostInstance:ba,bundleType:0,version:"18.2.0",rendererPackageName:"react-dom"},rc={bundleType:tc.bundleType,version:tc.version,rendererPackageName:tc.rendererPackageName,rendererConfig:tc.rendererConfig,overrideHookState:null,overrideHookStateDeletePath:null,overrideHookStateRenamePath:null,overrideProps:null,overridePropsDeletePath:null,overridePropsRenamePath:null,setErrorHandler:null,setSuspenseHandler:null,scheduleUpdate:null,currentDispatcherRef:x.ReactCurrentDispatcher,findHostInstanceByFiber:function(e){return null===(e=Ze(e))?null:e.stateNode},findFiberByHostInstance:tc.findFiberByHostInstance||function(){return null},findHostInstancesForRefresh:null,scheduleRefresh:null,scheduleRoot:null,setRefreshHandler:null,getCurrentFiber:null,reconcilerVersion:"18.2.0-next-9e3b772b8-20220608"};if("undefined"!=typeof __REACT_DEVTOOLS_GLOBAL_HOOK__){var ac=__REACT_DEVTOOLS_GLOBAL_HOOK__;if(!ac.isDisabled&&ac.supportsFiber)try{an=ac.inject(rc),ln=ac}catch(ce){}}n.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED=nc,n.createPortal=function(e,n){var t=2<arguments.length&&void 0!==arguments[2]?arguments[2]:null;if(!Ys(n))throw Error(l(200));return function(e,n,t){var r=3<arguments.length&&void 0!==arguments[3]?arguments[3]:null;return{$$typeof:k,key:null==r?null:""+r,children:e,containerInfo:n,implementation:t}}(e,n,null,t)},n.createRoot=function(e,n){if(!Ys(e))throw Error(l(299));var t=!1,r="",a=Qs;return null!=n&&(!0===n.unstable_strictMode&&(t=!0),void 0!==n.identifierPrefix&&(r=n.identifierPrefix),void 0!==n.onRecoverableError&&(a=n.onRecoverableError)),n=$s(e,1,!1,null,0,t,0,r,a),e[ma]=n.current,Ur(8===e.nodeType?e.parentNode:e),new Ks(n)},n.findDOMNode=function(e){if(null==e)return null;if(1===e.nodeType)return e;var n=e._reactInternals;if(void 0===n){if("function"==typeof e.render)throw Error(l(188));throw e=Object.keys(e).join(","),Error(l(268,e))}return null===(e=Ze(n))?null:e.stateNode},n.flushSync=function(e){return ds(e)},n.hydrate=function(e,n,t){if(!Gs(n))throw Error(l(200));return ec(null,e,n,!0,t)},n.hydrateRoot=function(e,n,t){if(!Ys(e))throw Error(l(405));var r=null!=t&&t.hydratedSources||null,a=!1,o="",i=Qs;if(null!=t&&(!0===t.unstable_strictMode&&(a=!0),void 0!==t.identifierPrefix&&(o=t.identifierPrefix),void 0!==t.onRecoverableError&&(i=t.onRecoverableError)),n=Vs(n,null,e,1,null!=t?t:null,a,0,o,i),e[ma]=n.current,Ur(e),r)for(e=0;e<r.length;e++)a=(a=(t=r[e])._getVersion)(t._source),null==n.mutableSourceEagerHydrationData?n.mutableSourceEagerHydrationData=[t,a]:n.mutableSourceEagerHydrationData.push(t,a);return new Xs(n)},n.render=function(e,n,t){if(!Gs(n))throw Error(l(200));return ec(null,e,n,!1,t)},n.unmountComponentAtNode=function(e){if(!Gs(e))throw Error(l(40));return!!e._reactRootContainer&&(ds((function(){ec(null,null,e,!1,(function(){e._reactRootContainer=null,e[ma]=null}))})),!0)},n.unstable_batchedUpdates=cs,n.unstable_renderSubtreeIntoContainer=function(e,n,t,r){if(!Gs(t))throw Error(l(200));if(null==e||void 0===e._reactInternals)throw Error(l(38));return ec(e,n,t,!1,r)},n.version="18.2.0-next-9e3b772b8-20220608"},745:function(e,n,t){"use strict";var r=t(3935);n.s=r.createRoot,r.hydrateRoot},3935:function(e,n,t){"use strict";!function e(){if("undefined"!=typeof __REACT_DEVTOOLS_GLOBAL_HOOK__&&"function"==typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.checkDCE)try{__REACT_DEVTOOLS_GLOBAL_HOOK__.checkDCE(e)}catch(e){console.error(e)}}(),e.exports=t(4448)},5251:function(e,n,t){"use strict";var r=t(7294),a=Symbol.for("react.element"),l=Symbol.for("react.fragment"),o=Object.prototype.hasOwnProperty,i=r.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner,u={key:!0,ref:!0,__self:!0,__source:!0};function s(e,n,t){var r,l={},s=null,c=null;for(r in void 0!==t&&(s=""+t),void 0!==n.key&&(s=""+n.key),void 0!==n.ref&&(c=n.ref),n)o.call(n,r)&&!u.hasOwnProperty(r)&&(l[r]=n[r]);if(e&&e.defaultProps)for(r in n=e.defaultProps)void 0===l[r]&&(l[r]=n[r]);return{$$typeof:a,type:e,key:s,ref:c,props:l,_owner:i.current}}n.Fragment=l,n.jsx=s,n.jsxs=s},2408:function(e,n){"use strict";var t=Symbol.for("react.element"),r=Symbol.for("react.portal"),a=Symbol.for("react.fragment"),l=Symbol.for("react.strict_mode"),o=Symbol.for("react.profiler"),i=Symbol.for("react.provider"),u=Symbol.for("react.context"),s=Symbol.for("react.forward_ref"),c=Symbol.for("react.suspense"),d=Symbol.for("react.memo"),f=Symbol.for("react.lazy"),p=Symbol.iterator,m={isMounted:function(){return!1},enqueueForceUpdate:function(){},enqueueReplaceState:function(){},enqueueSetState:function(){}},h=Object.assign,v={};function g(e,n,t){this.props=e,this.context=n,this.refs=v,this.updater=t||m}function b(){}function y(e,n,t){this.props=e,this.context=n,this.refs=v,this.updater=t||m}g.prototype.isReactComponent={},g.prototype.setState=function(e,n){if("object"!=typeof e&&"function"!=typeof e&&null!=e)throw Error("setState(...): takes an object of state variables to update or a function which returns an object of state variables.");this.updater.enqueueSetState(this,e,n,"setState")},g.prototype.forceUpdate=function(e){this.updater.enqueueForceUpdate(this,e,"forceUpdate")},b.prototype=g.prototype;var x=y.prototype=new b;x.constructor=y,h(x,g.prototype),x.isPureReactComponent=!0;var w=Array.isArray,k=Object.prototype.hasOwnProperty,S={current:null},C={key:!0,ref:!0,__self:!0,__source:!0};function E(e,n,r){var a,l={},o=null,i=null;if(null!=n)for(a in void 0!==n.ref&&(i=n.ref),void 0!==n.key&&(o=""+n.key),n)k.call(n,a)&&!C.hasOwnProperty(a)&&(l[a]=n[a]);var u=arguments.length-2;if(1===u)l.children=r;else if(1<u){for(var s=Array(u),c=0;c<u;c++)s[c]=arguments[c+2];l.children=s}if(e&&e.defaultProps)for(a in u=e.defaultProps)void 0===l[a]&&(l[a]=u[a]);return{$$typeof:t,type:e,key:o,ref:i,props:l,_owner:S.current}}function P(e){return"object"==typeof e&&null!==e&&e.$$typeof===t}var _=/\/+/g;function M(e,n){return"object"==typeof e&&null!==e&&null!=e.key?function(e){var n={"=":"=0",":":"=2"};return"$"+e.replace(/[=:]/g,(function(e){return n[e]}))}(""+e.key):n.toString(36)}function j(e,n,a,l,o){var i=typeof e;"undefined"!==i&&"boolean"!==i||(e=null);var u=!1;if(null===e)u=!0;else switch(i){case"string":case"number":u=!0;break;case"object":switch(e.$$typeof){case t:case r:u=!0}}if(u)return o=o(u=e),e=""===l?"."+M(u,0):l,w(o)?(a="",null!=e&&(a=e.replace(_,"$&/")+"/"),j(o,n,a,"",(function(e){return e}))):null!=o&&(P(o)&&(o=function(e,n){return{$$typeof:t,type:e.type,key:n,ref:e.ref,props:e.props,_owner:e._owner}}(o,a+(!o.key||u&&u.key===o.key?"":(""+o.key).replace(_,"$&/")+"/")+e)),n.push(o)),1;if(u=0,l=""===l?".":l+":",w(e))for(var s=0;s<e.length;s++){var c=l+M(i=e[s],s);u+=j(i,n,a,c,o)}else if(c=function(e){return null===e||"object"!=typeof e?null:"function"==typeof(e=p&&e[p]||e["@@iterator"])?e:null}(e),"function"==typeof c)for(e=c.call(e),s=0;!(i=e.next()).done;)u+=j(i=i.value,n,a,c=l+M(i,s++),o);else if("object"===i)throw n=String(e),Error("Objects are not valid as a React child (found: "+("[object Object]"===n?"object with keys {"+Object.keys(e).join(", ")+"}":n)+"). If you meant to render a collection of children, use an array instead.");return u}function z(e,n,t){if(null==e)return e;var r=[],a=0;return j(e,r,"","",(function(e){return n.call(t,e,a++)})),r}function N(e){if(-1===e._status){var n=e._result;(n=n()).then((function(n){0!==e._status&&-1!==e._status||(e._status=1,e._result=n)}),(function(n){0!==e._status&&-1!==e._status||(e._status=2,e._result=n)})),-1===e._status&&(e._status=0,e._result=n)}if(1===e._status)return e._result.default;throw e._result}var T={current:null},F={transition:null},I={ReactCurrentDispatcher:T,ReactCurrentBatchConfig:F,ReactCurrentOwner:S};n.Children={map:z,forEach:function(e,n,t){z(e,(function(){n.apply(this,arguments)}),t)},count:function(e){var n=0;return z(e,(function(){n++})),n},toArray:function(e){return z(e,(function(e){return e}))||[]},only:function(e){if(!P(e))throw Error("React.Children.only expected to receive a single React element child.");return e}},n.Component=g,n.Fragment=a,n.Profiler=o,n.PureComponent=y,n.StrictMode=l,n.Suspense=c,n.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED=I,n.cloneElement=function(e,n,r){if(null==e)throw Error("React.cloneElement(...): The argument must be a React element, but you passed "+e+".");var a=h({},e.props),l=e.key,o=e.ref,i=e._owner;if(null!=n){if(void 0!==n.ref&&(o=n.ref,i=S.current),void 0!==n.key&&(l=""+n.key),e.type&&e.type.defaultProps)var u=e.type.defaultProps;for(s in n)k.call(n,s)&&!C.hasOwnProperty(s)&&(a[s]=void 0===n[s]&&void 0!==u?u[s]:n[s])}var s=arguments.length-2;if(1===s)a.children=r;else if(1<s){u=Array(s);for(var c=0;c<s;c++)u[c]=arguments[c+2];a.children=u}return{$$typeof:t,type:e.type,key:l,ref:o,props:a,_owner:i}},n.createContext=function(e){return(e={$$typeof:u,_currentValue:e,_currentValue2:e,_threadCount:0,Provider:null,Consumer:null,_defaultValue:null,_globalName:null}).Provider={$$typeof:i,_context:e},e.Consumer=e},n.createElement=E,n.createFactory=function(e){var n=E.bind(null,e);return n.type=e,n},n.createRef=function(){return{current:null}},n.forwardRef=function(e){return{$$typeof:s,render:e}},n.isValidElement=P,n.lazy=function(e){return{$$typeof:f,_payload:{_status:-1,_result:e},_init:N}},n.memo=function(e,n){return{$$typeof:d,type:e,compare:void 0===n?null:n}},n.startTransition=function(e){var n=F.transition;F.transition={};try{e()}finally{F.transition=n}},n.unstable_act=function(){throw Error("act(...) is not supported in production builds of React.")},n.useCallback=function(e,n){return T.current.useCallback(e,n)},n.useContext=function(e){return T.current.useContext(e)},n.useDebugValue=function(){},n.useDeferredValue=function(e){return T.current.useDeferredValue(e)},n.useEffect=function(e,n){return T.current.useEffect(e,n)},n.useId=function(){return T.current.useId()},n.useImperativeHandle=function(e,n,t){return T.current.useImperativeHandle(e,n,t)},n.useInsertionEffect=function(e,n){return T.current.useInsertionEffect(e,n)},n.useLayoutEffect=function(e,n){return T.current.useLayoutEffect(e,n)},n.useMemo=function(e,n){return T.current.useMemo(e,n)},n.useReducer=function(e,n,t){return T.current.useReducer(e,n,t)},n.useRef=function(e){return T.current.useRef(e)},n.useState=function(e){return T.current.useState(e)},n.useSyncExternalStore=function(e,n,t){return T.current.useSyncExternalStore(e,n,t)},n.useTransition=function(){return T.current.useTransition()},n.version="18.2.0"},7294:function(e,n,t){"use strict";e.exports=t(2408)},5893:function(e,n,t){"use strict";e.exports=t(5251)},53:function(e,n){"use strict";function t(e,n){var t=e.length;e.push(n);e:for(;0<t;){var r=t-1>>>1,a=e[r];if(!(0<l(a,n)))break e;e[r]=n,e[t]=a,t=r}}function r(e){return 0===e.length?null:e[0]}function a(e){if(0===e.length)return null;var n=e[0],t=e.pop();if(t!==n){e[0]=t;e:for(var r=0,a=e.length,o=a>>>1;r<o;){var i=2*(r+1)-1,u=e[i],s=i+1,c=e[s];if(0>l(u,t))s<a&&0>l(c,u)?(e[r]=c,e[s]=t,r=s):(e[r]=u,e[i]=t,r=i);else{if(!(s<a&&0>l(c,t)))break e;e[r]=c,e[s]=t,r=s}}}return n}function l(e,n){var t=e.sortIndex-n.sortIndex;return 0!==t?t:e.id-n.id}if("object"==typeof performance&&"function"==typeof performance.now){var o=performance;n.unstable_now=function(){return o.now()}}else{var i=Date,u=i.now();n.unstable_now=function(){return i.now()-u}}var s=[],c=[],d=1,f=null,p=3,m=!1,h=!1,v=!1,g="function"==typeof setTimeout?setTimeout:null,b="function"==typeof clearTimeout?clearTimeout:null,y="undefined"!=typeof setImmediate?setImmediate:null;function x(e){for(var n=r(c);null!==n;){if(null===n.callback)a(c);else{if(!(n.startTime<=e))break;a(c),n.sortIndex=n.expirationTime,t(s,n)}n=r(c)}}function w(e){if(v=!1,x(e),!h)if(null!==r(s))h=!0,F(k);else{var n=r(c);null!==n&&I(w,n.startTime-e)}}function k(e,t){h=!1,v&&(v=!1,b(P),P=-1),m=!0;var l=p;try{for(x(t),f=r(s);null!==f&&(!(f.expirationTime>t)||e&&!j());){var o=f.callback;if("function"==typeof o){f.callback=null,p=f.priorityLevel;var i=o(f.expirationTime<=t);t=n.unstable_now(),"function"==typeof i?f.callback=i:f===r(s)&&a(s),x(t)}else a(s);f=r(s)}if(null!==f)var u=!0;else{var d=r(c);null!==d&&I(w,d.startTime-t),u=!1}return u}finally{f=null,p=l,m=!1}}"undefined"!=typeof navigator&&void 0!==navigator.scheduling&&void 0!==navigator.scheduling.isInputPending&&navigator.scheduling.isInputPending.bind(navigator.scheduling);var S,C=!1,E=null,P=-1,_=5,M=-1;function j(){return!(n.unstable_now()-M<_)}function z(){if(null!==E){var e=n.unstable_now();M=e;var t=!0;try{t=E(!0,e)}finally{t?S():(C=!1,E=null)}}else C=!1}if("function"==typeof y)S=function(){y(z)};else if("undefined"!=typeof MessageChannel){var N=new MessageChannel,T=N.port2;N.port1.onmessage=z,S=function(){T.postMessage(null)}}else S=function(){g(z,0)};function F(e){E=e,C||(C=!0,S())}function I(e,t){P=g((function(){e(n.unstable_now())}),t)}n.unstable_IdlePriority=5,n.unstable_ImmediatePriority=1,n.unstable_LowPriority=4,n.unstable_NormalPriority=3,n.unstable_Profiling=null,n.unstable_UserBlockingPriority=2,n.unstable_cancelCallback=function(e){e.callback=null},n.unstable_continueExecution=function(){h||m||(h=!0,F(k))},n.unstable_forceFrameRate=function(e){0>e||125<e?console.error("forceFrameRate takes a positive int between 0 and 125, forcing frame rates higher than 125 fps is not supported"):_=0<e?Math.floor(1e3/e):5},n.unstable_getCurrentPriorityLevel=function(){return p},n.unstable_getFirstCallbackNode=function(){return r(s)},n.unstable_next=function(e){switch(p){case 1:case 2:case 3:var n=3;break;default:n=p}var t=p;p=n;try{return e()}finally{p=t}},n.unstable_pauseExecution=function(){},n.unstable_requestPaint=function(){},n.unstable_runWithPriority=function(e,n){switch(e){case 1:case 2:case 3:case 4:case 5:break;default:e=3}var t=p;p=e;try{return n()}finally{p=t}},n.unstable_scheduleCallback=function(e,a,l){var o=n.unstable_now();switch(l="object"==typeof l&&null!==l&&"number"==typeof(l=l.delay)&&0<l?o+l:o,e){case 1:var i=-1;break;case 2:i=250;break;case 5:i=1073741823;break;case 4:i=1e4;break;default:i=5e3}return e={id:d++,callback:a,priorityLevel:e,startTime:l,expirationTime:i=l+i,sortIndex:-1},l>o?(e.sortIndex=l,t(c,e),null===r(s)&&e===r(c)&&(v?(b(P),P=-1):v=!0,I(w,l-o))):(e.sortIndex=i,t(s,e),h||m||(h=!0,F(k))),e},n.unstable_shouldYield=j,n.unstable_wrapCallback=function(e){var n=p;return function(){var t=p;p=n;try{return e.apply(this,arguments)}finally{p=t}}}},3840:function(e,n,t){"use strict";e.exports=t(53)},3379:function(e){"use strict";var n=[];function t(e){for(var t=-1,r=0;r<n.length;r++)if(n[r].identifier===e){t=r;break}return t}function r(e,r){for(var l={},o=[],i=0;i<e.length;i++){var u=e[i],s=r.base?u[0]+r.base:u[0],c=l[s]||0,d="".concat(s," ").concat(c);l[s]=c+1;var f=t(d),p={css:u[1],media:u[2],sourceMap:u[3],supports:u[4],layer:u[5]};if(-1!==f)n[f].references++,n[f].updater(p);else{var m=a(p,r);r.byIndex=i,n.splice(i,0,{identifier:d,updater:m,references:1})}o.push(d)}return o}function a(e,n){var t=n.domAPI(n);return t.update(e),function(n){if(n){if(n.css===e.css&&n.media===e.media&&n.sourceMap===e.sourceMap&&n.supports===e.supports&&n.layer===e.layer)return;t.update(e=n)}else t.remove()}}e.exports=function(e,a){var l=r(e=e||[],a=a||{});return function(e){e=e||[];for(var o=0;o<l.length;o++){var i=t(l[o]);n[i].references--}for(var u=r(e,a),s=0;s<l.length;s++){var c=t(l[s]);0===n[c].references&&(n[c].updater(),n.splice(c,1))}l=u}}},569:function(e){"use strict";var n={};e.exports=function(e,t){var r=function(e){if(void 0===n[e]){var t=document.querySelector(e);if(window.HTMLIFrameElement&&t instanceof window.HTMLIFrameElement)try{t=t.contentDocument.head}catch(e){t=null}n[e]=t}return n[e]}(e);if(!r)throw new Error("Couldn't find a style target. This probably means that the value for the 'insert' parameter is invalid.");r.appendChild(t)}},9216:function(e){"use strict";e.exports=function(e){var n=document.createElement("style");return e.setAttributes(n,e.attributes),e.insert(n,e.options),n}},3565:function(e,n,t){"use strict";e.exports=function(e){var n=t.nc;n&&e.setAttribute("nonce",n)}},7795:function(e){"use strict";e.exports=function(e){var n=e.insertStyleElement(e);return{update:function(t){!function(e,n,t){var r="";t.supports&&(r+="@supports (".concat(t.supports,") {")),t.media&&(r+="@media ".concat(t.media," {"));var a=void 0!==t.layer;a&&(r+="@layer".concat(t.layer.length>0?" ".concat(t.layer):""," {")),r+=t.css,a&&(r+="}"),t.media&&(r+="}"),t.supports&&(r+="}");var l=t.sourceMap;l&&"undefined"!=typeof btoa&&(r+="\n/*# sourceMappingURL=data:application/json;base64,".concat(btoa(unescape(encodeURIComponent(JSON.stringify(l))))," */")),n.styleTagTransform(r,e,n.options)}(n,e,t)},remove:function(){!function(e){if(null===e.parentNode)return!1;e.parentNode.removeChild(e)}(n)}}}},4589:function(e){"use strict";e.exports=function(e,n){if(n.styleSheet)n.styleSheet.cssText=e;else{for(;n.firstChild;)n.removeChild(n.firstChild);n.appendChild(document.createTextNode(e))}}}},n={};function t(r){var a=n[r];if(void 0!==a)return a.exports;var l=n[r]={id:r,loaded:!1,exports:{}};return e[r](l,l.exports,t),l.loaded=!0,l.exports}t.n=function(e){var n=e&&e.__esModule?function(){return e.default}:function(){return e};return t.d(n,{a:n}),n},t.d=function(e,n){for(var r in n)t.o(n,r)&&!t.o(e,r)&&Object.defineProperty(e,r,{enumerable:!0,get:n[r]})},t.g=function(){if("object"==typeof globalThis)return globalThis;try{return this||new Function("return this")()}catch(e){if("object"==typeof window)return window}}(),t.o=function(e,n){return Object.prototype.hasOwnProperty.call(e,n)},t.nmd=function(e){return e.paths=[],e.children||(e.children=[]),e},t.nc=void 0,function(){"use strict";var e=t(7294);function n(e,n,t){let r=t;return null!=e&&(r=Math.max(e,r)),null!=n&&(r=Math.min(n,r)),r}function r(e,n){const t=10**n;return Math.round(e*t)/t}function a(){return Math.ceil(1e10*Math.random()).toString()}function l(e){let n=e.split(/\./g);if(n.length<3)return e;let[t,r,a]=n,l=[r,a];return"www"!==t&&l.unshift(t),l.join(".")}function o(e){return e>=1e3?`${r(e/1e3,1)}kHz`:`${Math.round(e)}hz`}function i(e,n,t){return e+t*(n-e)}const u={sepia:{min:0,max:1,step:.1,sliderMin:0,sliderMax:1,default:0,format:e=>`sepia(${e})`},hueRotate:{step:8,sliderMin:-180,sliderMax:180,sliderStep:1,default:0,format:e=>`hue-rotate(${e}deg)`},grayscale:{min:0,max:1,step:.1,sliderMin:0,sliderMax:1,default:0,format:e=>`grayscale(${e})`},contrast:{min:0,step:.1,sliderMin:0,sliderMax:5,default:1,format:e=>`contrast(${e})`},brightness:{min:0,step:.1,sliderMin:0,sliderMax:5,sliderStep:.05,default:1,format:e=>`brightness(${e})`},saturate:{min:0,step:.1,sliderMin:0,sliderMax:5,sliderStep:.05,default:1,format:e=>`saturate(${e})`},invert:{min:0,max:1,step:.1,sliderMin:0,sliderMax:1,default:0,format:e=>`invert(${e})`},blur:{min:0,step:.1,sliderMin:0,sliderMax:10,sliderStep:.1,default:0,format:e=>`blur(${e}px)`},opacity:{min:0,max:1,step:.1,sliderMin:0,sliderMax:1,default:1,format:e=>`opacity(${e})`},scaleX:{isTransform:!0,step:.1,sliderMin:-1,sliderMax:3,sliderStep:.04,default:1,format:e=>`scaleX(${e})`},scaleY:{isTransform:!0,step:.1,sliderMin:-1,sliderMax:3,sliderStep:.04,default:1,format:e=>`scaleY(${e})`},translateX:{isTransform:!0,step:1,sliderMin:-300,sliderMax:300,sliderStep:5,default:0,format:e=>`translateX(${e}px)`},translateY:{isTransform:!0,step:1,sliderMin:-300,sliderMax:300,sliderStep:5,default:0,format:e=>`translateY(${e}px)`},rotateX:{isTransform:!0,step:1,sliderMin:-180,sliderMax:180,sliderStep:1,default:0,format:e=>`rotateX(${e}deg)`},rotateY:{isTransform:!0,step:1,sliderMin:-180,sliderMax:180,sliderStep:1,default:0,format:e=>`rotateY(${e}deg)`},rotateZ:{isTransform:!0,step:1,sliderMin:-180,sliderMax:180,sliderStep:1,default:0,format:e=>`rotateZ(${e}deg)`}};function s(e){for(let n of e||[]){const e=u[n.name];if(null!=n.value&&n.value!==e.default)return!0}}function c(e,n,t,r){chrome.tabs.sendMessage(t,{type:"APPLY_MEDIA_EVENT",event:e,key:n},null==r?void 0:{frameId:r})}var d={color:void 0,size:void 0,className:void 0,style:void 0,attr:void 0},f=e.createContext&&e.createContext(d),p=function(){return p=Object.assign||function(e){for(var n,t=1,r=arguments.length;t<r;t++)for(var a in n=arguments[t])Object.prototype.hasOwnProperty.call(n,a)&&(e[a]=n[a]);return e},p.apply(this,arguments)},m=function(e,n){var t={};for(var r in e)Object.prototype.hasOwnProperty.call(e,r)&&n.indexOf(r)<0&&(t[r]=e[r]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var a=0;for(r=Object.getOwnPropertySymbols(e);a<r.length;a++)n.indexOf(r[a])<0&&Object.prototype.propertyIsEnumerable.call(e,r[a])&&(t[r[a]]=e[r[a]])}return t};function h(n){return n&&n.map((function(n,t){return e.createElement(n.tag,p({key:t},n.attr),h(n.child))}))}function v(n){return function(t){return e.createElement(g,p({attr:p({},n.attr)},t),h(n.child))}}function g(n){var t=function(t){var r,a=n.attr,l=n.size,o=n.title,i=m(n,["attr","size","title"]),u=l||t.size||"1em";return t.className&&(r=t.className),n.className&&(r=(r?r+" ":"")+n.className),e.createElement("svg",p({stroke:"currentColor",fill:"currentColor",strokeWidth:"0"},t.attr,a,i,{className:r,style:p(p({color:n.color||t.color},t.style),n.style),height:u,width:u,xmlns:"http://www.w3.org/2000/svg"}),o&&e.createElement("title",null,o),n.children)};return void 0!==f?e.createElement(f.Consumer,null,(function(e){return t(e)})):t(d)}function b(e){return v({tag:"svg",attr:{viewBox:"0 0 10 16"},child:[{tag:"path",attr:{fillRule:"evenodd",d:"M7 7V3H3v4H0l5 6 5-6H7z"}}]})(e)}function y(e){return v({tag:"svg",attr:{viewBox:"0 0 10 16"},child:[{tag:"path",attr:{fillRule:"evenodd",d:"M6 3L0 8l6 5v-3h4V6H6V3z"}}]})(e)}function x(e){return v({tag:"svg",attr:{viewBox:"0 0 10 16"},child:[{tag:"path",attr:{fillRule:"evenodd",d:"M5 3L0 9h3v4h4V9h3L5 3z"}}]})(e)}function w(e){return v({tag:"svg",attr:{viewBox:"0 0 10 16"},child:[{tag:"path",attr:{fillRule:"evenodd",d:"M5 11L0 6l1.5-1.5L5 8.25 8.5 4.5 10 6l-5 5z"}}]})(e)}function k(e){return v({tag:"svg",attr:{viewBox:"0 0 10 16"},child:[{tag:"path",attr:{fillRule:"evenodd",d:"M10 10l-1.5 1.5L5 7.75 1.5 11.5 0 10l5-5 5 5z"}}]})(e)}function S(e){return v({tag:"svg",attr:{viewBox:"0 0 14 16"},child:[{tag:"path",attr:{fillRule:"evenodd",d:"M14 8.77v-1.6l-1.94-.64-.45-1.09.88-1.84-1.13-1.13-1.81.91-1.09-.45-.69-1.92h-1.6l-.63 1.94-1.11.45-1.84-.88-1.13 1.13.91 1.81-.45 1.09L0 7.23v1.59l1.94.64.45 1.09-.88 1.84 1.13 1.13 1.81-.91 1.09.45.69 1.92h1.59l.63-1.94 1.11-.45 1.84.88 1.13-1.13-.92-1.81.47-1.09L14 8.75v.02zM7 11c-1.66 0-3-1.34-3-3s1.34-3 3-3 3 1.34 3 3-1.34 3-3 3z"}}]})(e)}function C(e){return v({tag:"svg",attr:{viewBox:"0 0 16 16"},child:[{tag:"path",attr:{fillRule:"evenodd",d:"M8 0C3.58 0 0 3.58 0 8c0 3.54 2.29 6.53 5.47 7.59.4.07.55-.17.55-.38 0-.19-.01-.82-.01-1.49-2.01.37-2.53-.49-2.69-.94-.09-.23-.48-.94-.82-1.13-.28-.15-.68-.52-.01-.53.63-.01 1.08.58 1.23.82.72 1.21 1.87.87 2.33.66.07-.52.28-.87.51-1.07-1.78-.2-3.64-.89-3.64-3.95 0-.87.31-1.59.82-2.15-.08-.2-.36-1.02.08-2.12 0 0 .67-.21 2.2.82.64-.18 1.32-.27 2-.27.68 0 1.36.09 2 .27 1.53-1.04 2.2-.82 2.2-.82.44 1.1.16 1.92.08 2.12.51.56.82 1.27.82 2.15 0 3.07-1.87 3.75-3.65 3.95.29.25.54.73.54 1.48 0 1.07-.01 1.93-.01 2.2 0 .21.15.46.55.38A8.013 8.013 0 0 0 16 8c0-4.42-3.58-8-8-8z"}}]})(e)}function E(e){return v({tag:"svg",attr:{viewBox:"0 0 16 16"},child:[{tag:"path",attr:{fillRule:"evenodd",d:"M10 1.2V2l.5 1L6 6H2.2c-.44 0-.67.53-.34.86L5 10l-4 5 5-4 3.14 3.14a.5.5 0 0 0 .86-.34V10l3-4.5 1 .5h.8c.44 0 .67-.53.34-.86L10.86.86a.5.5 0 0 0-.86.34z"}}]})(e)}function P(e){return v({tag:"svg",attr:{viewBox:"0 0 10 16"},child:[{tag:"path",attr:{fillRule:"evenodd",d:"M10 7H6l3-7-9 9h4l-3 7 9-9z"}}]})(e)}function _(e){return v({tag:"svg",attr:{viewBox:"0 0 448 512"},child:[{tag:"path",attr:{d:"M223.7 239l136-136c9.4-9.4 24.6-9.4 33.9 0l22.6 22.6c9.4 9.4 9.4 24.6 0 33.9L319.9 256l96.4 96.4c9.4 9.4 9.4 24.6 0 33.9L393.7 409c-9.4 9.4-24.6 9.4-33.9 0l-136-136c-9.5-9.4-9.5-24.6-.1-34zm-192 34l136 136c9.4 9.4 24.6 9.4 33.9 0l22.6-22.6c9.4-9.4 9.4-24.6 0-33.9L127.9 256l96.4-96.4c9.4-9.4 9.4-24.6 0-33.9L201.7 103c-9.4-9.4-24.6-9.4-33.9 0l-136 136c-9.5 9.4-9.5 24.6-.1 34z"}}]})(e)}function M(e){return v({tag:"svg",attr:{viewBox:"0 0 448 512"},child:[{tag:"path",attr:{d:"M224.3 273l-136 136c-9.4 9.4-24.6 9.4-33.9 0l-22.6-22.6c-9.4-9.4-9.4-24.6 0-33.9l96.4-96.4-96.4-96.4c-9.4-9.4-9.4-24.6 0-33.9L54.3 103c9.4-9.4 24.6-9.4 33.9 0l136 136c9.5 9.4 9.5 24.6.1 34zm192-34l-136-136c-9.4-9.4-24.6-9.4-33.9 0l-22.6 22.6c-9.4 9.4-9.4 24.6 0 33.9l96.4 96.4-96.4 96.4c-9.4 9.4-9.4 24.6 0 33.9l22.6 22.6c9.4 9.4 24.6 9.4 33.9 0l136-136c9.4-9.2 9.4-24.4 0-33.8z"}}]})(e)}function j(e){return v({tag:"svg",attr:{viewBox:"0 0 256 512"},child:[{tag:"path",attr:{d:"M31.7 239l136-136c9.4-9.4 24.6-9.4 33.9 0l22.6 22.6c9.4 9.4 9.4 24.6 0 33.9L127.9 256l96.4 96.4c9.4 9.4 9.4 24.6 0 33.9L201.7 409c-9.4 9.4-24.6 9.4-33.9 0l-136-136c-9.5-9.4-9.5-24.6-.1-34z"}}]})(e)}function z(e){return v({tag:"svg",attr:{viewBox:"0 0 256 512"},child:[{tag:"path",attr:{d:"M224.3 273l-136 136c-9.4 9.4-24.6 9.4-33.9 0l-22.6-22.6c-9.4-9.4-9.4-24.6 0-33.9l96.4-96.4-96.4-96.4c-9.4-9.4-9.4-24.6 0-33.9L54.3 103c9.4-9.4 24.6-9.4 33.9 0l136 136c9.5 9.4 9.5 24.6.1 34z"}}]})(e)}function N(e){return v({tag:"svg",attr:{viewBox:"0 0 512 512"},child:[{tag:"path",attr:{d:"M377.941 169.941V216H134.059v-46.059c0-21.382-25.851-32.09-40.971-16.971L7.029 239.029c-9.373 9.373-9.373 24.568 0 33.941l86.059 86.059c15.119 15.119 40.971 4.411 40.971-16.971V296h243.882v46.059c0 21.382 25.851 32.09 40.971 16.971l86.059-86.059c9.373-9.373 9.373-24.568 0-33.941l-86.059-86.059c-15.119-15.12-40.971-4.412-40.971 16.97z"}}]})(e)}function T(e){return v({tag:"svg",attr:{viewBox:"0 0 512 512"},child:[{tag:"path",attr:{d:"M11.5 280.6l192 160c20.6 17.2 52.5 2.8 52.5-24.6V96c0-27.4-31.9-41.8-52.5-24.6l-192 160c-15.3 12.8-15.3 36.4 0 49.2zm256 0l192 160c20.6 17.2 52.5 2.8 52.5-24.6V96c0-27.4-31.9-41.8-52.5-24.6l-192 160c-15.3 12.8-15.3 36.4 0 49.2z"}}]})(e)}function F(e){return v({tag:"svg",attr:{viewBox:"0 0 512 512"},child:[{tag:"path",attr:{d:"M0 168v-16c0-13.255 10.745-24 24-24h360V80c0-21.367 25.899-32.042 40.971-16.971l80 80c9.372 9.373 9.372 24.569 0 33.941l-80 80C409.956 271.982 384 261.456 384 240v-48H24c-13.255 0-24-10.745-24-24zm488 152H128v-48c0-21.314-25.862-32.08-40.971-16.971l-80 80c-9.372 9.373-9.372 24.569 0 33.941l80 80C102.057 463.997 128 453.437 128 432v-48h360c13.255 0 24-10.745 24-24v-16c0-13.255-10.745-24-24-24z"}}]})(e)}function I(e){return v({tag:"svg",attr:{viewBox:"0 0 512 512"},child:[{tag:"path",attr:{d:"M500.5 231.4l-192-160C287.9 54.3 256 68.6 256 96v320c0 27.4 31.9 41.8 52.5 24.6l192-160c15.3-12.8 15.3-36.4 0-49.2zm-256 0l-192-160C31.9 54.3 0 68.6 0 96v320c0 27.4 31.9 41.8 52.5 24.6l192-160c15.3-12.8 15.3-36.4 0-49.2z"}}]})(e)}function O(e){return v({tag:"svg",attr:{viewBox:"0 0 352 512"},child:[{tag:"path",attr:{d:"M176 352c53.02 0 96-42.98 96-96V96c0-53.02-42.98-96-96-96S80 42.98 80 96v160c0 53.02 42.98 96 96 96zm160-160h-16c-8.84 0-16 7.16-16 16v48c0 74.8-64.49 134.82-140.79 127.38C96.71 376.89 48 317.11 48 250.3V208c0-8.84-7.16-16-16-16H16c-8.84 0-16 7.16-16 16v40.16c0 89.64 63.97 169.55 152 181.69V464H96c-8.84 0-16 7.16-16 16v16c0 8.84 7.16 16 16 16h160c8.84 0 16-7.16 16-16v-16c0-8.84-7.16-16-16-16h-56v-33.77C285.71 418.47 352 344.9 352 256v-48c0-8.84-7.16-16-16-16z"}}]})(e)}function L(e){return v({tag:"svg",attr:{viewBox:"0 0 320 512"},child:[{tag:"path",attr:{d:"M302.189 329.126H196.105l55.831 135.993c3.889 9.428-.555 19.999-9.444 23.999l-49.165 21.427c-9.165 4-19.443-.571-23.332-9.714l-53.053-129.136-86.664 89.138C18.729 472.71 0 463.554 0 447.977V18.299C0 1.899 19.921-6.096 30.277 5.443l284.412 292.542c11.472 11.179 3.007 31.141-12.5 31.141z"}}]})(e)}function A(e){return v({tag:"svg",attr:{viewBox:"0 0 512 512"},child:[{tag:"path",attr:{d:"M470.38 1.51L150.41 96A32 32 0 0 0 128 126.51v261.41A139 139 0 0 0 96 384c-53 0-96 28.66-96 64s43 64 96 64 96-28.66 96-64V214.32l256-75v184.61a138.4 138.4 0 0 0-32-3.93c-53 0-96 28.66-96 64s43 64 96 64 96-28.65 96-64V32a32 32 0 0 0-41.62-30.49z"}}]})(e)}function D(e){return v({tag:"svg",attr:{viewBox:"0 0 448 512"},child:[{tag:"path",attr:{d:"M144 479H48c-26.5 0-48-21.5-48-48V79c0-26.5 21.5-48 48-48h96c26.5 0 48 21.5 48 48v352c0 26.5-21.5 48-48 48zm304-48V79c0-26.5-21.5-48-48-48h-96c-26.5 0-48 21.5-48 48v352c0 26.5 21.5 48 48 48h96c26.5 0 48-21.5 48-48z"}}]})(e)}function R(e){return v({tag:"svg",attr:{viewBox:"0 0 448 512"},child:[{tag:"path",attr:{d:"M424.4 214.7L72.4 6.6C43.8-10.3 0 6.1 0 47.9V464c0 37.5 40.7 60.1 72.4 41.3l352-208c31.4-18.5 31.5-64.1 0-82.6z"}}]})(e)}function B(e){return v({tag:"svg",attr:{viewBox:"0 0 512 512"},child:[{tag:"path",attr:{d:"M400 54.1c63 45 104 118.6 104 201.9 0 136.8-110.8 247.7-247.5 248C120 504.3 8.2 393 8 256.4 7.9 173.1 48.9 99.3 111.8 54.2c11.7-8.3 28-4.8 35 7.7L162.6 90c5.9 10.5 3.1 23.8-6.6 31-41.5 30.8-68 79.6-68 134.9-.1 92.3 74.5 168.1 168 168.1 91.6 0 168.6-74.2 168-169.1-.3-51.8-24.7-101.8-68.1-134-9.7-7.2-12.4-20.5-6.5-30.9l15.8-28.1c7-12.4 23.2-16.1 34.8-7.8zM296 264V24c0-13.3-10.7-24-24-24h-32c-13.3 0-24 10.7-24 24v240c0 13.3 10.7 24 24 24h32c13.3 0 24-10.7 24-24z"}}]})(e)}function $(e){return v({tag:"svg",attr:{viewBox:"0 0 384 512"},child:[{tag:"path",attr:{d:"M215.03 72.04L126.06 161H24c-13.26 0-24 10.74-24 24v144c0 13.25 10.74 24 24 24h102.06l88.97 88.95c15.03 15.03 40.97 4.47 40.97-16.97V89.02c0-21.47-25.96-31.98-40.97-16.98zm123.2 108.08c-11.58-6.33-26.19-2.16-32.61 9.45-6.39 11.61-2.16 26.2 9.45 32.61C327.98 229.28 336 242.62 336 257c0 14.38-8.02 27.72-20.92 34.81-11.61 6.41-15.84 21-9.45 32.61 6.43 11.66 21.05 15.8 32.61 9.45 28.23-15.55 45.77-45 45.77-76.88s-17.54-61.32-45.78-76.87z"}}]})(e)}function U(e){return v({tag:"svg",attr:{viewBox:"0 0 512 512"},child:[{tag:"path",attr:{d:"M215.03 71.05L126.06 160H24c-13.26 0-24 10.74-24 24v144c0 13.25 10.74 24 24 24h102.06l88.97 88.95c15.03 15.03 40.97 4.47 40.97-16.97V88.02c0-21.46-25.96-31.98-40.97-16.97zM461.64 256l45.64-45.64c6.3-6.3 6.3-16.52 0-22.82l-22.82-22.82c-6.3-6.3-16.52-6.3-22.82 0L416 210.36l-45.64-45.64c-6.3-6.3-16.52-6.3-22.82 0l-22.82 22.82c-6.3 6.3-6.3 16.52 0 22.82L370.36 256l-45.63 45.63c-6.3 6.3-6.3 16.52 0 22.82l22.82 22.82c6.3 6.3 16.52 6.3 22.82 0L416 301.64l45.64 45.64c6.3 6.3 16.52 6.3 22.82 0l22.82-22.82c6.3-6.3 6.3-16.52 0-22.82L461.64 256z"}}]})(e)}function V(e){return v({tag:"svg",attr:{viewBox:"0 0 576 512"},child:[{tag:"path",attr:{d:"M215.03 71.05L126.06 160H24c-13.26 0-24 10.74-24 24v144c0 13.25 10.74 24 24 24h102.06l88.97 88.95c15.03 15.03 40.97 4.47 40.97-16.97V88.02c0-21.46-25.96-31.98-40.97-16.97zm233.32-51.08c-11.17-7.33-26.18-4.24-33.51 6.95-7.34 11.17-4.22 26.18 6.95 33.51 66.27 43.49 105.82 116.6 105.82 195.58 0 78.98-39.55 152.09-105.82 195.58-11.17 7.32-14.29 22.34-6.95 33.5 7.04 10.71 21.93 14.56 33.51 6.95C528.27 439.58 576 351.33 576 256S528.27 72.43 448.35 19.97zM480 256c0-63.53-32.06-121.94-85.77-156.24-11.19-7.14-26.03-3.82-33.12 7.46s-3.78 26.21 7.41 33.36C408.27 165.97 432 209.11 432 256s-23.73 90.03-63.48 115.42c-11.19 7.14-14.5 22.07-7.41 33.36 6.51 10.36 21.12 15.14 33.12 7.46C447.94 377.94 480 319.54 480 256zm-141.77-76.87c-11.58-6.33-26.19-2.16-32.61 9.45-6.39 11.61-2.16 26.2 9.45 32.61C327.98 228.28 336 241.63 336 256c0 14.38-8.02 27.72-20.92 34.81-11.61 6.41-15.84 21-9.45 32.61 6.43 11.66 21.05 15.8 32.61 9.45 28.23-15.55 45.77-45 45.77-76.88s-17.54-61.32-45.78-76.86z"}}]})(e)}let H,Z;var W,q,Q,K;(K=H||(H={}))[K.SET=1]="SET",K[K.ADD=2]="ADD",K[K.CYCLE=3]="CYCLE",function(e){e[e.FX=1]="FX",e[e.AUDIO_FX=2]="AUDIO_FX",e[e.MEDIA=3]="MEDIA",e[e.MISC=4]="MISC"}(Z||(Z={}));const X=!(!("requestPictureInPicture"in HTMLVideoElement.prototype)||!("pictureInPictureElement"in Document.prototype)),Y=(null===(W=document.featurePolicy)||void 0===W||W.allowsFeature("picture-in-picture"),null===(q=window.CSS)||void 0===q||null===(Q=q.supports)||void 0===Q?void 0:Q.call(q,"backdrop-filter: invert(1)"));let G={nothing:{group:Z.MISC,generate:()=>({id:a(),command:"nothing",enabled:!0,greedy:!0})},runCode:{group:Z.MISC,valueType:"modalString",generate:()=>({id:a(),command:"runCode",enabled:!0,greedy:!0,valueString:"// code here"})},openUrl:{group:Z.MISC,valueType:"string",generate:()=>({id:a(),command:"openUrl",enabled:!0,greedy:!0,valueString:"https://www.google.com/"})},adjustSpeed:{valueType:"adjustMode",hasFeedback:!0,valueMin:.07,valueMax:16,valueStep:.1,valueDefault:1,generate:()=>({id:a(),command:"adjustSpeed",enabled:!0,greedy:!0,adjustMode:H.SET})},speedChangesPitch:{valueType:"state",hasFeedback:!0,requiresMedia:!0,generate:()=>({id:a(),command:"speedChangesPitch",enabled:!0,greedy:!0,valueState:"toggle"})},setPin:{valueType:"state",hasFeedback:!0,generate:()=>({id:a(),command:"setPin",enabled:!0,greedy:!0,valueState:"toggle"})},setState:{valueType:"state",hasFeedback:!0,generate:()=>({id:a(),command:"setState",enabled:!0,greedy:!0,valueState:"toggle"})},seek:{group:Z.MEDIA,valueType:"number",requiresMedia:!0,noNull:!0,hasFeedback:!0,generate:()=>({id:a(),command:"seek",enabled:!0,greedy:!0,valueNumber:10})},setPause:{group:Z.MEDIA,valueType:"state",requiresMedia:!0,hasFeedback:!0,generate:()=>({id:a(),command:"setPause",enabled:!0,greedy:!0,valueState:"toggle"})},setMute:{group:Z.MEDIA,hasFeedback:!0,valueType:"state",requiresMedia:!0,generate:()=>({id:a(),command:"setMute",enabled:!0,greedy:!0,valueState:"toggle"})},adjustVolume:{group:Z.MEDIA,hasFeedback:!0,valueType:"number",requiresMedia:!0,valueDefault:.05,generate:()=>({id:a(),command:"adjustVolume",enabled:!0,greedy:!0})},setMark:{group:Z.MEDIA,hasFeedback:!0,valueType:"string",requiresMedia:!0,generate:()=>({id:a(),command:"setMark",enabled:!0,greedy:!0,valueString:"mark1"})},seekMark:{group:Z.MEDIA,hasFeedback:!0,valueType:"string",requiresMedia:!0,generate:()=>({id:a(),command:"seekMark",enabled:!0,greedy:!0,valueString:"mark1"})},toggleLoop:{group:Z.MEDIA,hasFeedback:!0,valueType:"string",requiresMedia:!0,generate:()=>({id:a(),command:"toggleLoop",enabled:!0,greedy:!0,valueString:"mark1"})},fullscreen:{group:Z.MEDIA,requiresVideo:!0,generate:()=>({id:a(),command:"fullscreen",enabled:!0,greedy:!0})},PiP:{group:Z.MEDIA,valueType:"state",requiresVideo:!0,requiresPiPApi:!0,generate:()=>({id:a(),command:"PiP",enabled:!0,greedy:!0,valueState:"toggle"})},setFx:{group:Z.FX,hasFeedback:!0,withFilterTarget:!0,valueType:"state",generate:()=>({id:a(),command:"setFx",enabled:!0,greedy:!0,valueState:"toggle",filterTarget:"element"})},resetFx:{group:Z.FX,hasFeedback:!0,withFilterTarget:!0,generate:()=>({id:a(),command:"resetFx",enabled:!0,greedy:!0,filterTarget:"element"})},flipFx:{group:Z.FX,hasFeedback:!0,generate:()=>({id:a(),command:"flipFx",enabled:!0,greedy:!0})},adjustFilter:{group:Z.FX,hasFeedback:!0,valueType:"adjustMode",withFilterOption:!0,withFilterTarget:!0,generate:()=>({id:a(),command:"adjustFilter",filterOption:"hueRotate",enabled:!0,greedy:!0,filterTarget:"element",adjustMode:H.ADD})},adjustGain:{group:Z.AUDIO_FX,hasFeedback:!0,valueType:"adjustMode",requiresTabCapture:!0,valueMin:0,valueMax:16,valueStep:.05,valueDefault:1,generate:()=>({id:a(),command:"adjustGain",enabled:!0,greedy:!0,adjustMode:H.ADD})},adjustPitch:{group:Z.AUDIO_FX,hasFeedback:!0,valueType:"adjustMode",requiresTabCapture:!0,valueMin:-36,valueMax:36,valueStep:1,valueDefault:0,generate:()=>({id:a(),command:"adjustPitch",enabled:!0,greedy:!0,adjustMode:H.ADD})},adjustDelay:{group:Z.AUDIO_FX,hasFeedback:!0,valueType:"adjustMode",requiresTabCapture:!0,valueMin:0,valueMax:60,valueStep:.05,valueDefault:0,generate:()=>({id:a(),command:"adjustDelay",enabled:!0,greedy:!0,adjustMode:H.ADD})},adjustPan:{group:Z.AUDIO_FX,hasFeedback:!0,valueType:"adjustMode",requiresTabCapture:!0,valueMin:-1,valueMax:1,valueStep:.05,valueDefault:0,generate:()=>({id:a(),command:"adjustPan",enabled:!0,greedy:!0,adjustMode:H.ADD})},tabCapture:{group:Z.AUDIO_FX,hasFeedback:!0,valueType:"state",requiresTabCapture:!0,generate:()=>({id:a(),command:"tabCapture",enabled:!0,greedy:!0,valueState:"toggle",global:!0})}};function J(){const[e,n]=function(e,n){let t=[],r=[];return e.forEach((e=>{(e=>{let[n,t]=e;return t.isTransform})(e)?t.push(e):r.push(e)})),[t,r]}(Object.entries(u));return{filters:n.map((e=>{let[n,t]=e;return{name:n,value:t.default}})),transforms:e.map((e=>{let[n,t]=e;return{name:n,value:t.default}}))}}function ee(){return{enabled:!1,factor:1,values:Array(10).fill(0)}}!function(e,n){let t=[],r=!1;for(let n of e)r&&(t.push(null),r=!1),t=[...t,...n],r=!0}(function(e,n){let t=new Map;for(let a of e){var r;const e=n(a),l=null!==(r=t.get(e))&&void 0!==r?r:[];l.push(a),t.set(e,l)}const a=[];return t.forEach((e=>{a.push(e)})),a}(Object.entries(G).filter((e=>!e[1].requiresTabCapture||chrome.tabCapture)).filter((e=>!e[1].requiresPiPApi||X)).map((e=>{let[n,t]=e;return[n,t.group]})),(e=>e[1])).map((e=>e.map((e=>e[0])))));const ne={10:Object.freeze([{name:"1965",values:[-6,-17.2,-6,0,-3.6,9.2,1.2,9.2,3.6,-5.2]},{name:"1965 - Part 2",values:[-18,-14.4,0,0,-3.6,9.2,1.2,9.2,3.6,-5.2]},{name:"Lo-Fidelity",values:[-15.1,-9.4,0,2.3,-2,4.3,4.3,-2.3,-4.6,-8.9]},{name:"Musical Presence",values:[0,0,0,0,0,2.5,5,2.5,0,0]},{name:"Notch Every Two Octaves",values:[-18,17.99,-18,17.99,-18,17.99,-18,17.99,-18,17.99]},{name:"Rattle The Trunk",values:[17.99,17.99,9,0,0,0,0,0,0,0]},{name:"Simple Bass Cut",values:[-4,-3,-2,-2,-2,0,0,0,0,0]},{name:"Simple Bass Lift",values:[6,6,3,3,3,0,0,0,0,0]},{name:"Simple High Cut",values:[0,0,0,0,0,-2,-2,-3,-3,-3]},{name:"Simple High Lift",values:[0,0,0,0,0,1,2,2,3,4]},{name:"Vocal Presence - Boost",values:[0,0,0,0,0,0,6.5,0,0,0]},{name:"Vocal Presence - Cut",values:[0,0,0,0,0,0,-6.5,0,0,0]}]),20:Object.freeze([{name:"20 Band Classic V",values:[5,6,3.54,.59,-.48,-2.5,-5,-7,-8,-8,-7,-5,-3,-2.5,-1,2,3,4,5,4.02]},{name:"Bowed String",values:[0,0,-1.2,-1.6,-2.4,-2.8,-1.6,-1.6,-1.6,0,0,0,0,0,2.4,3.6,5.6,0,0,0]},{name:"Bright and Punchy",values:[-3,3,6,4.5,3,1.5,0,0,0,0,0,0,0,1,2,3,4,4,4,4]},{name:"Cymbal Shimmer",values:[0,0,0,0,0,0,0,0,0,0,0,-.1,-.3,-.5,-.4,.2,1.3,2.6,3.6,4]},{name:"Dark and Dull",values:[-6,-4,-2,0,0,0,0,0,0,0,0,0,0,-3,-6,-9,-12,-15,-18,-18]},{name:"Destination - Car Stereo",values:[-4,-2,0,3,4,3,1.5,0,-1,-2,-2,-1,0,1,2,3,4,2,0,-3]},{name:"Heavy Guitar",values:[0,-.2,-.1,1,1.9,1.6,.4,-.5,-1.1,-2.2,-3.6,-3.9,-2.9,-1.6,-.5,.1,.1,0,0,0]},{name:"Liven up dead samples",values:[0,0,0,0,0,0,0,0,0,0,0,.1,.1,-.2,-.6,.5,3,3.9,1.5,-.4]},{name:"Notch Every Octave",values:[-18,17.99,-18,17.99,-18,17.99,-18,17.99,-18,17.99,-18,17.99,-18,17.99,-18,17.99,-18,17.99,-18,17.99]},{name:"Possible Bass",values:[0,0,5.2,6,3.2,0,-11.6,-5.2,-4,-4,0,3.2,4.8,0,0,0,-3.2,-7.2,-10.8,-14]},{name:"Sloping High End Boost",values:[0,0,0,0,0,0,0,0,0,0,1,2,3,4,5,6,6,7,8,8]},{name:"Sloping Low End Boost",values:[8,8,8,8,7,6,5,4,3,2,1,0,0,0,0,0,0,0,0,0]},{name:"Tinny and Brittle",values:[-10,-9,-8,-7,-6,-5,-4,-3,-2,-1,0,0,0,0,1,3.52,6,6,3,1]},{name:"Vocal Magic (breath)",values:[0,0,0,0,0,0,0,0,0,0,0,0,0,0,.1,-.1,-.5,2,2.5,1]}]),30:Object.freeze([{name:"Bass - Increased Clarity",values:[-4,-3.4,-1.9,-.3,.6,.6,.2,-.3,-1.2,-1.5,1.4,2.9,.7,.2,.8,.5,0,-2,-.5,-.5,-.4,-.2,0,0,-.2,-.4,-.4,-.3,-.1,0]},{name:"Background Vocal",values:[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-.2,-.3,-.4,-.4,-3,-6,-3,0,0,-.1,0,0,0]},{name:"Classic V",values:[3,2.5,1.3,.2,-.4,-.5,-.2,.2,.4,.3,-.3,-1.6,-3.4,-5.7,-8.2,-10.2,-10.9,-9.8,-7.4,-4.5,-2.3,-.9,-.1,0,-.2,-.3,.2,1.3,2.5,3]},{name:"Destination - Home Theater",values:[4.5,6,7.5,7.5,5,3,1.5,.5,0,-.5,-1.5,-3,-5,-3,-1.5,0,1.5,3,3,3,1.5,0,0,3,6,7.5,7.5,6,3,0]},{name:"Drums",values:[0,0,0,0,0,0,0,-.1,.3,.4,-2,-2.8,0,.6,-.2,-.1,0,-.2,-.3,-.5,-.4,-.1,0,0,.2,-.3,-.1,2.5,2.1,0]},{name:"Generic Attack Booster",values:[0,0,0,0,0,0,0,0,0,0,0,0,0,0,-.1,-.1,-.1,.2,.6,1.3,2,2.8,3.1,2.7,1.8,.6,-.2,-.3,-.1,0]},{name:"Generic Mud Removal",values:[0,0,0,0,-.1,-.3,-.7,-1.5,-2.4,-3,-2.8,-2,-.8,0,.4,.3,0,-.1,-.1,0,0,0,0,0,0,0,0,0,0,0]},{name:"Gentle Hi Boost",values:[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,.5,1.5,3,5,5,3,1.5,.5]},{name:"Gentle Hi Cut",values:[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-.5,-1.5,-3,-5,-5,-3,-1.5,-.5]},{name:"Gentle Low Boost",values:[0,.5,1.5,3,5,3,1.5,.5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]},{name:"Gentle Low Cut",values:[0,-.5,-1.5,-3,-5,-3,-1.5,-.5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]},{name:"Gentle Mid Boost",values:[0,0,0,0,0,0,0,0,0,0,0,0,0,.5,1.5,3,5,5,3,1.5,.5,0,0,0,0,0,0,0,0,0]},{name:"Gentle Mid Cut",values:[0,0,0,0,0,0,0,0,0,0,0,0,0,-.5,-1.5,-3,-5,-5,-3,-1.5,-.5,0,0,0,0,0,0,0,0,0]},{name:"Guitar - Increases Attack",values:[0,0,0,0,-1.5,-4,-2,0,0,0,0,0,0,0,0,0,0,-.2,-.3,-.4,2,0,-.1,0,0,0,-.1,0,0,0]},{name:"Keyboards - Bright and Clear",values:[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-.2,-.3,-.4,-.4,2,5,2.5,0,0,-.1,0,0,0]},{name:"Kick - Less Boxy, more Attack",values:[0,0,0,0,0,0,0,0,0,0,-2.5,-6,-2.5,0,0,0,0,0,0,0,0,2,5,2,0,0,0,0,0,0]},{name:"Lead Vocal - Clarity",values:[0,0,0,0,0,0,0,0,-3,0,0,0,0,0,0,0,0,-.2,-.3,-.4,-.4,0,2,0,0,4,-.1,0,0,0]},{name:"Notch Every 2/3 Octave",values:[-18,17.99,-18,17.99,-18,17.99,-18,17.99,-18,17.99,-18,17.99,-18,17.99,-18,17.99,-18,17.99,-18,17.99,-18,17.99,-18,17.99,-18,17.99,-18,17.99,-18,17.99]},{name:"RIAA De-Emphasis",values:[18.3,17.6,16.7,15.6,14.2,12.8,11.3,9.6,8,6.5,5,3.7,2.6,1.6,.7,0,-.7,-1.6,-2.6,-3.7,-5.1,-6.6,-8.2,-10,-11.9,-13.8,-15.7,-17.7,-19.7,-20]},{name:"Snare - Increase Snap",values:[0,-.1,-.2,-.1,.5,1.3,1.9,1.9,1.3,.4,-.1,-.3,-.2,0,.1,0,0,-.1,-.2,-.4,-.6,-.7,-.5,1.5,2,0,0,0,.9,0]},{name:"cymbals sans gong",values:[-8,-6.5,-3.3,-.4,.4,-.5,-2.3,-3.7,-4.5,-4.4,-3.7,-2.3,-.9,.1,.5,.3,0,-.3,-.5,-.5,-.4,-.2,0,.1,0,0,-.1,0,0,0]}])};var te=t(3465),re=t.n(te),ae=t(1296),le=t.n(ae);function oe(e){var n;return null!==(n=window.globalState)&&void 0!==n&&n.set?(window.globalState.set(e),Promise.resolve()):new Promise(((n,t)=>{const r={};for(let[n,t]of Object.entries(e.override||{}))r[n]=null!=t?t:null;e.override=r,chrome.runtime.sendMessage({type:"PUSH_VIEW",init:e},(e=>{chrome.runtime.lastError?t(chrome.runtime.lastError):n()}))}))}var ie=t(3174).$;function ue(n,t,r){const[l,o]=(0,e.useState)(null),i=(0,e.useMemo)((()=>({})),[]);(0,e.useEffect)((()=>{var e;return i.client=function(e,n,t,r,l,o){e=function(e){return Object.fromEntries(Object.entries(e).filter((e=>{let[n,t]=e;return t})))}(e);const i={cbs:r?new Set([r]):new Set,subId:a()},u=(e,n)=>{i.view=e,i.cbs.forEach((t=>{t(e,n)}))};if(window.globalState){const t=le()(u,null!=l?l:0,{trailing:!0,leading:!0,...null==o?{}:{maxWait:o}}),r={selector:e,tabId:n,handleUpdate:t,id:i.subId};window.globalState.subs.add(r),i.release=()=>{i.released||(i.released=!0,i.cbs.clear(),window.globalState.subs.delete(r))}}else{const t=chrome.runtime.connect({name:`subscribe ${JSON.stringify({selector:e,tabId:n,id:i.subId,wait:l,maxWait:o})}`});t.onMessage.addListener((e=>{u(e)})),i.release=()=>{i.released||(i.released=!0,i.cbs.clear(),t.disconnect())}}return i.push=t=>{const r={};Object.keys(e).forEach((e=>{r[e]=t[e]})),u(r,!1),oe({override:r,tabId:n,ignoreSub:i.subId})},t&&function(e,n){return window.globalState?Promise.resolve(window.globalState.get(e,n)):new Promise(((t,r)=>{window.globalState?t(window.globalState.get(e,n)):chrome.runtime.sendMessage({type:"FETCH_VIEW",selector:e,tabId:n},(e=>{chrome.runtime.lastError?r(chrome.runtime.lastError):t(e)}))}))}(e,n).then((e=>{u(e,!0)})),i}(n,null===(e=ie.tabInfo)||void 0===e?void 0:e.tabId,!0,(e=>{o(e)}),t,r),()=>{i.client.release()}}),[]);let u=(0,e.useCallback)((e=>{i.client.push(e)}),[]);return[l,u]}var se=t(3174).$;function ce(){const[n,t]=(0,e.useState)(null);return(0,e.useEffect)((()=>{const e=(e,n,r)=>{if("CAPTURE_STATUS"===e.type&&e.tabId===se.tabInfo.tabId)return t(e.value),void r(!0)};return chrome.runtime.onMessage.addListener(e),chrome.runtime.sendMessage({type:"REQUEST_CAPTURE_STATUS",tabId:se.tabInfo.tabId}),()=>{chrome.runtime.onMessage.removeListener(e)}}),[]),n}var de=t(3379),fe=t.n(de),pe=t(7795),me=t.n(pe),he=t(569),ve=t.n(he),ge=t(3565),be=t.n(ge),ye=t(9216),xe=t.n(ye),we=t(4589),ke=t.n(we),Se=t(1617),Ce={};Ce.styleTagTransform=ke(),Ce.setAttributes=be(),Ce.insert=ve().bind(null,"head"),Ce.domAPI=me(),Ce.insertStyleElement=xe(),fe()(Se.Z,Ce),Se.Z&&Se.Z.locals&&Se.Z.locals;var Ee,Pe=t(5893),_e=t(3174).$;const Me=!(null===(Ee=chrome.tabCapture)||void 0===Ee||!Ee.capture);function je(e){const[n,t]=ue({enabled:!0,isPinned:!0,superDisable:!0});return n?(0,Pe.jsxs)("div",{className:"Header",children:[(0,Pe.jsx)("div",{className:n.enabled?"active":"muted",onClick:()=>{oe({override:{enabled:!n.enabled,enabledLatestViaPopup:!0},tabId:_e.tabInfo.tabId})},onContextMenu:e=>{e.preventDefault(),oe({override:{superDisable:!0}})},children:(0,Pe.jsx)(B,{size:"17px"})}),(0,Pe.jsx)("div",{className:"pin "+(n.isPinned?"active":"muted"),onClick:()=>{oe({override:{isPinned:!n.isPinned},tabId:_e.tabInfo.tabId})},children:(0,Pe.jsx)(E,{size:"20px"})}),0===e.panel&&Me?(0,Pe.jsx)(Ne,{onClick:()=>e.setPanel(2)}):(0,Pe.jsx)("div",{className:"noPadding"}),0===e.panel?(0,Pe.jsx)(ze,{enabled:null==n?void 0:n.enabled,onClick:()=>e.setPanel(1)}):(0,Pe.jsx)("div",{className:"noPadding"}),0!==e.panel?(0,Pe.jsx)("div",{onClick:n=>e.setPanel(0),children:(0,Pe.jsx)(y,{size:"20px"})}):(0,Pe.jsx)("div",{className:"noPadding"}),(0,Pe.jsx)("div",{title:"open options page.",onClick:e=>{chrome.runtime.openOptionsPage()},children:(0,Pe.jsx)(S,{size:"20px"})}),(0,Pe.jsx)("div",{title:"open github page.",onClick:e=>{window.open("https://github.com/polywock/globalSpeed","_blank")},children:(0,Pe.jsx)(C,{size:"18px"})})]}):(0,Pe.jsx)("div",{})}function ze(n){const[t,r]=ue({elementFx:!0,backdropFx:!0}),a=(0,e.useMemo)((()=>{if(t&&n.enabled){if(t.backdropFx.enabled&&(s(t.backdropFx.filters)||s(t.backdropFx.transforms)))return!0;if(t.elementFx.enabled&&(s(t.elementFx.filters)||s(t.elementFx.transforms)))return!0}return!1}),[n.enabled,t]);return(0,Pe.jsx)("div",{className:"beat "+(a?"active":""),onClick:e=>n.onClick(),onContextMenu:e=>{e.preventDefault(),oe({override:{elementFx:J(),backdropFx:J()},tabId:_e.tabInfo.tabId})},children:(0,Pe.jsx)(P,{size:"20px"})})}function Ne(e){const n=ce();return(0,Pe.jsx)("div",{className:"beat "+(n?"active":""),onClick:e.onClick,onContextMenu:e=>{e.preventDefault(),chrome.runtime.sendMessage({type:"TAB_CAPTURE",on:!1,tabId:_e.tabInfo.tabId})},children:(0,Pe.jsx)(V,{size:"17px"})})}function Te(e){return new Promise(((n,t)=>{chrome.tabs.query(e,(e=>{chrome.runtime.lastError?t(chrome.runtime.lastError.message):n(e||[])}))}))}var Fe=t(3416),Ie={};Ie.styleTagTransform=ke(),Ie.setAttributes=be(),Ie.insert=ve().bind(null,"head"),Ie.domAPI=me(),Ie.insertStyleElement=xe(),fe()(Fe.Z,Ie),Fe.Z&&Fe.Z.locals&&Fe.Z.locals;const Oe=e=>(0,Pe.jsx)("div",{className:"FloatTooltip",children:(0,Pe.jsx)("div",{children:e.value})}),Le=/^-?(?=[\d\.])\d*(\.\d+)?$/,Ae=n=>{var t;const[a,l]=(0,e.useState)(""),[o,i]=(0,e.useState)(null);return(0,e.useEffect)((()=>{var e;(i(null),null==n.value)?""!==a&&l(""):parseFloat(a)!==n.value&&l(r(n.value,null!==(e=n.rounding)&&void 0!==e?e:4).toString())}),[n.value]),(0,Pe.jsxs)("div",{className:`NumericInput ${n.className||""}`,style:{position:"relative"},children:[(0,Pe.jsx)("input",{disabled:null!==(t=n.disabled)&&void 0!==t&&t,onBlur:e=>{var t;i(null),l(null==n.value?"":r(n.value,null!==(t=n.rounding)&&void 0!==t?t:4).toString())},className:o?"error":"",placeholder:n.placeholder,type:"text",onChange:e=>{var t;l(e.target.value);const a=e.target.value.trim();if(!a)return void(n.noNull?i("empty"):(i(null),n.onChange(null)));const o=r(parseFloat(a),null!==(t=n.rounding)&&void 0!==t?t:4);if(Le.test(a)&&!isNaN(o)){var u;if(null!=n.min&&o<n.min)return void i(`>= ${n.min}`);if(null!=n.max&&o>n.max)return void i(`<=  ${n.max}`);o!==r(n.value,null!==(u=n.rounding)&&void 0!==u?u:4)&&n.onChange(o),i(null)}else i("NaN")},value:a}),o&&(0,Pe.jsx)(Oe,{value:o})]})};var De=t(8024),Re={};function Be(e){const n=n=>{var t;let r=null!==(t=e.value)&&void 0!==t?t:e.default;null!=r&&e.onChange(r+n)};return(0,Pe.jsxs)("div",{className:"NumericControl",children:[(0,Pe.jsx)("button",{onClick:()=>{var t;return n(-(null!==(t=e.largeStep)&&void 0!==t?t:0))},children:(0,Pe.jsx)(_,{size:16})}),(0,Pe.jsx)("button",{onClick:()=>{var t;return n(-(null!==(t=e.smallStep)&&void 0!==t?t:0))},children:(0,Pe.jsx)(j,{size:16})}),(0,Pe.jsx)(Ae,{rounding:e.rounding,placeholder:e.inputPlaceholder,noNull:e.inputNoNull,min:e.min,max:e.max,value:e.value,onChange:n=>{e.onChange(n)}}),(0,Pe.jsx)("button",{onClick:()=>{var t;return n(null!==(t=e.smallStep)&&void 0!==t?t:0)},children:(0,Pe.jsx)(z,{size:16})}),(0,Pe.jsx)("button",{onMouseDown:()=>{},onClick:()=>{var t;return n(null!==(t=e.largeStep)&&void 0!==t?t:0)},children:(0,Pe.jsx)(M,{size:16})})]})}function $e(e){return v({tag:"svg",attr:{fill:"currentColor",viewBox:"0 0 16 16"},child:[{tag:"path",attr:{d:"M12 13c0 1.105-1.12 2-2.5 2S7 14.105 7 13s1.12-2 2.5-2 2.5.895 2.5 2z"}},{tag:"path",attr:{fillRule:"evenodd",d:"M12 3v10h-1V3h1z"}},{tag:"path",attr:{d:"M11 2.82a1 1 0 0 1 .804-.98l3-.6A1 1 0 0 1 16 2.22V4l-5 1V2.82z"}},{tag:"path",attr:{fillRule:"evenodd",d:"M0 11.5a.5.5 0 0 1 .5-.5H4a.5.5 0 0 1 0 1H.5a.5.5 0 0 1-.5-.5zm0-4A.5.5 0 0 1 .5 7H8a.5.5 0 0 1 0 1H.5a.5.5 0 0 1-.5-.5zm0-4A.5.5 0 0 1 .5 3H8a.5.5 0 0 1 0 1H.5a.5.5 0 0 1-.5-.5z"}}]})(e)}Re.styleTagTransform=ke(),Re.setAttributes=be(),Re.insert=ve().bind(null,"head"),Re.domAPI=me(),Re.insertStyleElement=xe(),fe()(De.Z,Re),De.Z&&De.Z.locals&&De.Z.locals;var Ue=t(3552),Ve={};function He(e){var t,r,a;const[l]=ue({speedPresets:!0,speedSmallStep:!0,speedBigStep:!0,speedSlider:!0,freePitch:!0,speedPresetRows:!0,speedPresetPadding:!0});if(!l)return null;let o=12===(null===(t=l.speedPresets)||void 0===t?void 0:t.length)?l.speedPresets:[.25,.5,.75,.9,1,1.1,1.25,1.5,1.75,2,2.5,16];return o=o.slice(0,3*n(1,4,null!==(r=l.speedPresetRows)&&void 0!==r?r:4)),(0,Pe.jsxs)("div",{className:"SpeedControl",children:[(0,Pe.jsx)("div",{className:"options",style:{"--padding":`${null!==(a=l.speedPresetPadding)&&void 0!==a?a:0}px`},children:o.map((n=>(0,Pe.jsx)("button",{className:e.speed===n?"selected":"",onClick:()=>e.onChange(n),children:n.toFixed(2)},n)))}),(0,Pe.jsx)(Be,{value:e.speed,onChange:n=>e.onChange(n),smallStep:l.speedSmallStep||.01,largeStep:l.speedBigStep||.1,min:.07,max:16,inputNoNull:!0,rounding:2}),!!l.speedSlider&&(0,Pe.jsxs)("div",{className:"slider",children:[(0,Pe.jsx)($e,{title:window.gsm.command.speedChangesPitch,size:"17px",className:l.freePitch?"active":"",onClick:e=>{l.freePitch||function(e,n,t){const r=document.createElement("div");r.textContent=e,r.setAttribute("style",`\n    position: fixed;\n    left: ${n.x}px;\n    top: ${n.y}px;\n    background-color: blue; \n    color: yellow;\n    padding: 10px;\n    z-index: 99999999999;\n  `),document.body.appendChild(r),setTimeout((()=>{r.remove()}),1e3)}(window.gsm.command.speedChangesPitch,function(e){let n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:10;return{x:e.x+e.width+n,y:e.y-e.height-n}}(e.target.getBoundingClientRect())),oe({override:{freePitch:!l.freePitch}})}}),(0,Pe.jsx)("input",{step:.01,type:"range",min:l.speedSlider.min,max:l.speedSlider.max,value:e.speed,onChange:n=>{e.onChange(n.target.valueAsNumber)}})]})]})}function Ze(e){return v({tag:"svg",attr:{viewBox:"0 0 24 24"},child:[{tag:"path",attr:{fill:"none",d:"M0 0h24v24H0V0z"}},{tag:"path",attr:{d:"M19 11h-8v6h8v-6zm4 8V4.98C23 3.88 22.1 3 21 3H3c-1.1 0-2 .88-2 1.98V19c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2zm-2 .02H3V4.97h18v14.05z"}}]})(e)}function We(e){return v({tag:"svg",attr:{viewBox:"0 0 24 24"},child:[{tag:"path",attr:{fill:"none",d:"M0 0h24v24H0z"}},{tag:"path",attr:{d:"M1 21h22L12 2 1 21zm12-3h-2v-2h2v2zm0-4h-2v-4h2v4z"}}]})(e)}function qe(e){return v({tag:"svg",attr:{viewBox:"0 0 24 24"},child:[{tag:"path",attr:{fill:"none",d:"M0 0h24v24H0z"}},{tag:"path",attr:{d:"M11.99 2C6.47 2 2 6.48 2 12s4.47 10 9.99 10C17.52 22 22 17.52 22 12S17.52 2 11.99 2zM12 20c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8z"}},{tag:"path",attr:{d:"M12.5 7H11v6l5.25 3.15.75-1.23-4.5-2.67z"}}]})(e)}Ve.styleTagTransform=ke(),Ve.setAttributes=be(),Ve.insert=ve().bind(null,"head"),Ve.domAPI=me(),Ve.insertStyleElement=xe(),fe()(Ue.Z,Ve),Ue.Z&&Ue.Z.locals&&Ue.Z.locals;var Qe=t(558),Ke={};Ke.styleTagTransform=ke(),Ke.setAttributes=be(),Ke.insert=ve().bind(null,"head"),Ke.domAPI=me(),Ke.insertStyleElement=xe(),fe()(Qe.Z,Ke),Qe.Z&&Qe.Z.locals&&Qe.Z.locals;const Xe=!!HTMLVideoElement.prototype.requestPictureInPicture;function Ye(e){const{info:n,pinned:t}=e,{tabId:r,frameId:a}=n.tabInfo;let o=[l(n.domain)];return!n.infinity&&n.duration&&o.push(function(e){const n=e/60,t=n/60;return t>=100?"":t>1?`${Math.floor(t)}:${Math.floor(n%60).toString().padStart(2,"0")}:${Math.floor(e%60).toString().padStart(2,"0")}`:`${Math.floor(n).toString().padStart(1,"0")}:${Math.floor(e%60).toString().padStart(2,"0")}`}(n.duration)),(0,Pe.jsxs)("div",{className:"MediaView",children:[(0,Pe.jsx)("div",{className:"header",title:n.metaTitle||n.title,children:o.join(null==n.shadowMode?" • ":"open"===n.shadowMode?" / ":"  ")}),(0,Pe.jsxs)("div",{className:"controls",children:[(0,Pe.jsx)("button",{onClick:e=>{c({type:"SEEK",value:-5,relative:!0},n.key,r,a)},children:(0,Pe.jsx)(T,{size:15})}),(0,Pe.jsx)("button",{onClick:e=>{c({type:"PAUSE",state:"toggle"},n.key,r,a)},children:n.paused?(0,Pe.jsx)(R,{size:16}):(0,Pe.jsx)(D,{size:16})}),(0,Pe.jsx)("button",{onClick:e=>{c({type:"SEEK",value:5,relative:!0},n.key,r,a)},children:(0,Pe.jsx)(I,{size:15})}),n.hasAudioTrack?(0,Pe.jsxs)(Pe.Fragment,{children:[(0,Pe.jsx)("button",{onClick:e=>{c({type:"MUTE",state:"toggle"},n.key,r,a)},children:n.muted?(0,Pe.jsx)(U,{size:16}):n.volume>.5?(0,Pe.jsx)(V,{size:16}):(0,Pe.jsx)($,{size:16})}),(0,Pe.jsx)("input",{className:"slider",onChange:e=>{c({type:"SET_VOLUME",value:e.target.valueAsNumber,relative:!1},n.key,r,a)},type:"range",min:0,max:1,step:.1,value:n.volume})]}):(0,Pe.jsxs)(Pe.Fragment,{children:[(0,Pe.jsx)("div",{}),(0,Pe.jsx)("div",{})]}),Xe&&n.hasVideoTrack&&n.duration?(0,Pe.jsx)("button",{className:n.pipMode?"active":"",onClick:e=>{c(e.shiftKey?{type:"FULLSCREEN",direct:!0}:{type:"PIP"},n.key,r,a)},children:(0,Pe.jsx)(Ze,{size:18})}):(0,Pe.jsx)("div",{}),(0,Pe.jsx)("button",{title:window.gsm.warnings.selectTooltip,className:t?"active":"",onClick:e=>{chrome.runtime.sendMessage({type:"MEDIA_SET_PIN",value:t?null:{key:n.key,tabInfo:n.tabInfo}})},children:(0,Pe.jsx)(L,{size:18})})]},n.key)]})}var Ge=t(3174).$;function Je(e){for(var n=arguments.length,t=Array(n>1?n-1:0),r=1;r<n;r++)t[r-1]=arguments[r];throw Error("[Immer] minified error nr: "+e+(t.length?" "+t.map((function(e){return"'"+e+"'"})).join(","):"")+". Find the full error at: https://bit.ly/3cXEKWf")}function en(e){return!!e&&!!e[Bn]}function nn(e){var n;return!!e&&(function(e){if(!e||"object"!=typeof e)return!1;var n=Object.getPrototypeOf(e);if(null===n)return!0;var t=Object.hasOwnProperty.call(n,"constructor")&&n.constructor;return t===Object||"function"==typeof t&&Function.toString.call(t)===$n}(e)||Array.isArray(e)||!!e[Rn]||!!(null===(n=e.constructor)||void 0===n?void 0:n[Rn])||on(e)||un(e))}function tn(e,n,t){void 0===t&&(t=!1),0===rn(e)?(t?Object.keys:Un)(e).forEach((function(r){t&&"symbol"==typeof r||n(r,e[r],e)})):e.forEach((function(t,r){return n(r,t,e)}))}function rn(e){var n=e[Bn];return n?n.i>3?n.i-4:n.i:Array.isArray(e)?1:on(e)?2:un(e)?3:0}function an(e,n){return 2===rn(e)?e.has(n):Object.prototype.hasOwnProperty.call(e,n)}function ln(e,n,t){var r=rn(e);2===r?e.set(n,t):3===r?(e.delete(n),e.add(t)):e[n]=t}function on(e){return On&&e instanceof Map}function un(e){return Ln&&e instanceof Set}function sn(e){return e.o||e.t}function cn(e){if(Array.isArray(e))return Array.prototype.slice.call(e);var n=Vn(e);delete n[Bn];for(var t=Un(n),r=0;r<t.length;r++){var a=t[r],l=n[a];!1===l.writable&&(l.writable=!0,l.configurable=!0),(l.get||l.set)&&(n[a]={configurable:!0,writable:!0,enumerable:l.enumerable,value:e[a]})}return Object.create(Object.getPrototypeOf(e),n)}function dn(e,n){return void 0===n&&(n=!1),pn(e)||en(e)||!nn(e)||(rn(e)>1&&(e.set=e.add=e.clear=e.delete=fn),Object.freeze(e),n&&tn(e,(function(e,n){return dn(n,!0)}),!0)),e}function fn(){Je(2)}function pn(e){return null==e||"object"!=typeof e||Object.isFrozen(e)}function mn(e){var n=Hn[e];return n||Je(18,e),n}function hn(){return Fn}function vn(e,n){n&&(mn("Patches"),e.u=[],e.s=[],e.v=n)}function gn(e){bn(e),e.p.forEach(xn),e.p=null}function bn(e){e===Fn&&(Fn=e.l)}function yn(e){return Fn={p:[],l:Fn,h:e,m:!0,_:0}}function xn(e){var n=e[Bn];0===n.i||1===n.i?n.j():n.O=!0}function wn(e,n){n._=n.p.length;var t=n.p[0],r=void 0!==e&&e!==t;return n.h.g||mn("ES5").S(n,e,r),r?(t[Bn].P&&(gn(n),Je(4)),nn(e)&&(e=kn(n,e),n.l||Cn(n,e)),n.u&&mn("Patches").M(t[Bn].t,e,n.u,n.s)):e=kn(n,t,[]),gn(n),n.u&&n.v(n.u,n.s),e!==Dn?e:void 0}function kn(e,n,t){if(pn(n))return n;var r=n[Bn];if(!r)return tn(n,(function(a,l){return Sn(e,r,n,a,l,t)}),!0),n;if(r.A!==e)return n;if(!r.P)return Cn(e,r.t,!0),r.t;if(!r.I){r.I=!0,r.A._--;var a=4===r.i||5===r.i?r.o=cn(r.k):r.o;tn(3===r.i?new Set(a):a,(function(n,l){return Sn(e,r,a,n,l,t)})),Cn(e,a,!1),t&&e.u&&mn("Patches").R(r,t,e.u,e.s)}return r.o}function Sn(e,n,t,r,a,l){if(en(a)){var o=kn(e,a,l&&n&&3!==n.i&&!an(n.D,r)?l.concat(r):void 0);if(ln(t,r,o),!en(o))return;e.m=!1}if(nn(a)&&!pn(a)){if(!e.h.F&&e._<1)return;kn(e,a),n&&n.A.l||Cn(e,a)}}function Cn(e,n,t){void 0===t&&(t=!1),e.h.F&&e.m&&dn(n,t)}function En(e,n){var t=e[Bn];return(t?sn(t):e)[n]}function Pn(e,n){if(n in e)for(var t=Object.getPrototypeOf(e);t;){var r=Object.getOwnPropertyDescriptor(t,n);if(r)return r;t=Object.getPrototypeOf(t)}}function _n(e){e.P||(e.P=!0,e.l&&_n(e.l))}function Mn(e){e.o||(e.o=cn(e.t))}function jn(e,n,t){var r=on(n)?mn("MapSet").N(n,t):un(n)?mn("MapSet").T(n,t):e.g?function(e,n){var t=Array.isArray(e),r={i:t?1:0,A:n?n.A:hn(),P:!1,I:!1,D:{},l:n,t:e,k:null,o:null,j:null,C:!1},a=r,l=Zn;t&&(a=[r],l=Wn);var o=Proxy.revocable(a,l),i=o.revoke,u=o.proxy;return r.k=u,r.j=i,u}(n,t):mn("ES5").J(n,t);return(t?t.A:hn()).p.push(r),r}function zn(e){return en(e)||Je(22,e),function e(n){if(!nn(n))return n;var t,r=n[Bn],a=rn(n);if(r){if(!r.P&&(r.i<4||!mn("ES5").K(r)))return r.t;r.I=!0,t=Nn(n,a),r.I=!1}else t=Nn(n,a);return tn(t,(function(n,a){r&&function(e,n){return 2===rn(e)?e.get(n):e[n]}(r.t,n)===a||ln(t,n,e(a))})),3===a?new Set(t):t}(e)}function Nn(e,n){switch(n){case 2:return new Map(e);case 3:return Array.from(e)}return cn(e)}var Tn,Fn,In="undefined"!=typeof Symbol&&"symbol"==typeof Symbol("x"),On="undefined"!=typeof Map,Ln="undefined"!=typeof Set,An="undefined"!=typeof Proxy&&void 0!==Proxy.revocable&&"undefined"!=typeof Reflect,Dn=In?Symbol.for("immer-nothing"):((Tn={})["immer-nothing"]=!0,Tn),Rn=In?Symbol.for("immer-draftable"):"__$immer_draftable",Bn=In?Symbol.for("immer-state"):"__$immer_state",$n=("undefined"!=typeof Symbol&&Symbol.iterator,""+Object.prototype.constructor),Un="undefined"!=typeof Reflect&&Reflect.ownKeys?Reflect.ownKeys:void 0!==Object.getOwnPropertySymbols?function(e){return Object.getOwnPropertyNames(e).concat(Object.getOwnPropertySymbols(e))}:Object.getOwnPropertyNames,Vn=Object.getOwnPropertyDescriptors||function(e){var n={};return Un(e).forEach((function(t){n[t]=Object.getOwnPropertyDescriptor(e,t)})),n},Hn={},Zn={get:function(e,n){if(n===Bn)return e;var t=sn(e);if(!an(t,n))return function(e,n,t){var r,a=Pn(n,t);return a?"value"in a?a.value:null===(r=a.get)||void 0===r?void 0:r.call(e.k):void 0}(e,t,n);var r=t[n];return e.I||!nn(r)?r:r===En(e.t,n)?(Mn(e),e.o[n]=jn(e.A.h,r,e)):r},has:function(e,n){return n in sn(e)},ownKeys:function(e){return Reflect.ownKeys(sn(e))},set:function(e,n,t){var r=Pn(sn(e),n);if(null==r?void 0:r.set)return r.set.call(e.k,t),!0;if(!e.P){var a=En(sn(e),n),l=null==a?void 0:a[Bn];if(l&&l.t===t)return e.o[n]=t,e.D[n]=!1,!0;if(function(e,n){return e===n?0!==e||1/e==1/n:e!=e&&n!=n}(t,a)&&(void 0!==t||an(e.t,n)))return!0;Mn(e),_n(e)}return e.o[n]===t&&"number"!=typeof t&&(void 0!==t||n in e.o)||(e.o[n]=t,e.D[n]=!0,!0)},deleteProperty:function(e,n){return void 0!==En(e.t,n)||n in e.t?(e.D[n]=!1,Mn(e),_n(e)):delete e.D[n],e.o&&delete e.o[n],!0},getOwnPropertyDescriptor:function(e,n){var t=sn(e),r=Reflect.getOwnPropertyDescriptor(t,n);return r?{writable:!0,configurable:1!==e.i||"length"!==n,enumerable:r.enumerable,value:t[n]}:r},defineProperty:function(){Je(11)},getPrototypeOf:function(e){return Object.getPrototypeOf(e.t)},setPrototypeOf:function(){Je(12)}},Wn={};tn(Zn,(function(e,n){Wn[e]=function(){return arguments[0]=arguments[0][0],n.apply(this,arguments)}})),Wn.deleteProperty=function(e,n){return Wn.set.call(this,e,n,void 0)},Wn.set=function(e,n,t){return Zn.set.call(this,e[0],n,t,e[0])};var qn=function(){function e(e){var n=this;this.g=An,this.F=!0,this.produce=function(e,t,r){if("function"==typeof e&&"function"!=typeof t){var a=t;t=e;var l=n;return function(e){var n=this;void 0===e&&(e=a);for(var r=arguments.length,o=Array(r>1?r-1:0),i=1;i<r;i++)o[i-1]=arguments[i];return l.produce(e,(function(e){var r;return(r=t).call.apply(r,[n,e].concat(o))}))}}var o;if("function"!=typeof t&&Je(6),void 0!==r&&"function"!=typeof r&&Je(7),nn(e)){var i=yn(n),u=jn(n,e,void 0),s=!0;try{o=t(u),s=!1}finally{s?gn(i):bn(i)}return"undefined"!=typeof Promise&&o instanceof Promise?o.then((function(e){return vn(i,r),wn(e,i)}),(function(e){throw gn(i),e})):(vn(i,r),wn(o,i))}if(!e||"object"!=typeof e){if(void 0===(o=t(e))&&(o=e),o===Dn&&(o=void 0),n.F&&dn(o,!0),r){var c=[],d=[];mn("Patches").M(e,o,c,d),r(c,d)}return o}Je(21,e)},this.produceWithPatches=function(e,t){if("function"==typeof e)return function(t){for(var r=arguments.length,a=Array(r>1?r-1:0),l=1;l<r;l++)a[l-1]=arguments[l];return n.produceWithPatches(t,(function(n){return e.apply(void 0,[n].concat(a))}))};var r,a,l=n.produce(e,t,(function(e,n){r=e,a=n}));return"undefined"!=typeof Promise&&l instanceof Promise?l.then((function(e){return[e,r,a]})):[l,r,a]},"boolean"==typeof(null==e?void 0:e.useProxies)&&this.setUseProxies(e.useProxies),"boolean"==typeof(null==e?void 0:e.autoFreeze)&&this.setAutoFreeze(e.autoFreeze)}var n=e.prototype;return n.createDraft=function(e){nn(e)||Je(8),en(e)&&(e=zn(e));var n=yn(this),t=jn(this,e,void 0);return t[Bn].C=!0,bn(n),t},n.finishDraft=function(e,n){var t=(e&&e[Bn]).A;return vn(t,n),wn(void 0,t)},n.setAutoFreeze=function(e){this.F=e},n.setUseProxies=function(e){e&&!An&&Je(20),this.g=e},n.applyPatches=function(e,n){var t;for(t=n.length-1;t>=0;t--){var r=n[t];if(0===r.path.length&&"replace"===r.op){e=r.value;break}}t>-1&&(n=n.slice(t+1));var a=mn("Patches").$;return en(e)?a(e,n):this.produce(e,(function(e){return a(e,n)}))},e}(),Qn=new qn,Kn=Qn.produce,Xn=(Qn.produceWithPatches.bind(Qn),Qn.setAutoFreeze.bind(Qn),Qn.setUseProxies.bind(Qn),Qn.applyPatches.bind(Qn),Qn.createDraft.bind(Qn),Qn.finishDraft.bind(Qn),Kn),Yn=t(6127),Gn={};function Jn(e){const[t,a]=ue({speed:!0,hideMediaView:!0,enabled:!0});return t?(0,Pe.jsxs)("div",{className:"MainPanal panel",children:[(0,Pe.jsx)(He,{speed:t.speed,onChange:e=>{a(Xn(t,(t=>{t.speed=function(e){return n(.07,16,r(e,arguments.length>1&&void 0!==arguments[1]?arguments[1]:2))}(e),t.enabled=!0})))}}),t.hideMediaView?null:(0,Pe.jsx)(et,{})]}):(0,Pe.jsx)("div",{className:"panel unloaded"})}function et(n){const t=function(){const[n,t]=(0,e.useState)(null),r=(0,e.useMemo)((()=>({shownBefore:[]})),[]);return(0,e.useEffect)((()=>{const e=chrome.runtime.connect({name:"MEDIA_WATCH"});return e.onMessage.addListener((e=>{let n=function(e){const n=[];return null==e||e.forEach((e=>{var t;null===(t=e.media)||void 0===t||t.forEach((t=>{n.push({...t,...e})}))})),n}(e.scopes).filter((n=>{const t=Ge.tabInfo.tabId===n.tabInfo.tabId;if(n.readyState&&(n.key===e.pinned||r.shownBefore.includes(n.key)||t||!n.paused))return r.shownBefore.push(n.key),!0}));t({infos:n,pinned:e.pinned})})),()=>{e.disconnect()}}),[]),n}();return(0,Pe.jsx)(Pe.Fragment,{children:((null==t?void 0:t.infos)||[]).filter((e=>e.isConnected||e.duration>.5||e.key===t.pinned)).map((e=>(0,Pe.jsx)(Ye,{info:e,pinned:e.key===t.pinned},e.key)))})}Gn.styleTagTransform=ke(),Gn.setAttributes=be(),Gn.insert=ve().bind(null,"head"),Gn.domAPI=me(),Gn.insertStyleElement=xe(),fe()(Yn.Z,Gn),Yn.Z&&Yn.Z.locals&&Yn.Z.locals;var nt=t(697),tt={};function rt(n){const t=(0,e.useRef)();return(0,e.useEffect)((()=>{if(n.keepOnClose)return;const e=e=>{n.onClose()};return document.addEventListener("scroll",e,{passive:!0,capture:!0}),()=>{document.removeEventListener("scroll",e,!0)}}),[n.keepOnClose]),(0,Pe.jsx)("div",{...n.color?{style:{backgroundColor:n.color}}:{},ref:t,onMouseDown:e=>{e.target===t.current&&n.onClose()},className:"ModalBase",children:n.children})}tt.styleTagTransform=ke(),tt.setAttributes=be(),tt.insert=ve().bind(null,"head"),tt.domAPI=me(),tt.insertStyleElement=xe(),fe()(nt.Z,tt),nt.Z&&nt.Z.locals&&nt.Z.locals;var at=t(1485),lt={};lt.styleTagTransform=ke(),lt.setAttributes=be(),lt.insert=ve().bind(null,"head"),lt.domAPI=me(),lt.insertStyleElement=xe(),fe()(at.Z,lt),at.Z&&at.Z.locals&&at.Z.locals;const ot=n=>{var t,r;const[a,l]=(0,e.useState)(null),o=(e,t)=>{if(n.alert)return alert(n.tooltip);let r=Math.min(300,window.innerWidth-20);const a=window.innerWidth-r-10,o=window.innerHeight-100;l({x:Math.max(10,Math.min(a,e+20)),y:Math.max(10,Math.min(o,t+15)),w:r})};return(0,Pe.jsxs)("div",{...n.pass||{},className:"Tooltip",children:[(0,Pe.jsx)("span",{tabIndex:0,onKeyDown:e=>{if("Enter"===e.key){const{x:n,y:t}=e.target.getBoundingClientRect();o(n,t)}},onClick:e=>{o(e.clientX,e.clientY)},children:null!==(t=n.label)&&void 0!==t?t:"?"}),a&&(0,Pe.jsx)(rt,{color:"#00000000",onClose:()=>l(null),children:(0,Pe.jsx)("div",{className:"fg",tabIndex:0,onBlur:e=>l(null),style:{maxWidth:`${null!==(r=a.w)&&void 0!==r?r:300}px`,left:`${a.x}px`,top:`${a.y}px`},children:n.tooltip})})]})};function it(n){var t;const[r,a]=(0,e.useState)(n.value),l=(0,e.useMemo)((()=>({})),[]);var o;return l.props=n,(0,e.useEffect)((()=>{a(n.value)}),[n.value]),l.sendUpdateDebounced=(0,e.useCallback)(le()((e=>{l.props.onChange(e)}),500,{maxWait:3e3,leading:!0,trailing:!0}),[]),l.handleBlur=()=>{l.sendUpdateDebounced.flush()},(0,e.useEffect)((()=>(window.addEventListener("beforeunload",(e=>{l.handleBlur()})),()=>{l.handleBlur()})),[]),n.textArea?(0,Pe.jsx)("textarea",{...null!==(o=n.passTextArea)&&void 0!==o?o:{},value:r,onChange:e=>{a(e.target.value),l.sendUpdateDebounced(e.target.value)},onBlur:l.handleBlur}):(0,Pe.jsx)("input",{...null!==(t=n.passInput)&&void 0!==t?t:{},value:r,onChange:e=>{a(e.target.value),l.sendUpdateDebounced(e.target.value)},type:"text",onBlur:l.handleBlur})}function ut(t){var r,a,l;const[o,u]=(0,e.useState)(null),s=(0,e.useMemo)((()=>({props:t})),[]);s.props=t,s.handleChange=(0,e.useCallback)(le()((e=>{const{props:t}=s;t.onChange(n(t.min,t.max,e))}),null!==(r=t.wait)&&void 0!==r?r:25,{maxWait:null!==(a=t.maxWait)&&void 0!==a?a:50,leading:!0,trailing:!0}),[]),(0,e.useEffect)((()=>()=>{var e;null===(e=s.handleChange)||void 0===e||e.flush()}),[]);let c=t.min,d=t.max,f=null!==(l=t.step)&&void 0!==l?l:.01;if(o){const e=(p=t.min,m=t.max,(o[0]-p)/(m-p));c=n(t.min,t.max,i(t.min,t.max,e-.05)),d=n(t.min,t.max,i(t.min,t.max,e+.05)),f*=.1}var p,m;const h=()=>{u([t.value])};return(0,Pe.jsx)("input",{title:window.gsm.warnings.sliderTooltip,style:o?{outline:"2px solid red",transformOrigin:"center",transform:"scaleY(1.5)"}:{},onMouseDown:e=>{e.shiftKey&&h()},onKeyDown:e=>{e.shiftKey&&h()},onBlur:()=>{u(null)},type:"range",min:c,max:d,step:f,value:t.value,onChange:e=>{s.handleChange(e.target.valueAsNumber)}})}function st(e){return v({tag:"svg",attr:{viewBox:"0 0 512 512"},child:[{tag:"path",attr:{d:"M248.91 50c11.882-.006 23.875 1.018 35.857 3.13 85.207 15.025 152.077 81.895 167.102 167.102 15.023 85.208-24.944 170.917-99.874 214.178-32.782 18.927-69.254 27.996-105.463 27.553-46.555-.57-92.675-16.865-129.957-48.15l30.855-36.768c50.95 42.75 122.968 49.05 180.566 15.797 57.597-33.254 88.152-98.777 76.603-164.274-11.55-65.497-62.672-116.62-128.17-128.168-51.656-9.108-103.323 7.98-139.17 43.862L185 192H57V64l46.34 46.342C141.758 71.962 194.17 50.03 248.91 50z"}}]})(e)}function ct(e){return(0,Pe.jsx)(st,{size:15,className:"reset "+(e.active?"active":""),onClick:e.onClick})}var dt=t(7733),ft={};function pt(e){var t;const r=t=>{e.onChange(n(e.min,e.max,t))},a=e.default!==e.value;return(0,Pe.jsxs)("div",{className:"SliderPlus "+(a?"highlight":""),children:[(0,Pe.jsxs)("div",{className:"header",children:[(0,Pe.jsx)("span",{children:e.label}),(0,Pe.jsx)(Ae,{noNull:!0,min:e.min,max:e.max,value:e.value,onChange:r}),e.noReset?(0,Pe.jsx)("div",{}):(0,Pe.jsx)(ct,{active:a,onClick:()=>r(e.default)})]}),(0,Pe.jsx)(ut,{step:null!==(t=e.sliderStep)&&void 0!==t?t:.01,min:e.sliderMin,max:e.sliderMax,value:e.value,default:e.default,onChange:r})]})}ft.styleTagTransform=ke(),ft.setAttributes=be(),ft.insert=ve().bind(null,"head"),ft.domAPI=me(),ft.insertStyleElement=xe(),fe()(dt.Z,ft),dt.Z&&dt.Z.locals&&dt.Z.locals;var mt=t(5338),ht={};function vt(e){return(0,Pe.jsxs)("div",{className:"Move",children:[(0,Pe.jsx)("button",{className:"icon",onClick:()=>e.onMove(!1),children:(0,Pe.jsx)(x,{size:"20px"})}),(0,Pe.jsx)("button",{className:"icon",onClick:()=>e.onMove(!0),children:(0,Pe.jsx)(b,{size:"20px"})})]})}ht.styleTagTransform=ke(),ht.setAttributes=be(),ht.insert=ve().bind(null,"head"),ht.domAPI=me(),ht.insertStyleElement=xe(),fe()(mt.Z,ht),mt.Z&&mt.Z.locals&&mt.Z.locals;var gt=t(9317),bt={};function yt(t){const[r,a]=(0,e.useState)(!1);return(0,Pe.jsx)("div",{className:`Filters ${t.className||""}`,children:t.filters.map((e=>(0,Pe.jsx)(xt,{entry:e,onMove:r=>{t.onChange(Xn(t.filters,(t=>{!function(t,r,a){let l=t.findIndex((n=>n.name===e.name)),o=t[l],i=n(0,t.length-1,l+(a?1:-1));t.splice(l,1),t.splice(i,0,o)}(t,0,r)})))},onChange:n=>{t.onChange(Xn(t.filters,(t=>{const a=t.find((n=>n.name===e.name));a.value=n.value,r&&a.name.startsWith("scale")&&t.filter((e=>e.name.startsWith("scale"))).forEach((e=>{e.value=n.value}))})))},syncChange:e.name.startsWith("scale")?()=>a(!r):null,syncValue:r},e.name)))})}function xt(e){const{entry:n}=e,t=u[n.name];return(0,Pe.jsxs)("div",{className:"Filter",children:[(0,Pe.jsx)(vt,{onMove:n=>e.onMove(n)}),(0,Pe.jsx)(pt,{label:(0,Pe.jsxs)(Pe.Fragment,{children:[window.gsm.filter[n.name],e.syncChange?(0,Pe.jsx)("button",{onClick:()=>e.syncChange(),style:{padding:"0px 5px",marginLeft:"10px"},className:"toggle "+(e.syncValue?"active":""),children:":"}):null]}),value:n.value,sliderMin:t.sliderMin,sliderMax:t.sliderMax,sliderStep:t.sliderStep,min:t.min,max:t.max,default:t.default,onChange:t=>{e.onChange(Xn(n,(e=>{e.value=t})))}})]})}bt.styleTagTransform=ke(),bt.setAttributes=be(),bt.insert=ve().bind(null,"head"),bt.domAPI=me(),bt.insertStyleElement=xe(),fe()(gt.Z,bt),gt.Z&&gt.Z.locals&&gt.Z.locals;var wt=t(9017),kt={};function St(e){return(0,Pe.jsx)("div",{className:"Origin",children:Et.map((e=>Ct.map((n=>[n,e])))).flat(1).map((n=>{let[t,r]=n;return(0,Pe.jsx)("div",{className:t===e.x&&r===e.y?"active":"",tabIndex:0,onClick:n=>e.onChange(t,r)},`${t}:${r}`)}))})}kt.styleTagTransform=ke(),kt.setAttributes=be(),kt.insert=ve().bind(null,"head"),kt.domAPI=me(),kt.insertStyleElement=xe(),fe()(wt.Z,kt),wt.Z&&wt.Z.locals&&wt.Z.locals;const Ct=["left","center","right"],Et=["top","center","bottom"];var Pt=t(1087),_t={};function Mt(n){var t;let[r,a]=(0,e.useState)(n.defaultExpanded);return(0,Pe.jsxs)("div",{className:"DropdownWarning",children:[(0,Pe.jsxs)("div",{className:"header",onClick:e=>{a(!r)},children:[(0,Pe.jsx)(We,{size:15}),(0,Pe.jsx)("span",{children:null!==(t=n.label)&&void 0!==t?t:window.gsm.token.warning}),r?(0,Pe.jsx)(k,{size:15}):(0,Pe.jsx)(w,{size:15})]}),r&&(0,Pe.jsx)("div",{className:"body",children:n.value})]})}_t.styleTagTransform=ke(),_t.setAttributes=be(),_t.insert=ve().bind(null,"head"),_t.domAPI=me(),_t.insertStyleElement=xe(),fe()(Pt.Z,_t),Pt.Z&&Pt.Z.locals&&Pt.Z.locals;var jt=t(1510),zt={};zt.styleTagTransform=ke(),zt.setAttributes=be(),zt.insert=ve().bind(null,"head"),zt.domAPI=me(),zt.insertStyleElement=xe(),fe()(jt.Z,zt),jt.Z&&jt.Z.locals&&jt.Z.locals;var Nt=t(3174).$;function Tt(n){const{elementFx:t,backdropFx:r}=n,[a,l]=(0,e.useState)(!1),[o,i]=(0,e.useState)(!1),c=a?r:t,d=(0,e.useMemo)((()=>({elemFilter:s(t.filters),elemTransform:s(t.transforms),backdropFilter:s(r.filters),backdropTransform:s(r.transforms)})),[t,r]);return(0,Pe.jsxs)("div",{className:`FxControl ${n.className||""}`,children:[(0,Pe.jsxs)("div",{className:"tabs",children:[(0,Pe.jsx)("button",{className:`${a?"":"open"} ${d.elemFilter||d.elemTransform?"active":""}`,onClick:e=>{l(!1)},children:window.gsm.token.element}),(0,Pe.jsx)("button",{className:`${a?"open":""} ${d.backdropFilter||d.backdropTransform?"active":""}`,onClick:e=>{l(!0)},children:window.gsm.token.backdrop})]}),a&&!Y&&(0,Pe.jsx)(Mt,{value:window.gsm.warnings.backdropFirefox}),(0,Pe.jsxs)("div",{className:"controls",children:[(0,Pe.jsx)("button",{className:c.enabled?"active":"muted",onClick:e=>{a?n.handleFxChange(!0,{...r,enabled:!r.enabled}):n.handleFxChange(!1,{...t,enabled:!t.enabled})},children:(0,Pe.jsx)(B,{size:15})}),(0,Pe.jsx)("button",{onClick:e=>{n.swapFx()},children:(0,Pe.jsx)(F,{size:15})}),(0,Pe.jsx)("button",{onClick:e=>{a?n.handleFxChange(!0,J()):n.handleFxChange(!1,J())},children:(0,Pe.jsx)(st,{size:15})})]}),!a&&(0,Pe.jsxs)("div",{className:"query",children:[(0,Pe.jsxs)("span",{children:[window.gsm.token.query," ",(0,Pe.jsx)(ot,{tooltip:window.gsm.fxPanel.queryTooltip})]}),(0,Pe.jsx)(it,{passInput:{placeholder:"video"},value:c.query||"",onChange:e=>{n.handleFxChange(!1,Xn(t,(n=>{n.query=e})))}})]}),(0,Pe.jsxs)("div",{className:"tabs",children:[(0,Pe.jsx)("button",{className:`${o?"":"open"} ${(a?d.backdropFilter:d.elemFilter)?"active":""}`,onClick:e=>{i(!1)},children:window.gsm.token.filters}),(0,Pe.jsx)("button",{className:`${o?"open":""} ${(a?d.backdropTransform:d.elemTransform)?"active":""}`,onClick:e=>{i(!0)},children:window.gsm.token.transforms})]}),o&&(0,Pe.jsx)(St,{x:c.originX||"center",y:c.originY||(a?"top":"center"),onChange:(e,l)=>{n.handleFxChange(a,Xn(a?r:t,(n=>{n.originX=e,n.originY=l})))}}),n.live&&!o&&(0,Pe.jsx)("button",{className:"intoPane",disabled:!c.enabled||!(a?d.backdropFilter:d.elemFilter),onClick:e=>{const t=function(e){let n=[];return null==e||e.forEach((e=>{const t=u[e.name];null!=e.value&&e.value!==t.default&&n.push(t.format(e.value))})),n.join(" ")}(c.filters);var r,l;t&&(n.handleFxChange(a,Xn(c,(e=>{e.filters=J().filters}))),r={type:"ADD_PANE",filter:t},l=Nt.tabInfo.tabId,0,chrome.tabs.sendMessage(l,r,{frameId:0}),setTimeout((()=>{window.close()}),50))},children:window.gsm.fxPanel.intoPane}),(0,Pe.jsx)(yt,{filters:o?c.transforms:c.filters,onChange:e=>{n.handleFxChange(a,Xn(a?r:t,(n=>{n[o?"transforms":"filters"]=e,s(o?n.transforms:n.filters)&&(n.enabled=!0)})))}})]})}function Ft(e){const[n]=ue({enabled:!0}),[t,r]=ue({backdropFx:!0,elementFx:!0});return t&&n?(0,Pe.jsx)(Tt,{live:!0,className:"panel",elementFx:t.elementFx,backdropFx:t.backdropFx,enabled:n.enabled,handleFxChange:(e,n)=>{r(Xn(t,(t=>{t[e?"backdropFx":"elementFx"]=n})))},swapFx:()=>{r(Xn(t,(e=>{[e.backdropFx,e.elementFx]=[e.elementFx,e.backdropFx]})))}}):(0,Pe.jsx)("div",{className:"panel unloaded"})}var It=t(9695),Ot={};function Lt(e){var t,a;const l=t=>{e.onChange(n(e.min,e.max,t))},o=e.default!==e.value;return(0,Pe.jsxs)("div",{...null!==(t=e.pass)&&void 0!==t?t:{},className:`SliderMicro ${e.label?"withLabel":""} ${e.withInput?"withInput":""} ${o?"highlight":""}`,children:[null!=e.label&&(0,Pe.jsx)("span",{title:r(e.value,2).toString(),children:e.label}),(0,Pe.jsx)(ut,{step:null!==(a=e.sliderStep)&&void 0!==a?a:.01,min:e.sliderMin,max:e.sliderMax,value:e.value,default:e.default,onChange:l}),e.withInput&&(0,Pe.jsx)(Ae,{value:e.value,min:e.min,max:e.max,noNull:!0,onChange:e=>{l(e)}}),(0,Pe.jsx)(ct,{active:o,onClick:()=>l(e.default)})]})}Ot.styleTagTransform=ke(),Ot.setAttributes=be(),Ot.insert=ve().bind(null,"head"),Ot.domAPI=me(),Ot.insertStyleElement=xe(),fe()(It.Z,Ot),It.Z&&It.Z.locals&&It.Z.locals;var At=t(3053),Dt={};function Rt(e){var n;const t=e.value,r=ne[t.values.length.toString()];return(0,Pe.jsxs)("div",{className:"EqualizerControl audioTab",children:[(0,Pe.jsxs)("div",{className:"controls",children:[(0,Pe.jsx)("button",{className:t.enabled?"active":"muted",onClick:n=>{e.onChange(Xn(t,(e=>{e.enabled=!e.enabled})))},children:(0,Pe.jsx)(B,{size:15})}),(0,Pe.jsx)("button",{onClick:n=>{e.onChange(Xn(t,(e=>ee())))},children:(0,Pe.jsx)(st,{size:15})})]}),(0,Pe.jsxs)("div",{className:"preset",children:[(0,Pe.jsxs)("select",{value:t.values.length.toString(),onChange:n=>{const r=parseInt(n.target.value);r!==t.values.length&&e.onChange(Xn(t,(e=>{e.values=Array(r).fill(0),delete e.name})))},children:[(0,Pe.jsx)("option",{value:"10",children:"10"}),(0,Pe.jsx)("option",{value:"20",children:"20"}),(0,Pe.jsx)("option",{value:"30",children:"30"})]}),(0,Pe.jsxs)("select",{value:t.name||"",onChange:n=>{if(""===n.target.value)return void e.onChange(Xn(t,(e=>{delete e.name})));const a=null==r?void 0:r.find((e=>e.name===n.target.value));a&&e.onChange(Xn(t,(e=>{e.enabled=!0,e.name=a.name,e.values=a.values})))},children:[(0,Pe.jsx)("option",{value:"",children:"---"}),(null!=r?r:[]).map((e=>(0,Pe.jsx)("option",{value:e.name,children:e.name},e.name)))]})]}),(0,Pe.jsxs)("div",{className:"values",children:[(0,Pe.jsx)(Lt,{label:"POW",value:null!==(n=t.factor)&&void 0!==n?n:1,sliderMin:0,sliderMax:3,default:1,pass:{style:{marginBottom:"10px"}},onChange:n=>{e.onChange(Xn(t,(e=>{e.factor=n,delete e.name})))}},"intensity"),t.values.map(((n,r)=>{const a=31.25*2**(r/Math.round(t.values.length/10));return(0,Pe.jsx)(Lt,{label:`${0===r?"<":r===t.values.length-1?">":""}${o(a)}`,value:n,sliderMin:-20,sliderMax:20,sliderStep:.1,min:-40,max:40,default:0,onChange:n=>{e.onChange(Xn(t,(e=>{0!==n&&(e.enabled=!0),e.values[r]=n,delete e.name})))}},a.toString())}))]})]})}Dt.styleTagTransform=ke(),Dt.setAttributes=be(),Dt.insert=ve().bind(null,"head"),Dt.domAPI=me(),Dt.insertStyleElement=xe(),fe()(At.Z,Dt),At.Z&&At.Z.locals&&At.Z.locals;var Bt=t(9363),$t={};$t.styleTagTransform=ke(),$t.setAttributes=be(),$t.insert=ve().bind(null,"head"),$t.domAPI=me(),$t.insertStyleElement=xe(),fe()(Bt.Z,$t),Bt.Z&&Bt.Z.locals&&Bt.Z.locals;var Ut=t(3174).$;function Vt(n){const t=(0,e.useRef)({info:null}).current,[r,a]=(0,e.useState)(null);return(0,Pe.jsx)("button",{className:"ReverseButton "+(r?r[1]?"playing":"recording":""),onMouseDown:e=>{var r;if(0!==e.button)return;if(t.info)return void(t.info&&(t.info[0].disconnect(),t.info=null,a(null)));null===(r=n.onActivate)||void 0===r||r.call(n);const l=chrome.runtime.connect({name:`REVERSE ${JSON.stringify({tabId:Ut.tabInfo.tabId})}`});t.info=[l,!1],a(t.info),l.onMessage.addListener((e=>{"PLAYING"===e.type&&(t.info=[l,!0],a(t.info))})),l.onDisconnect.addListener((()=>{t.info=null,a(null)})),window.addEventListener("mouseup",(e=>{0===e.button&&t.info&&!t.info[1]&&l.postMessage({type:"PLAY"})}),{once:!0,capture:!0})},children:r?r[1]?(0,Pe.jsx)(V,{size:"1em"}):(0,Pe.jsx)(O,{size:"1em"}):window.gsm.audio.reverse})}var Ht=t(5394),Zt={};Zt.styleTagTransform=ke(),Zt.setAttributes=be(),Zt.insert=ve().bind(null,"head"),Zt.domAPI=me(),Zt.insertStyleElement=xe(),fe()(Ht.Z,Zt),Ht.Z&&Ht.Z.locals&&Ht.Z.locals;var Wt=t(3174).$;function qt(n){var t,r,a,l;const[o,i]=ue({audioFx:!0,audioFxAlt:!0,monoOutput:!0,audioPan:!0}),u=(0,e.useRef)({viaButton:!0}).current;let[s,c]=(0,e.useState)(!1);const d=ce();if(!o)return(0,Pe.jsx)("div",{className:"panel unloaded"});o.audioFxAlt||(s=!1);let f=s?o.audioFxAlt:o.audioFx,p=s?"audioFxAlt":"audioFx";const m=()=>{d||(u.viaButton=!1,chrome.runtime.sendMessage({type:"TAB_CAPTURE",on:!0,tabId:Wt.tabInfo.tabId}))};return(0,Pe.jsxs)("div",{className:"AudioPanel panel",children:[(0,Pe.jsx)("button",{className:"capture "+(d?"active":""),onClick:e=>{u.viaButton=!0,chrome.runtime.sendMessage({type:"TAB_CAPTURE",tabId:Wt.tabInfo.tabId})},children:d?window.gsm.audio.releaseTab:window.gsm.audio.captureTab}),(0,Pe.jsxs)("div",{className:"mainControls",children:[(0,Pe.jsx)("button",{className:"toggle "+(o.audioFxAlt?"active":""),onClick:()=>{i(Xn(o,(e=>{e.audioFxAlt=e.audioFxAlt?null:re()(e.audioFx||{pitch:0,volume:1,delay:0,eq:ee()})})))},children:window.gsm.audio.split}),(0,Pe.jsx)("button",{className:"toggle "+(o.monoOutput?"active":""),onClick:()=>{i(Xn(o,(e=>{e.monoOutput=!e.monoOutput,e.monoOutput&&m()})))},children:window.gsm.audio.mono})]}),o.audioFxAlt?(0,Pe.jsxs)("div",{className:"tabs",children:[(0,Pe.jsx)("button",{className:s?"":"open",onClick:e=>{c(!1)},children:"<< L"}),(0,Pe.jsx)("button",{className:s?"open":"",onClick:e=>{c(!0)},children:"R >>"})]}):null,(0,Pe.jsx)(pt,{label:(0,Pe.jsxs)("div",{children:[(0,Pe.jsx)(A,{size:"17px"}),(0,Pe.jsx)("span",{style:{marginLeft:"10px"},children:window.gsm.command.adjustPitch}),(0,Pe.jsx)("button",{title:"high quality",style:{marginLeft:"10px"},className:"micro toggle "+(f.jungleMode?"":"active"),onClick:e=>{i(Xn(o,(e=>{e[p].jungleMode=!f.jungleMode})))},children:"HD"})]}),value:null!==(t=f.pitch)&&void 0!==t?t:1,sliderMin:-6,sliderMax:6,min:-36,max:36,sliderStep:.1,default:0,onChange:e=>{i(Xn(o,(n=>{n[p].pitch=e}))),0!==e&&m()}}),(0,Pe.jsx)(pt,{label:(0,Pe.jsxs)("div",{children:[(0,Pe.jsx)(V,{size:"17px"}),(0,Pe.jsx)("span",{style:{marginLeft:"10px"},children:window.gsm.command.adjustGain})]}),value:null!==(r=f.volume)&&void 0!==r?r:1,sliderMin:0,sliderMax:3,min:0,default:1,onChange:e=>{i(Xn(o,(n=>{n[p].volume=e}))),1!==e&&m()}}),(0,Pe.jsx)(pt,{label:(0,Pe.jsxs)("div",{children:[(0,Pe.jsx)(N,{size:"17px"}),(0,Pe.jsx)("span",{style:{marginLeft:"10px"},children:window.gsm.command.adjustPan})]}),value:null!==(a=o.audioPan)&&void 0!==a?a:0,sliderMin:-1,sliderMax:1,min:-1,default:0,onChange:e=>{i(Xn(o,(n=>{n.audioPan=e}))),0!==e&&m()}}),(0,Pe.jsx)(pt,{label:(0,Pe.jsxs)("div",{children:[(0,Pe.jsx)(qe,{size:"20px"}),(0,Pe.jsx)("span",{style:{marginLeft:"10px"},children:window.gsm.command.adjustDelay}),(0,Pe.jsx)("button",{title:"merge",style:{marginLeft:"10px"},className:"toggle "+(f.delayMerge?"active":""),onClick:e=>{i(Xn(o,(e=>{e[p].delayMerge=!f.delayMerge})))},children:"+"})]}),value:null!==(l=f.delay)&&void 0!==l?l:0,sliderMin:0,sliderMax:5,min:0,max:179,default:0,onChange:e=>{i(Xn(o,(n=>{n[p].delay=e}))),0!==e&&m()}}),(0,Pe.jsx)(Vt,{onActivate:m}),(0,Pe.jsx)(Rt,{value:f.eq,onChange:e=>{i(Xn(o,(n=>{n[p].eq=e}))),e.enabled&&m()}})]})}function Qt(e){return Qt="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},Qt(e)}function Kt(e,n,t){return(n=function(e){var n=function(e,n){if("object"!==Qt(e)||null===e)return e;var t=e[Symbol.toPrimitive];if(void 0!==t){var r=t.call(e,"string");if("object"!==Qt(r))return r;throw new TypeError("@@toPrimitive must return a primitive value.")}return String(e)}(e);return"symbol"===Qt(n)?n:String(n)}(n))in e?Object.defineProperty(e,n,{value:t,enumerable:!0,configurable:!0,writable:!0}):e[n]=t,e}var Xt=t(3683),Yt={};Yt.styleTagTransform=ke(),Yt.setAttributes=be(),Yt.insert=ve().bind(null,"head"),Yt.domAPI=me(),Yt.insertStyleElement=xe(),fe()(Xt.Z,Yt),Xt.Z&&Xt.Z.locals&&Xt.Z.locals;var Gt=t(3174).$;class Jt extends e.Component{constructor(){super(...arguments),Kt(this,"state",{hasError:!1}),Kt(this,"handleReset",(()=>{var e;oe({override:{},tabId:null===(e=Gt.tabInfo)||void 0===e?void 0:e.tabId,overDefault:!0}),setTimeout((()=>{window.location.reload()}),50)})),Kt(this,"handleRefresh",(()=>{window.location.reload()}))}componentDidCatch(e,n){console.log("ERROR: ",e),console.log("ERROR INFO: ",n),this.setState({hasError:!0})}render(){return this.state.hasError?(0,Pe.jsxs)("div",{className:"ErrorFallback",children:[(0,Pe.jsx)("div",{children:"An error occurred."}),(0,Pe.jsxs)("ol",{children:[(0,Pe.jsxs)("li",{children:["Try refreshing this page.  ",(0,Pe.jsx)("button",{onClick:this.handleRefresh,children:"refresh"})]}),(0,Pe.jsxs)("li",{children:["If that didn't work, click this button to reset the settings. ",(0,Pe.jsx)("button",{onClick:this.handleReset,children:"reset"})]}),(0,Pe.jsx)("li",{children:"As a final resort, try reinstalling the extension."})]})]}):this.props.children}}var er=t(4345),nr={};nr.styleTagTransform=ke(),nr.setAttributes=be(),nr.insert=ve().bind(null,"head"),nr.domAPI=me(),nr.insertStyleElement=xe(),fe()(er.Z,nr),er.Z&&er.Z.locals&&er.Z.locals;var tr=t(745),rr=t(3174).$;function ar(n){const[t,r]=(0,e.useState)(0),[a,l]=ue({superDisable:!0});return function(){const[n,t]=ue({darkTheme:!0});(0,e.useEffect)((()=>{null!=n&&n.darkTheme?document.documentElement.classList.add("darkTheme"):document.documentElement.classList.remove("darkTheme")}),[null==n?void 0:n.darkTheme])}(),a?a.superDisable?(0,Pe.jsx)("div",{id:"SuperDisable",onClick:()=>{oe({override:{superDisable:!1,enabled:!0},tabId:rr.tabInfo.tabId})},onContextMenu:e=>{e.preventDefault(),oe({override:{superDisable:!1,enabled:!0},tabId:rr.tabInfo.tabId})},children:(0,Pe.jsx)(B,{size:"25px"})}):(0,Pe.jsxs)("div",{id:"App",children:[(0,Pe.jsx)(je,{panel:t,setPanel:e=>r(e)}),0===t&&(0,Pe.jsx)(Jn,{}),1===t&&(0,Pe.jsx)(Ft,{}),2===t&&qt&&(0,Pe.jsx)(qt,{})]}):null}Promise.all([new Promise(((e,n)=>{chrome.runtime.sendMessage({type:"REQUEST_GSM"},(t=>{chrome.runtime.lastError?n(chrome.runtime.lastError):e(t)}))})).then((e=>{window.gsm=e})),async function(){let e=await async function(e){let n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:5,t=arguments.length>2&&void 0!==arguments[2]?arguments[2]:100;for(let r=0;r<Math.max(0,null!=n?n:3);r++){r&&await new Promise(((e,n)=>setTimeout((()=>e(!0)),null!=t?t:100)));try{return await Te(e)}catch(e){}}}({active:!0,currentWindow:!0},3,75);if(!e.length)return;const[n]=e;return{tabId:n.id,windowId:n.windowId,url:n.url}}().then((e=>{rr.tabInfo=e,rr.tabInfo||window.close()}))]).then((()=>{(0,tr.s)(document.querySelector("#root")).render((0,Pe.jsx)(Jt,{children:(0,Pe.jsx)(ar,{})}))}))}()}();